//==========================================================
MainProgram: 
  gosub Instructions 
  gosub SetUp
  while true
     clearscr
     XYText 100,100,"Please Wait....","",20,fs_Bold
     flip
     gosub GenerateData
     repeat
        GoSub PlotData
        GoSub WaitForCommand
     until New
     GoSub SelectFunction
  wend
End
//==========================================================
//==========================================================
//==========================================================
SetUp:
  AbortMethod am_Exit
  XLimit = 800 \ YLimit = 600
  rho=30\theta=pi()/4\phi=pi()/4\d=720
  cx=400\cy=300
  data Eye;rho,theta,phi,d,cx,cy
  dT = pi()/10 \ dP = pi()/10
  plot = true
  Flip on
  data Buttons;"Theta <-","Theta ->","Phi ^","Phi v","&New Function"
  data Hints;"Rotate Left","Rotate Right","Rotate Up","Rotate Down","Select a different mesh shape"
  for i=0 to MaxDim(Buttons,1)-1
     AddButton Buttons[i],i*105+1,575,105,24,Hints[i]
  next
  New = false
  CalcZ = "CalcZ1"
Return
//==========================================================
GenerateData:
   dim points[0]
   y = 10
   while y >= -10.0
     ft = true
     x = 10
     while x >= -10
       gosub CalcZ
       data points;x,y,z
       x = x-1
     wend
     data points;"e","e","e"
     y = y-0.5
   Wend
   x = 10
   while x >= -10
     ft = true
     y = 10
     while y >= -10
       gosub CalcZ
       data points;x,y,z
       y = y-0.5
     wend
     data points;"e","e","e"
     x = x-1
   Wend
   NumPoints = MaxDim(points,1)/3
   dim Points[NumPoints,5]
   for i=0 to NumPoints-1
     Points[i,0] = points[i*3]
     Points[i,1] = points[i*3+1]
     Points[i,2] = points[i*3+2]
   next
Return
//==========================================================
CalcZ1:
   z=2*cos(0.05*(x^2-y^2))             // bead sheet
return
//==========================================================
CalcZ2:   
   z = 7/exp(0.1*(x^2+y^2))             //hole mountain
Return
//==========================================================
CalcZ3:   
   A = 2 \ B = 6 \ C = 2
   z = A*sin(x/B)*sin(y/C)           //rollercoaster
Return
//==========================================================
CalcZ4:
   z = 0.1*(x^2-y^2)                 //saddle
Return
//==========================================================
CalcZ5:
   z = 3*sin(x)+cos(y)		//valleys
Return
//==========================================================
CalcZ6:   
   z = -8                            //-
   if x < 5 and x > -5  then z = 5   // |  create a building
   if y > 5   then z = 0             // |
   if y < -5   then z = 0            //-
Return
//==========================================================
PlotData:
     if plot
       xyText 130,300,"Please Wait Generating the Plot","",20,fs_Bold
       flip
       clearscr
       ft = true
       ge3dto2da Points,Eye
       for i=0 to NumPoints-1
           x = Points[i,0] 
           if isstring(x) 
              ft = true
              continue
           endif
           if ft 
             gotoxy Points[i,3],Points[i,4] //sx,sy
             ft = false
           else
             lineto Points[i,3],Points[i,4],1,2   //sx,sy,1,2
           endif
        next
        plot = false
        flip
     endif
Return
//==========================================================
WaitForCommand:
     k=0
     while k=0
       getkeye k
       getbutton btn
       if btn == Buttons[4] then New = true \ plot = true \ return
       readmouse x,y,m
       if m==1 || btn == Buttons[0] then k = kc_LArrow
       if m==2 || btn == Buttons[2] then k = kc_UArrow
       if m==3 || btn == Buttons[1] then k = kc_RArrow
       if m==12 || btn == Buttons[3] then k = kc_DArrow
     wend
     dTheta = 0 \ dPhi = 0
     if k = kc_LArrow then dTheta = -dT
     if k = kc_RArrow then dTheta = dT
     if k = kc_UArrow then dPhi = dP
     if k = kc_DArrow then dPhi = -dP
     if dTheta <> 0 || dPhi <> 0
       plot = true
       Eye[1] = Eye[1]+dTheta
       Eye[2] = Eye[2]+dPhi
     endif
Return
//==========================================================
SelectFunction:
   if !VType(SF_t)
     data Menu;"Please Select a shape function:"
     data Menu;"&1-Sheet   ","&2-Hill    ","&3-Machine "
     data Menu;"&4-Saddle  ","&5-Valleys ","&6-Building"
     SF_t = 1
   endif
   AddButton Menu[0],200,200
   for SF_i = 1 to MaxDim(Menu,1)-1
      AddButton Menu[SF_i],230,225+(SF_i-1)*25,105,25
   next
   repeat
      GetButton btn
      if btn == Menu[0] then btn =""
   until btn != ""
   for SF_i = 1 to MaxDim(Menu,1)-1
      if btn == Menu[SF_i] then break
   next   
   CalcZ = "CalcZ"+SF_i
   for SF_i = 0 to MaxDim(Menu,1)-1
      removeButton Menu[SF_i]
   next   
   New = false
Return
//==========================================================
Instructions:
  data I_M;"Mesh.Bas... Instructions..."
  data I_M;"This program demonstrates the Math and simple 3D-Engine capabilities of"
  data I_M;"RobotBASIC.",""
  data I_M;"Use the buttons to manipulate the view point of the image. You can view the"
  data I_M;"generated plot from various view points. Also you can choose from among "
  data I_M;"different plotting functions that generate quite interesting objects.",""
  data I_M;"This program and many more will be listed and analysed in a book currently"
  data I_M;"in development. The book will teach programming through the medium of computer"
  data I_M;"animation and game programming."
  n = MsgBox(I_M)
Return
//=======================================================
