//---Constants
  DIR_IMGS = ".\images\"

//=========================================================
//=========================================================
MainProgram:
   gosub SetUp
   GoSub Instructions
   while true
      gosub UpdateDisplay
      gosub AnimateBC     
      gosub AnimateSlide
   wend
End
//=========================================================
//=========================================================
SetUp:
  AbortMethod am_Exit
  Flip on
  BC_Frame = 1
  BC_Timer = Timer()
  BC_Time = 0
  data Buttons;"Turn &Back Buffer On","Turn &Back Buffer Off"
  Btn = 1
  Addbutton Buttons[Btn],400,50
Return
//=========================================================
UpdateDisplay:
  readbmp DIR_IMGS+"BC"+BC_Frame,100,100
  rectangle 25,34,285,46,white,white
  line 30,40,280,40,4,blue
  t_rate = BC_Time + 30
  line t_rate,37,t_rate,43,4,red
  xyText 100,10,""+BC_Time+" millisecs/frame   ","",12,fs_Bold
  flip
Return
//=========================================================
AnimateBC:
  if Timer()-BC_Timer < BC_Time then return
  BC_Timer = Timer()
  BC_Frame = BC_Frame#2+1
Return
//=========================================================
AnimateSlide:
    dr = 0
    GetButton btn
    if btn !=""
       RemoveButton Buttons[Btn]
       Btn =!Btn \  Flip Btn
       AddButton Buttons[Btn],400,50
    endif
    if keydown(kc_RArrow) then dr = 1
    if keydown(kc_LArrow) then dr = -1
    BC_Time = Limit(BC_Time +dr,0,250)
    if dr then return
    readmouse x,y,m
    if m==1 && within(x,30,280) && within(y,37,43)
       x=limit(x,30,280)
       BC_Time = x-30
    endif
return
//=========================================================
Instructions:
   data I_M;"Bird_Cage.Bas.....Instructions"
   data I_M;"This program demonstrates an old game we used to play a long time ago, where"
   data I_M;"you had a picture of a bird on one side of a piece of cardboard and a picture of"
   data I_M;"a cage on the other. If you spin the paper by one method or another (say using"
   data I_M;"a pencil) you will start to notice the bird appearing to be inside the cage.",""
   data I_M;"The quality of the illusion depends on the spinning speed. The principle is"
   data I_M;"the well known one of image latency on the retina. Your Rods and Cones require"
   data I_M;"a few milliseconds to clear the effect of chemicals from the previous stimulation"
   data I_M;"and thus if a series of images appear in front of your eyes at a rate faster than"
   data I_M;"this clearing rate the images will seem to blend together.",""
   data I_M;"This program simulates that old game. You can reduce or decrease the spinning rate"
   data I_M;"by using the Left and Right arrow keys to move the slider to the desired number"
   data I_M;"(milliseconds per frame). You can also use the mouse to move the slider by clicking"
   data I_M;"on the slider or keeping the mouse button down while moving the mouse left or right"
   data I_M;"to the desired position.",""
   data I_M;"The number above the slider shows the number of milliseconds between frames. The"
   data I_M;"maximum frame delay rate required for the bird and cage to appear as if they were"
   data I_M;"concurrent rather than separate images will be 40 milliseconds per frame which is"
   data I_M;"1000/40 = 25 frames per second which is a well known number in animation. The movies"
   data I_M;"use around 36 frames per second and computer animation can vary. But 24 FPS is usually"
   data I_M;"good for computer animation.",""
   data I_M;"Another factor that affects computer animation is the use of back buffering, but in"
   data I_M;"this program the use of back buffering only works for the slider animation. For the"
   data I_M;"bird/cage animation the flicker is due to the fact that the images presented to"
   data I_M;"you are one with an empty cage then one with a bird without a cage. So there will"
   data I_M;"always be a little flicker and also you will notice that the faster the spin rate"
   data I_M;"the fainter will be the combined image, since the colors will blend together with"
   data I_M;"the background color to make the overall colors fainter.",""
   data I_M;"True animation would present to you the cage then the bird+cage not the way it is"
   data I_M;"done here; see other programs for true animation. The slider action is a true"
   data I_M;"animation. Try to see the effect of not using Back Buffering by clicking on the"
   data I_M;"button. You will notice an effect on the slider but not on the bird/cage."
   n = MsgBox(I_M)
Return
//=========================================================
