//------Variables
  CX = 400     //Clock's X-position
  CY = 300     //Clock's Y-position
  CR = 160     //Clock's Radius  (no less than 20)
  HTickClr = Red
  MTickClr = Blue
  DIR_IMGS = ".\Images\"
  DIR_SNDS = ".\Wavs\"
//====================================================================
//====================================================================
MainProgram:
  GoSub SetUp
  GoSub Instructions
  while true
    GoSub ShowTime
    GoSub ShowAlarm
    flip
    GoSub CheckAlarm
    delay 100
  wend  
End
//====================================================================
//====================================================================
SetUp:
  AbortMethod am_Exit
  Dim TA[3,4]
  if CR < 20 then CR = 20
  TA[0,0] = CR*0.6 \ TA[1,0] = CR*0.8 \ TA[2,0] = CR*0.9
  flip on
  clearscr
  GoSub DrawClock
  LineWidth 3
  rectangle 5,540,50,570,black,white
  rectangle 53,550,60,560,black,white
  rectangle 65,540,105,570,black,white
  rectangle 125,540,165,570,black,white
  LineWidth 1
  ArrowUp = "RRRaaarrrrrrqqq"
  ArrowDn = "rrrrrraaaqqq"
  DrawShape ArrowUp,106,540,3
  FloodFill 115,543,black
  DrawShape ArrowUp,166,540,3
  FloodFill 175,543,black
  DrawShape ArrowDn,106,560,3
  FloodFill 115,563,black
  DrawShape ArrowDn,166,560,3
  FloodFill 175,563,black

  SaveScr 
  data Buttons;"Alarm &Off"
  AddButton Buttons[0],0,575,0,0,"Turn the alarm on/off"
  A_H = 1 \ A_M = 0 \ A_PM = false \ A_On = false
  T_Timer = 0 \ T_Time = 100
  A_Timer = 0 \ A_Time = 100
  mb = 0
  A_Sound = off \ A_SoundTimer = 0
  A_Duration = 60000 //--1 minute
Return
//====================================================================
ShowTime:
   GoSub GetTime
   TA[0,1] = pi()*(2-hr/6.0+0.5)-pi(2)/12*mins/60.0
   TA[1,1] = pi()*(2-mins/30.0+0.5)   //  -pi(2)/60*secs/60.0
   TA[2,1] = pi()*(2-secs/30.0+0.5)
   for i=0 to 2
     TA[i,2] = TA[i,0]*cos(TA[i,1]) \ TA[i,3] = TA[i,0]*sin(TA[i,1])
   next
   RestoreScr 
   for i = 0 to 2
      gotoxy CX,CY
      lineto CX+TA[i,2],CY-TA[i,3],3-i,i
   next   
   XYText 10,0,Date(0),"Times New Roman",30
   XYText 30,45,Time(0),"Times New Roman",48
Return
//====================================================================
ShowAlarm:
  GetButton btn
  if btn == Buttons[0]
     RemoveButton Buttons[0]
     if !A_On then Buttons[0] = "Alarm &On" 
     if  A_On then Buttons[0] = "Alarm &Off"
     A_On = !A_On
     AddButton Buttons[0],0,575
  endif
  AM_PM = "AM"
  if A_PM then rectangle 53,550,60,560,black,Black \ AM_PM = "PM"
  XYText 12,543,AM_PM,"Time New Roman",15,fs_bold
  XYText 70,543,format(A_H,"00"),"Time New Roman",15,fs_bold
  XYText 130,543,format(A_M,"00"),"Time New Roman",15,fs_bold
  t = A_H
  if t==12 && !A_PM then t=0
  if A_PM && t !=12 then t = Limit(t+12,0,23)
  AlarmTime = format(t,"00:")+Format(A_M,"00:")+"00"
  readmouse x,y,mb
  if mb == 1 && within(y,540,570)
     if within(x,5,60) 
        A_PM = !A_PM
        waitnokey 100
     endif   
     if within(x,108,125) && within(y,540,559) then  A_H = A_H+1
     if within(x,108,125) && within(y,560,579) then  A_H = A_H-1
     if within(x,168,185) && within(y,540,559) then  A_M = A_M+1
     if within(x,168,185) && within(y,560,579) then  A_M = A_M-1
     if A_H < 1 then A_H = 12
     if A_H > 12 then A_H = 1
     if A_M < 0 then A_M = 59
     if A_M > 59 then A_M = 0
     WaitNoKey 100
  endif
Return
//====================================================================
CheckAlarm:
  if AlarmTime == time(1) then A_Sound = on \ A_SoundTimer = timer()
  if A_On && A_Sound && timer()-A_SoundTimer < A_Duration
     if !WavBusy() then PlayWav DIR_SNDS+"Alarm"
  else
     A_Sound = off
  endif
return
//====================================================================
GetTime:
  tm = Time(1)
  hhour = tonumber(left(tm,2))
  hr = hhour # 12                    
  secs = tonumber(right(tm,2))       
  mins = tonumber(substring(tm,4,2)) 
Return
//====================================================================
DrawClock:
  linewidth 3
  R = CR+5
  circle CX-R,CY-R,CX+R,CY+R,black
  LineWidth 1
  R1= R-3
  for i=0 to 360 step 6    //minutes ticks
    gotoxy CX,CY
    A  = i*pi()/180
    Lineto CX+R1*cos(A),CY-R1*sin(A),2,MTickClr
  next
  circle CX+6-R,CY+6-R,CX-6+R,CY-6+R,white,white
  for i=0 to 360 step 30  //hours ticks
    gotoxy CX,CY
    A  = i*pi()/180
    lineto CX+R1*cos(A), CY-R1*sin(A),4,HTickClr
  next
  circle CX+10-R,CY+10-R,CX-10+R,CY-10+R,white,white
  circle CX-5,CY-5,CX+5,CY+5,black,black  //hands circle
  Linewidth 1
Return
//====================================================================
Instructions:
   data I_M;"Clock.Bas... Instructions..."
   data I_M;"Besides demonstrating many graphics and Math capabailities, this"
   data I_M;"program can be useful as an alarm clock.",""
   data I_M;"Set the desired alarm time and press the button to turn the alarm on."
   data I_M;"To turn the alram off press the button again. The label on the button"
   data I_M;"indicates the current status of the alarm (on/off)."
   n= MsgBox(I_M)
Return
//====================================================================
