//------Variables
  CX = 400     //Clock's X-position
  CY = 300     //Clock's Y-position
  CR = 260     //Clock's Radius  (no less than 20)
  HTickClr = Red \  MTickClr = Blue
  DIR_IMGS = ".\Images\"   \  DIR_SNDS = ".\Wavs\"
//====================================================================
//====================================================================
MainProgram:
  GoSub SetUp
  GoSub Instructions
  while true
  wend  
End
//====================================================================
//====================================================================
SetUp:
  Dim TA[3,4]
  if CR < 20 then CR = 20
  TA[0,0] = CR*0.75 \ TA[1,0] = CR*0.85 \ TA[2,0] = CR*0.95
  flip on \  clearscr \ GoSub DrawClock \ SaveScr 
  AddEdit "Time",CX+30,CY-12,120 \ AddEdit "Date",CX-150,CY-12,120
  SetEDitFont "Time","Times New Roman",15,fs_Bold
  SetEDitFont "Date","Times New Roman",15,fs_Bold
  xyText 650,20,"Set Alram","Times New Roman",15,fs_Bold
  addEdit "AH",650,50,25,0,"01" \ addspinner "AH",675,48,0,0,1,12
  addEdit "AM",700,50,25,0,"00" \ addspinner "AM",725,48,0,0,0,59
  setspinnerwrap "AH" \ setSpinnerwrap "AM"
  SetEditMask "AH","99;1;0" \ SetEditMask "AM","99;1;0"
  AddCheckBox "AM",750,50,"",1 \ AddCheckBox "Alarm On",660,90,"",0
  AddTimer "t1",200
  A_Sound = off \ A_SoundTimer = 0 \ A_Duration = 60000 //--1 minute
  onTimer tHandler \  onSpinner sHandler \ onEdit eHandler
Return
//====================================================================
tHandler:
    lt = LastTimer()
    GoSub ShowTime
    flip
    GoSub CheckAlarm
    onTimer tHandler
Return
//====================================================================
sHandler:
    ls = LastSpinner()
    setEdit ls,format(getSpinner(ls),"00")
    onSpinner sHandler
Return
//====================================================================
eHandler:
   le = LastEdit()
   if le !="Time" && le != "Date"
     SetSpinner le,ToNumber(getEditUnMasked(le),0)
     setEdit le,format(getSpinner(le),"00")
   endif
   onEdit eHandler
Return
//====================================================================
ShowTime:
   tm = Now()
   hr = hour(tm) \ secs = second(tm) \  mins = minute(tm)
   TA[0,1] = pi()*(2-hr/6.0+0.5)-pi(2)/12*mins/60.0
   TA[1,1] = pi()*(2-mins/30.0+0.5)   //  -pi(2)/60*secs/60.0
   TA[2,1] = pi()*(2-secs/30.0+0.5)
   for i=0 to 2
     TA[i,2] = TA[i,0]*cos(TA[i,1]) \ TA[i,3] = TA[i,0]*sin(TA[i,1])
   next
   RestoreScr 
   SetEdit "Time",DateTime(Now(),"hh:mm:ss AM/PM")
   SetEdit "Date",DateTime(Now(),"ddd. mmm. d")
   for i = 0 to 2
      line CX,CY,CX+TA[i,2],CY-TA[i,3],8-i*3,i
   next   
Return
//====================================================================
CheckAlarm:
  AlarmTime = GetEditUnMasked("AH")+":"+GetEditUnMasked("AM")+":00"
  if GetCheckBox("AM")
      AlarmTime = "AM "+AlarmTime
  else    
      AlarmTime = "PM "+AlarmTime
  endif
  if AlarmTime == time(0) then A_Sound = on \ A_SoundTimer = timer()
  if GetCheckBox("Alarm On") && A_Sound && timer()-A_SoundTimer < A_Duration
     if !WavBusy() then PlayWav DIR_SNDS+"Alarm"
  else
     A_Sound = off
  endif
return
//====================================================================
DrawClock:
  linewidth 3
  R = CR+5
  circle CX-R,CY-R,CX+R,CY+R,black
  LineWidth 1
  R1= R-3
  for i=0 to 360 step 6    //minutes ticks
    gotoxy CX,CY
    A  = i*pi()/180
    Lineto CX+R1*cos(A),CY-R1*sin(A),2,MTickClr
  next
  circle CX+6-R,CY+6-R,CX-6+R,CY-6+R,white,white
  for i=0 to 360 step 30  //hours ticks
    gotoxy CX,CY
    A  = i*pi()/180
    lineto CX+R1*cos(A), CY-R1*sin(A),4,HTickClr
  next
  circle CX+10-R,CY+10-R,CX-10+R,CY-10+R,white,white
  circleWH CX-10,CY-10,20,20,black,black  //hands circle
  circleWH CX-5,CY-5,10,10,blue,blue  //hands circle
  Linewidth 1
Return
//====================================================================
Instructions:
   data I_M;ProgName()+"... Instructions..."
   data I_M;"Besides demonstrating many graphics and Math capabailities, this"
   data I_M;"program can be useful as an alarm clock.",""
   data I_M;"Set the desired alarm time and check the box to turn the alarm on."
   data I_M;"To turn the alram off check the box again. "
   n= MsgBox(I_M)
Return
//====================================================================
