MainProgram:
  gosub Initialize
  while !Quit
     gosub MonitorInputs
  wend
Exit
//==========================================================
Initialize:
  clearscr darkgray
  Rectangle 2,2,400,400
  Rectangle 402,2,799,400
  OrgFile = ""  \ fn = "IPD_file"
  Quit = false \ LastSaved = false
  BrushClr = 2 \ BrushShape = 3
  BrushAreaClr = 4737168
  RectangleWH 550,540,500,500,0,BrushAreaClr
  UpArrow = "lwsl" \ DnArrow = "lswl" \ LtArrow = "uasu" \ RtArrow = "usau"
  Font = "Times New Roman"
  gosub CreateButtonsAndEdits
  GoSub DrawBrushArea
  data IM;"Image_Processing.Bas"
  data IM;" This demo allows you to experiment with the various image manipulation routines"
  data IM;" available in RobotBASIC. Once you have loaded an image you can try the various "
  data IM;" buttons. Each operation will work on the result of the previous one and the "
  data IM;" result is always shown on the righ image area. If you wish to start from the "
  data IM;" original image again then push the Reset button. You can also undo the Last "
  data IM;" operation's action.",""
  data IM;" Most operations have parameters (next to or below the button) that affect how"
  data IM;" the command behaves. You can specify the parameters by clicking on the spinner"
  data IM;" controls to increment or decrement the number by a small amount for the vertical"
  data IM;" spinner control, or a big amount for the horizontal spinners. You can also click"
  data IM;" inside the edit boxes then enter an amount. Each amount will have an allowable "
  data IM;" upper and lower limit. If you type in an amount that exceeds the allowable limits"
  data IM;" then the next time the amount is needed it will be set to the closest limit. Also"
  data IM;" if you type non-numbers the value will be set to the lower limit.",""
  data IM;" You can draw on the image on the right by clicking the mouse and moving it. You"
  data IM;" can choose a brush color and shape by clicking on the various colors and shapes."
  data IM;" You can also choose a brush size(min 2 max 50). You can also select a color other"
  data IM;" than the standard 16 colors by clicking the RIGHT mouse button inside either of"
  data IM;" the images, which sets the brush color to the pixel color you have chosen from"
  data IM;" either image. You can also create a color by clicking inside the square on the"
  data IM;" bottom right area of the brush work area. This allows you to create a color for"
  data IM;" the brush. Also if you right-click on the square at the bottom right corner you"
  data IM;" will see the R-G-B values for the color in the box.",""
  data IM;" The Reduce Resolution button reduces the resolution of the picture on the right"
  data IM;" by a factor (min 2 max 80) indicated by the number next to the button.",""
  data IM;" The Find Brush Color will search the picture on the right for the current brush"
  data IM;" color as indicated on the colors grid with a tolerance (min 0% max 99%). Draw on"
  data IM;" the picture then use this button to search for the color. The picture will be"
  data IM;" divided into a 10x10 grid and the grids found to have the color will be outlined"
  data IM;" with a thin box. The ones that have the maximum density of the color will have a"
  data IM;" thick outline."
  AbortMethod am_Flag
return
//==========================================================
CreateButtonsAndEdits:
  if !vType(butY) //make sure database is only created once
     butY = 440 \ butW = 80

     //create buttons database
     data ButNames;"Contrast","Bright","Red","Green","Blue"
     for i=0 to 4
       data Buttons;ButNames[i]+" Up",10+i*butW,butY,butW
       data Buttons;ButNames[i]+" Dn",10+i*butW,butY+25,butW
     next  
     data Buttons;"Rot. Left",10+i*butW,butY,butW
     data Buttons;"Rot. Right",10+i*butW,butY+25,butW
     data ButNames2;"To Gray","Negative","Flip","Mirror"
     For i=0 to 3
       data Buttons;ButNames2[i],500+i*70,butY,70
     Next
     data Buttons;"To B&&W",500,butY+25,70
     data Buttons;"Edges",650,butY+25,70
     data Buttons;"Load Image From File",60,405,140
     data Buttons;"Compare To=>",200,405,100
     data Buttons;"Reset",420,405,70
     data Buttons;"Undo Last Op.",490,405,100
     data Buttons;"Save To File",590,405,100
     data Buttons;"Load From File",690,405,100
     data Buttons;"Reduce Resolution",250,butY+100,130
     data Buttons;"Find Brush Color",580,butY+70,130
     data Buttons;"Get The Image's Color Statistics",250,butY+130,200
     data Buttons;"Quit",1,574,75
     data Buttons;"Instructions",76,574,100
     Dim buttons[MaxDim(Buttons,1)/4,4]
     mCopy Buttons,buttons

     //Create editboxes database
     //name,x,y,W,value,changed,min,max,format
     data Edits;"BrushSize",670,573,30,4,0,2,80,"00"
     data Edits;"Reduction Ratio",380,butY+100,30,10,0,2,80,"00"
     data Edits;"Color Tolerance",710,butY+70,40,10,0,0,99,"00%"
     data tEdits;"Contrast","Brightness","Red","Green","Blue","Rotate"
     for i=0 to 4
        data Edits;tEdits[i],15+butW*i,butY+55,40,10,0,0,99,"00%"
     next   
     data Edits;tEdits[i],15+i*butW,butY+55,40,90,0,0,360,"#00" 
     data Edits;"Compar Tol",300,405,40,10,0,0,99,"00%"
     data Edits;"BW Threshold",500+70,butY+25,40,128,0,1,254,"##0"
     data Edits;"Edges Threshold",650+70,butY+25,40,128,0,1,254,"##0"
     data Edits;"Contrast Threshold",15,butY+85,40,128,0,1,254,"##0"
     Dim edits[MaxDim(Edits,1)/9,9]
     mCopy Edits,edits

     //create Spinners database
     //editbox#,incr,dx,dy,type (0=vertical, 1=horizontal)
     data Spinners;0,2,40,11,0  //brush size vertical
     data Spinners;0,10,55,11,1  //brush size horizontal
     data Spinners;1,1,40,11,0 //reduction ratio vertical
     data Spinners;1,10,55,11,1 //reduction ratio horizontal
     data Spinners;2,1,50,11,0 //color tolerance vertical
     data Spinners;2,10,65,11,1 //color tolerance horizontal
     for i=3 to 7
        data Spinners;i,1,50,11,0 //cont/bri/red/gr/bl  vertical
        data Spinners;i,10,65,11,1 //cont/bri/red/gr/bl horizontal
     next   
     data Spinners;i,90,50,11,0 //rotate  vertical
     data Spinners;9,1,50,11,0 //compare tol% vertical
     data Spinners;9,10,65,11,1 //compare tol% horizontal
     for i=10 to 12
        data Spinners;i,1,50,11,0 //contr/bw/edg Threshold  vertical
        data Spinners;i,20,65,11,1 //contr/bw/edg Threshold  horizontal
     next   
     Dim spinners[MaxDim(Spinners,1)/5,5]
     mCopy Spinners, spinners
     
     //Define positions of needed variables
     BrushSize = 0 \ ReductRatio = 1 \ ClrTol  = 2 
     ContrastL = 3 \ BrightnessL = 4 \ RedL = 5 \ GreenL = 6 \ BlueL = 7 \ RotL = 8
     CompTol = 9 \ ContrTh = 12 \ BWTh = 10\ EdgeTh = 11
  endif
  for i=0 to MaxDim(buttons,1)-1  //create buttons
     Addbutton buttons[i,0],buttons[i,1],buttons[i,2],buttons[i,3]
  next
  for i=0 to MaxDim(edits,1)-1  //create edit boxes 
     AddEdit edits[i,0],edits[i,1],edits[i,2],edits[i,3],22,Format(edits[i,4],edits[i,8])," "
  next   
  EnableEdit edits[RotL,0],false
  for i=0 to MaxDim(spinners,1)-1  //draw spinners
     X = edits[spinners[i,0],1]+spinners[i,2] \ Y = edits[spinners[i,0],2]+spinners[i,3]
     if spinners[i,4] == 0 //up/Dn
        DrawShape UpArrow,X,Y-1,7 \  DrawShape DnArrow,X,Y+1,7
        FloodFill X,Y-3 \ FloodFill X,Y+3
     else //Lft/Rt
        DrawShape LtArrow,X-1,Y,7 \  DrawShape RtArrow,X+1,Y,7
        FloodFill X-3,Y \ FloodFill X+3,Y
     endif
  next    
return  
//==========================================================
MonitorInputs:
  if AbortFlag() then Quit = true \ return
  GetButton butn
  if butn == "" 
      GoSub CheckMouse \ return
  elseif butn == buttons[18,0]  //load
      tf = PromptBMP()
      if tf != "" 
         OrgFile = tf
         FitBMP OrgFile,3,3,397,397
         CbFitBMP OrgFile,397,397
         ScrFromCb 403,3
         GoSub SaveForUndo
      endif   
      return
  elseif butn == buttons[27,0] //quit
      Quit = true  \ return  
  elseif butn == buttons[28,0] //instructions
      n = MsgBox(IM) \ return
  elseif OrgFile == "" //don't allow any other butons if no image
      n = ErrMsg("Must Select a file first",IM[0],MB_OK|MB_ERROR)
      return
  endif
  GoSub UpdateEdits
  if butn == buttons[25,0] //findcolor
      gosub FindColor \ return
  elseif butn == buttons[26,0] //statistics
      gosub DisplayStats \ return    
  endif
  GoSub DisplayWait
  if butn != buttons[21,0] //save for undoing unless undoing
      GoSub SaveForUndo \ LastSaved = false
  endif   
  if butn == buttons[0,0]
      BmpContrast "",edits[ContrastL,4]/100.0,edits[ContrTh,4]
  elseif butn == buttons[1,0]
      BmpContrast "",-edits[ContrastL,4]/100.0,edits[ContrTh,4]
  elseif butn == buttons[2,0]
      bri = edits[BrightnessL,4]/100.0
      BmpRGB "",bri,bri,bri
  elseif butn == buttons[3,0]
      bri = -edits[BrightnessL,4]/100.0
      BmpRGB "",bri,bri,bri
  elseif butn == buttons[4,0]
      BmpRGB "",edits[RedL,4]/100.0,0,0
  elseif butn == buttons[5,0]
      BmpRGB "",-edits[RedL,4]/100.0,0,0
  elseif butn == buttons[6,0]
      BmpRGB "",0,edits[GreenL,4]/100.0,0
  elseif butn == buttons[7,0]
      BmpRGB "",0,-edits[GreenL,4]/100.0,0
  elseif butn == buttons[8,0]
      BmpRGB "",0,0,edits[BlueL,4]/100.0
  elseif butn == buttons[9,0]
      BmpRGB "",0,0,-edits[BlueL,4]/100.0
  elseif butn == buttons[10,0]
      RotateCB edits[RotL,4]
  elseif butn == buttons[11,0]
      RotateCB -edits[RotL,4]
  elseif butn == buttons[12,0]
      BmpToGray ""
  elseif butn == buttons[13,0]
      BmpNegative ""
  elseif butn == buttons[14,0]
      FlipCB
  elseif butn == buttons[15,0]
      MirrorCB
  elseif butn == buttons[16,0]
      BmpToBW "",edits[BWTh,4]
  elseif butn == buttons[17,0]
      BmpEdges "",edits[EdgeTh,4]
  elseif butn == buttons[19,0]  //compare
      WriteBMP "tt",3,3,397,397
      CbToBmp "ttt"
      BmpCompare "tt","ttt","",edits[CompTol,4]/100.0
      n= FilDelete("tt.bmp") \ n= FilDelete("ttt.bmp")
  elseif butn == buttons[20,0]  //reset
      ScrToCb 3,3,397,397
  elseif butn == buttons[21,0]  //undo
      Flip on \ ScrToCb 0,0,397,397  \ Flip off 
  elseif butn == buttons[22,0]  //save
      tf = FileSave(fn+".bmp")
      if tf != ""
         fn = FilChangeExt(tf,"")
         Flip on \ WriteBMP fn,0,0,397,397 \ flip off
      endif
  elseif butn == buttons[24,0]  //reduce Resolution
      n = 400/edits[ReductRatio,4]
      ResizeBMP "",n,n,"tt"
      CbFitBmp "tt",397,397
      n=FilDelete("tt.bmp")
  elseif butn == buttons[23,0] //load right image from file    
      tf = PromptBMP()
      if tf != "" then CbFitBMP tf,397,397
  endif
  ScrFromCb 403,3
return
//==========================================================
DisplayWait:
  SetColor Black
  tt = "WORKING" \ ttt = "Please Wait..."
  OverlayText 450+3,100+3,tt,Font,30,fs_Bold
  OverlayText 460+3,145+3,ttt,Font,20,fs_Bold
  SetColor Red
  OverlayText 450,100,tt,Font,30,fs_Bold
  OverlayText 460,145,ttt,Font,20,fs_Bold
  SetColor black
Return
//==========================================================
SaveForUndo:
  flip on \ scrfromcb \ flip off
  LastSaved = true
Return
//==========================================================
CheckMouse:
  readmouse x,y,mb
  if mb then GoSub UpdateEdits
  if !mb 
     GoSub CheckEdits
  elseif mb==1
     for i=0 to MaxDim(spinners,1)-1
        n=spinners[i,0]
        lx = edits[n,1]+spinners[i,2] \ ly = edits[n,2]+spinners[i,3]
        Incr = 0
        if spinners[i,4]==0  //up/Dn
           if within(x,lx-7,lx+7) && within(y,ly-8,ly-1) //up
              Incr = spinners[i,1]
           elseif within(x,lx-7,lx+7) && within(y,ly+1,ly+8)  //down
              Incr = -spinners[i,1]
           endif
        else  //Lft/Rt
           if within(x,lx-8,lx-1) && within(y,ly-7,ly+7) //left
              Incr = -spinners[i,1]
           elseif within(x,lx+1,lx+8) && within(y,ly-7,ly+7)  //right
              Incr = spinners[i,1]
           endif
        endif
        if Incr
           edits[n,4] = Limit(edits[n,4]+Incr,edits[n,6],edits[n,7]) 
           SetEdit edits[n,0],Format(edits[n,4],edits[n,8]) 
           WaitNoKey 150
           n = EditChanged(edits[n,0])
           return
        endif   
     next
     n = edits[BrushSize,4]/2 \ nn = edits[BrushSize,4]
     if within(x,560,560+15*16) && within(y,550,550+15)  //brushcolor
        BrushClr = (x-560)/15
        GoSub DrawBrushArea
        WaitNoKey
     elseif within(x,770,790) && within(y,570,590)
        BrushClr = PromptColor(ConsToClr(BrushClr))
        GoSub DrawBrushArea
        WaitNoKey   
     elseif within(x,560,560+20*4) && within(y,580,580+15) //brushshape
        BrushShape = (x-560)/20
        GoSub DrawBrushArea
        WaitNoKey
     elseif within(x,404+n,798-n) && within(y,4+n,398-n)   //draw
        if !LastSaved
           GoSub SaveForUndo
        endif
        LineWidth  2
        if BrushShape == 0 then eRectangleWH x-n,y-n,nn,nn,2,BrushClr
        if BrushShape == 1 then RectangleWH x-n,y-n,nn,nn,BrushClr,BrushClr
        if BrushShape == 2 then Arc x-n,y-n,x+n,y+n,0,0,2,BrushClr
        if BrushShape == 3 then CircleWH x-n,y-n,nn,nn,BrushClr,BrushClr
        LineWidth 1
        ScrToCb 403,3,397,397
     endif
  elseif mb==2 && (within(x,403,798) || within(x,03,399))&& within(y,3,398) 
     ReadPixel x,y,BrushClr
     GoSub DrawBrushArea
     WaitNoKey   
  elseif mb==2 && within(x,772,788) && within(y,572,588)
     ReadPixel x,y,cc
     R=RedValue(cc) \G =GreenValue(cc) \ B =BlueValue(cc)
     s = "R="+R+" ---G="+G+" ---B="+B+char(13)
     s = s+"RGB("+R+","+G+","+B+") = "+RGB(R,G,B)
     cc = ErrMsg(s,IM[0],MB_OK|MB_Information)
  endif
Return
//==========================================================
DrawBrushArea:
  RectangleWH 550,540,500,30,0,BrushAreaClr
  RectangleWH 553,572,100,28,BrushAreaClr,BrushAreaClr
  Rectangle 765,572,799,599,BrushAreaClr,BrushAreaClr
  for i=0 to 15
     rectanglewh 560+i*15,547,15,15,0,i
  next
  tc = black
  If BrushClr == Black then tc = white
  RectangleWH 770,575,20,20,0,BrushClr
  eRectangleWH 560,580,15,15,2,BrushClr
  Arc 560+40,580,560+40+15,580+15,0,0,2,BrushClr
  LineWidth 2
  RectangleWH  560+20,580,15,15,BrushClr,BrushClr
  CircleWH 560+60,580,15,15,BrushClr,BrushClr
  LineWidth 1
  eRectangleWH 560+BrushShape*20-3,580-3,20,20,1,tc
  if BrushClr < 16
     eRectangleWH 560+BrushClr*15-1,547-1,17,17,3,tc
  else
     eRectangleWH 770-2,575-2,24,24,3,tc     
  endif   

Return
//==========================================================
FindColor:
 GridSize = 10 \ w = 397/GridSize \ h = 397/GridSize
 bmpfindclr "",BrushClr,t,n,edits[ClrTol,4]/100.0,0.1,GridSize,FoundSectors
 if t >= 0
    c = white
    if BrushClr >= Yellow then c=red
 else   
    n = ErrMsg("The color was not found...",IM[0],MB_OK|MB_Information) 
    return
 endif
 SaveScr
 MaxDen = 0
 for x=0 to 9
   for y = 0 to 9
      if FoundSectors[y,x] > MaxDen then MaxDen = FoundSectors[y,x]
   next
 next  
 for x=0 to 9
   for y = 0 to 9
      LW = 1
      if FoundSectors[y,x] > 0
         if FoundSectors[y,x] == MaxDen then LW = 4      
         eRectanglewh 403+x*w,3+y*h,w+1,h+1,LW,c
      endif
   next
 next  
 Rectangle 25+3,25+3,370+3,190+3,white,black
 Rectangle 25,25,370,190,black,white
 xyText 35,30,"The sectors containing the color with the maximum",Font,12
 xyText 35,48,"density are indicated with thick squares. Other",Font,12
 xyText 35,66,"sectors containing the color are indicated with",Font,12
 xyText 35,84,"thin squares.",Font,12
 xyText 35,115,"      Press The Ok button to proceed...",Font,12
 Addbutton "OK",180,155,50
 FocusButton "OK"
 while true
    GetButton bt
    if bt == "OK" then RemoveButton "OK" \ break
    delay 200
 wend
 RestoreScr
return
//==========================================================
CheckEdits:
   For i=0 to MaxDim(edits,1)-1
     s = edits[i,0]
     if EditChanged(s)
         n = GetEdit(s) \ j = InString(n,"%")
         if j then n = left(n,j-1) 
         n = ToNumber(n)
         if !IsNumber(n)
           n = edits[i,6]
           SetEdit s,ToString(n)
           FocusEdit "" \ FocusEdit s
         endif
         edits[i,4] = n \ edits[i,5] = true
     endif
   Next
Return
//==========================================================
UpdateEdits:
   for i=0 to MaxDim(edits,1)-1
      if !edits[i,5] then continue
      n = Limit(edits[i,4],edits[i,6],edits[i,7])
      edits[i,4] = n
      SetEdit edits[i,0],Format(n,edits[i,8])
      edits[i,5] = false
      n = EditChanged(edits[i,0]) //force no change
   next      
Return
//==========================================================
DisplayStats:
   saveScr
   GoSub DisplayWait
   BMPStats Stats
   RestoreScr
   Rectangle 50+3,50+3,350+3,230+3,white,black
   rectangle 50,50,350,230,Black,white
   fmat = "##0.0000000"
   xyString 60,60,  "Average     = ", Format(Stats[3],fmat)
   xyString 60,75,  "  Ave Red   = ", Format(Stats[0],fmat)
   xyString 60,90,  "  Ave Green = ", Format(Stats[1],fmat)
   xyString 60,105, "  Ave Blue  = ", Format(Stats[2],fmat)
   xyString 60,130, "StdDev      = ", Format(Stats[7],fmat)
   xyString 60,145, "  SD Red    = ", Format(Stats[4],fmat)
   xyString 60,160, "  SD Green  = ", Format(Stats[5],fmat)
   xyString 60,175, "  SD Blue   = ", Format(Stats[6],fmat)
   Addbutton "OK",180,200,50
   FocusButton "OK"
   while true
     GetButton bt
     if bt == "OK" then RemoveButton "OK" \ break
     delay 200
   wend
   restorescr   
Return
//==========================================================
