MainProgram:
    GoSub Initialize
    while true
	GoSub CheckInputs
	GoSub CheckDrawing
    wend
end
//=============================================================
Initialize:
   B_y = 555
   rectangle 0,B_y,800,600,DarkGray,DarkGray
   line 0,B_y+1,800,B_y,2,0
   line 1,B_y+1,1,600,2,0
   line 0,600,800,600,2,gray
   line 799,B_y+1,799,600,2,gray
   data Buttons;"&Text","Type a text to be printed on the canvas"
   data Buttons;"&Fill","Fill an area with the pen color"
   data Buttons;"&Undo","Undo the last operation"
   data Buttons;"&Clear","Clear the canvas"
   data Buttons;"&Save","Save the canvas to a file"
   data Buttons;"&Load","Load the canvas from a file"
   data Buttons;"&Print","Print the screen"
   data Buttons;"&Instructions","View the instructions"
   for i=0 to maxdim(Buttons,1)-1 step 2
     addbutton Buttons[i],5+75*i/2,573,75,23,Buttons[i+1]
   next
   A_x=785 \ A_y=585
   xyText A_x-130,A_y-25,"Shape  Color  Size","",8,fs_Bold
   Size = "Size"
   Addedit Size,A_x-40,A_y-10,30,0,"2","Size of the brush"
   data Arrows;"lwsl","usau","lswl","uasu"
   drawshape Arrows[0],A_x,A_y-1,7
   floodfill A_x,A_y-3,Black
   drawshape Arrows[2],A_x,A_y+1,7
   floodfill A_x,A_y+3,Black
   data Brushes;"waa","sqq","rll","udd","uddurll","qssqwaa","uddulrrlqssqwaa"
   MaxBrushes = MaxDim(Brushes,1)-1
   BrushSize = 2
   BrushColor = 0
   BrushShape = MaxBrushes+1
   C_x = 710 \ C_y = 577
   rectanglewh C_x,C_y,20,20,black,BrushColor
   S_x = 670 \ S_y = 577
   rectanglewh S_x,S_y,20,20,white,white
   circlewh S_x+9,S_y+9,2,2,black,black
   ss = false
   setcolor black,white
Return
//=============================================================
CheckDrawing:
   ReadMouse x,y,mb
   if y > B_y then return
   if mb == 1 then GoSub SaveForUndo
   if mb == 2
      BrushColor = PixelClr(x,y)
      rectanglewh C_x,C_y,20,20,Black,BrushColor      
   endif
   while mb = 1
      Readmouse x,y,mb
      y = limit(y,0,B_y)
      if y > B_y-1-BrushSize then SaveScr 0,B_y,800,600 \ ss =true
      if BrushShape == MaxBrushes+1
         LineTo x,y,BrushSize,BrushColor
      elseif BrushShape > MaxBrushes+1
         n=Limit(BrushSize,2,100) \ temp = BrushShape-MaxBrushes
         if temp == 2 then circlewh x-n/2,y-n/2,n,n,BrushColor,BrushColor
         if temp == 3 then rectanglewh x-n/2,y-n/2,n,n,BrushColor,BrushColor
         if temp == 4 then arc x-n/2,y-n/2,x+n/2,y+n/2,0,0,1,BrushColor
         if temp == 5 then erectanglewh x-n/2,y-n/2,n,n,1,BrushColor
      else
        setcolor BrushColor
        DrawShape Brushes[BrushShape],x,y,BrushSize
        SetColor black
      endif
      if ss then ss = false \ RestoreScr 0,B_y
   wend
   GotoXY x,y   
Return
//=============================================================
CheckInputs:
   If EditChanged(Size) 
     n = ToNumber(GetEdit(Size))
     if !IsNumber(n) then n=1
     n = Limit(n,1,100)
     BrushSize = n
   endif
   If !EditHasFocus(Size) && GetEdit(Size) != ToString(BrushSize)
      SetEdit Size,BrushSize \ n = EditChanged(Size)
   endif   
   GetButton btn
   if btn != ""
     if btn == Buttons[0]   then GoSub SaveForUndo \ GoSub DoText
     if btn == Buttons[1*2] then GoSub SaveForUndo \ GoSub DoFill
     if btn == Buttons[2*2] then FitCB 0,0,800,B_y
     if btn == Buttons[3*2] then GoSub SaveForUndo\savescr 0,B_y,800,600 \ clearscr \ restorescr 0,B_y
     if btn == Buttons[7*2] then GoSub Instructions
     if btn == Buttons[4*2] 
         n = FileSave()
         if n != "" then WriteBMP FilChangeExt(n,""),0,0,800,B_y
         waitnokey
     elseif btn == Buttons[5*2] 
         n = PromptBMP()
         if n != "" then GoSub SaveForUndo \FitBMP n,0,0,800,B_y
         waitnokey
     endif
     if btn == Buttons[6*2] then PrintScr     
   endif
   ReadMouse x,y,mb
   if y > B_y && x > S_x && mb == 1
      if within(x,S_x,S_x+20) && within(y,S_y,S_y+20) then GoSub GetBrushShape
      if within(x,C_x,C_x+20) && within(y,C_y,C_y+20) 
         BrushColor = PromptColor(ConsToClr(BrushColor))
         rectanglewh C_x,C_y,20,20,Black,BrushColor
      endif
      if within(x,A_x-7,A_x+7) && within(y,A_y-8,A_y-1)
          BrushSize = Limit(BrushSize+1,1,100)\SetEdit Size,BrushSize \ n=EditChanged(Size)
          delay 150
      endif       
      if within(x,A_x-7,A_x+7) && within(y,A_y+8,A_y+1)
          BrushSize = Limit(BrushSize-1,1,100)\SetEdit Size,BrushSize \ n=EditChanged(Size)
          delay 150
      endif       
   endif
Return
//=============================================================
GetBrushShape:
    SaveScr 100,100,700,550
    RectangleWH 200,150,402,352,Black,Black
    RectangleWH 201,151,400,350,DarkGray,White
    T_x = 220
    for i=0 to MaxBrushes
       drawshape Brushes[i],T_x+40*i,210,10
    next
    circlewh T_x+18,318,4,4,black,black
    circlewh T_x+50,300,40,40,black,black
    rectanglewh T_x+100,300,40,40,black,black
    circlewh T_x+150,300,40,40,black
    rectanglewh T_x+200,300,40,40,black
    xytext T_x+10,450,"Select a brush shape by clicking on it","",0,fs_Bold
    repeat
       ReadMouse x,y,mb
       temp = false
       if mb == 1
          if within(y,200,220) && within(x,T_x-10,T_x+30+40*MaxBrushes)
             BrushShape = (x-T_x+10)/40
             temp = true
          elseif within(y,300,340)&& within(x,T_x,T_x+250)
             BrushShape = MaxBrushes+1+(x-T_x)/50
             temp = true
          endif
       endif
       if temp
          rectanglewh S_x,S_y,20,20,white,white
          if BrushShape <= MaxBrushes
             Drawshape Brushes[BrushShape],S_x+10,S_y+10,5
          else
            temp= BrushShape-MaxBrushes
            n = 10 \ nn=5
            if temp == 1 then circlewh S_x+8,S_y+8,2,2,black,black
            if temp == 2 then circlewh S_x+nn,S_y+nn,n,n,black,black
            if temp == 3 then rectanglewh S_x+nn,S_y+nn,n,n,black,black
            if temp == 4 then circlewh S_x+nn,S_y+nn,n,n,black
            if temp == 5 then rectanglewh S_x+nn,S_y+nn,n,n,black
          endif
          waitnokey
          break
       endif
    until false
    RestoreScr 100,100
Return
//=============================================================
DoFill:
   SaveScr 0,B_y,800,600
   xyText 3,B_y+2,"Click inside the area you want to fill...or right click to cancel","Times NEw Roman",8
   SetCursor cr_Cross
   repeat
      readmouse x,y,mb
      y = Limit(y,0,B_y)
      if mb == 1
         FloodFill x,y,BrushColor
      endif
   until mb
   waitnokey
   SetCursor 0
   RestoreScr 0,B_y 
Return
//=============================================================
SaveForUndo:
    ScrToCB 0,0,800,B_y
Return
//=============================================================
DoText:
   if !vType(Txt )
      data Edits;"Txt","Enter the desired text here","Enter your text here"
      data Edits;"TxtSize",12,"The Font's Size"
      Txt = true
   Endif
   SaveScr  
   RectangleWh 100,100,502,402,black,black       
   RectangleWh 101,101,500,400,white,white
   addedit Edits[0],110,140,300,0,Edits[1],Edits[2]
   xyText 110,165,"Font Size","Times New Roman",10,fs_Bold
   addedit Edits[3],180,165,40,0,Edits[4],Edits[5]
   addbutton "OK",250,450,100,0
   addbutton "Cancel",350,450,100,0
   FocusEdit "Txt"
   Changed = true
   while true
      if EditChanged(Edits[0]) then Edits[1] = GetEdit(Edits[0]) \ Changed = true
      if EditChanged(Edits[3]) 
         n= ToNumber(GetEdit(Edits[3]))
         if !IsNumber(n) then n = 12
         n = limit(n,2,100)
         Edits[4] = n 
         if !EditHasFocus(Edits[3])
            SetEdit Edits[3],n \ n=EditChanged(Edits[3])
         endif
         Changed = true
      endif   
      if Changed
         Changed = false
         rectanglewh 101,220,500,179,white,white
         SetColor BrushColor
         OverlayText 110,220,left(Edits[1],5),"",Edits[4]
         SetColor Black
      Endif   
      getbutton btn
      if btn == "OK"
        restorescr
        SaveScr 0,B_y,800,600
        xyText 3,B_y+2,"Click on the canvas where you want to place the text...(right click to cancel)","Times NEw Roman",8
        SetCursor cr_IBeam
        RemoveButton "OK"
        RemoveButton "Cancel"
        RemoveEdit "Txt"
        RemoveEdit "TxtSize"
        repeat
           readmouse x,y,mb
           y = limit(y,0,B_y)
           if mb == 1
              SetColor BrushColor
              OverlayText x,y,Edits[1],"",Edits[4]
              SetColor Black
           endif
        until mb
        waitnokey
        SetCursor 0
        RestoreScr 0,B_y
        break
      elseif btn == "Cancel"
         restorescr
         RemoveButton "OK"
         RemoveButton "Cancel"
         RemoveEdit "Txt"
         RemoveEdit "TxtSize"
         break         
      endif
   wend
Return
//=============================================================
Instructions:
  if !vType(IM_Defined) 
    data IM;"Painter.Bas"
    data IM;"This program creates a simple PAINTING program. You can"
    data IM;"choose the pen color and shape and size and draw using"
    data IM;"the mouse. Click the left mouse button to draw and keep"
    data IM;"it pressed while you move the mouse around to draw.",""
    data IM;"You can Save the picture to a file, Load the picture from"
    data IM;"a file, and Print the picture.",""
    data IM;"When you click on the Color box you will be prompted for a"
    data IM;"color using a color creation dialog. You can also right"
    data IM;"click on the canvas to select a color from within the canvas"
    data IM;"as the brush color.",""
    data IM;"Click on the Shape box to select from among various brush"
    data IM;"shapes from a dialog box.",""
    data IM;"The size edit box allows you to type in the brush size. Max"
    data IM;"of 100 and minimum of 1. The scroll arrows allow you to set"
    data IM;"the brush size incementaly.",""
    data IM;"The Undo button allows you to undo the last operation"
    data IM;"performed. When drawing the last operation is determined"
    data IM;"to be a mouse click. So if you press the mouse and continue"
    data IM;"to press it and draw, this is considered a single operation,"
    data IM;"and will be undone as one operation.",""
    data IM;"The Text button allows you to draw a string of text on the"
    data IM;"canvas by specifying the text and size and then the location"
    data IM;"for the text. The color of the text is the pen color.",""
    data IM;"The Fill button will change the cursor and allow you to indicate"
    data IM;"the location inside a closed area to be filled with the pen color.",""
    data IM;"The clear button allows you to clear the canvas.",""
    IM_Defined = true
  endif  
  n=MsgBox(IM)
Return
//=============================================================
