MainProgram:
    GoSub Initialize
    GoSub MonitorInputs
End
//============================================================
Initialize:
    GoSub Instructions
    xyText 60,250,"Please Wait.....Initializing...","",30,fs_Bold
    flip on
    data clrs;0,0,0
    data arrows;"uasu","lwsl","usau","lswl",-2,0,0,-2,2,0,0,2
    data arrowsC;0,247,187,  2,247,187,  1,470,343,  3,470,343,  1,63,345,  3,63,345
    for i=0 to MaxDim(arrowsC,1)-1 step 3       
       dx = arrows[arrowsC[i]*2+4] \ dy = arrows[arrowsC[i]*2+5]
       DrawShape arrows[arrowsC[i]],arrowsC[i+1]+dx,arrowsC[i+2]+dy,7
       FloodFill arrowsC[i+1]+dx*2,arrowsC[i+2]+dy*2
    next   
    xystring 413,335,"G=000"
    c = rgb(clrs[0],clrs[1],clrs[2])
    RectangleWH 250,20,100,100,c,c
    w = 5
    for i=0 to 255-w step w
      for j=0 to 255-w step w
         n = RGB(i,0,j)
         RectangleWH 75+i,200+j,w,w,n,n
      next
    next
    eRectangle 74,199,331,456,2,0
    SaveScr 73,198,332,457
    xyString 175,180,"R=000"
    xyString 5,335,"B=000"
    eRectangle 374,199,405,456
    for i=0 to 255
       n = rgb(0,i,0)
       line 375,200+i,405,200+i,1,n
    next
    xyString 355,30,"Actual RGB Code"
    xyString 355,64,"Specified RGB Code"
    orb = 0
    w = 100 \ h=60
    xyString 600,10,"Standard Colors"
    for i=0 to 15
       x = i/8 \ y = i#8
       RectangleWH 572+w*x,h*y+32,w-2,h-2,0,i
    next
    flip
    data clrnames;"Black","Blue","Green","Cyan","Red","Magenta"
    data clrnames;"Brown","Gray","Darkgray","Lightblue","Lightgreen"
    data clrnames;"Lightcyan","Lightred","Lightmagenta","Yellow","White"
    addbutton "&Instructions",1,1
Return
//============================================================    
MonitorInputs:
   UpdateBar = false
   while true
     getbutton btn
     if btn != "" then n=MsgBox(IM)
     if !vType(mb)
        x = 203 \ y = 328 \ mb = 1 \ clrs[1] = 128
     else
        ReadMouse x,y,mb
     endif   
     if mb
       if within(x,375,405) & within(y,200,455)
          clrs[1] = y-200
       elseif within(x,75,330) & within(y,200,455)
           clrs[0]=x-75 \ clrs[2] = y-200 
       elseif within(x,239,248) & within(y,180,194)
            clrs[0] = clrs[0]-1
       elseif within(x,246,254) & within(y,180,194)
            clrs[0] = clrs[0]+1
       elseif within(x,463,477) & within(y,334,342)
            clrs[1] = clrs[1]-1
       elseif within(x,463,477) & within(y,344,352)
            clrs[1] = clrs[1]+1
       elseif within(x,56,70) & within(y,335,343)
            clrs[2] = clrs[2]-1
       elseif within(x,56,70) & within(y,346,354)
            clrs[2] = clrs[2]+1
       elseif within(y,32,510) & within(x,572,770)
            readpixel x,y,c
            clrs[0] = RedValue(c) \ clrs[1] = GreenValue(c) \ clrs[2] = BlueValue(c)
            sn = ""
            if c < 16 then sn = clrnames[c]
            xyString 600,520,c,"=",sn,spaces(30)
       else
         continue     
       endif
       clrs[0] = limit(clrs[0],0,255)
       clrs[1] = limit(clrs[1],0,255)
       clrs[2] = limit(clrs[2],0,255)
       xyString 413,335,"G=",format(clrs[1],"000")
       xyString 411,352,"(0x",Hex(clrs[1]),")"
       xyString 135,180,"R=",format(clrs[0],"000"),"(0x",hex(clrs[0]),")"
       xyString 5,335,"B=",format(clrs[2],"000")
       xyString 2,352,"(0x",Hex(clrs[2]),")"
       RestoreScr 73,198
       Line 75,200+clrs[2],330,200+clrs[2],1,white
       Line 75+clrs[0],200,75+clrs[0],555,1,white
       Rectangle 370,190,373,460,white,white
       Rectangle 406,190,410,460,white,white
       drawshape arrows[2],371,clrs[1]+200,3
       FloodFill 373,clrs[1]+200
       DrawShape arrows[0],409,clrs[1]+200,3
       FloodFill 407,clrs[1]+200
       flip
       UpdateBar = true   
       readmouse x,y,mb
       if mb && within(x,55,330) && within(y,180,455) then continue        
     endif
     if UpdateBar
       UpdateBar = false
       c = rgb(clrs[0],clrs[1],clrs[2])
       RectangleWH 250,20,100,100,0,c
       if orb != clrs[0]+clrs[2]
         orb = clrs[0]+clrs[2]
         for i=0 to 255
            n = rgb(clrs[0],i,clrs[2])
            Line 375,200+i,405,200+i,1,n
         next
       endif
       xystring 375,47,"0x",Hex(c,3)
       xystring 375,81,"0x",Hex(clrs[2]),Hex(clrs[1]),Hex(clrs[0])
       flip
     endif
   wend
Return
//============================================================
Instructions:
     data IM;"RGB_Colors.BAS"
     data IM;"This program allows you to interactively view colors.",""
     data IM;"You can specify a Red/Blue value by clicking the mouse"
     data IM;"within the Red/Blue map or by incrementaly increasing"
     data IM;"or decreasing the value using the spin controls. The"
     data IM;"position within the colors map is indicated with a white"
     data IM;"cross-hairs.",""
     data IM;"You can specify a Green value by clicking within the"
     data IM;"vertical final color column, or by incrementing or"
     data IM;"decrementing using the spin controls. The position"
     data IM;"is indicated with a slider.",""
     data IM;"The color that is actually formed from the values"
     data IM;"you specify for Red/Green/Blue will be shown in the"
     data IM;"top box.",""
     data IM;"This color however, is not exactly the same value"
     data IM;"as you have specified due to the machine's graphics"
     data IM;"card approximating to the nearest available color,"
     data IM;"which may not be exactly the value you specified.",""
     data IM;"You can see the actual color value (in hex) next to"
     data IM;"the box. Remember the LSB is the Red color value"
     data IM;"the next byte is the Green, and the MSB is the Blue"
     data IM;"value. Compare those to the hex values for each"
     data IM;"color you have specified.",""
     data IM;"If you click inside the standard colors boxes on"
     data IM;"the right, the program will set the RGB values"
     data IM;"according to the color selected. Also the top box"
     data IM;"will contain the color. Below the boxes you will see"
     data IM;"the constant number value as well as the name of the"
     data IM;"color.",""
Return
//============================================================
