MainProgram:
  GoSub Initialization
  while true
     GoSub AnimateCannon
     gosub RespondToInputs
     Gosub UpdateDisplay
     gosub AnimateCannonBall
  wend
End
//===================================================================
Initialization:
  GoSub Instructions
  Flip On
  Cannon_x = 30 \ Cannon_y = 400
  Cannon_L = 40  \ Cannon_H = 10
  MaxBalls = 50
  data muzzle;0,-Cannon_H,Cannon_L,-Cannon_H/2
  data muzzle;Cannon_L,Cannon_H/2,0,Cannon_H
  data muzzle;Cannon_L/2,0,-Cannon_H-2,0
  data muzzle;Cannon_L+5,0
  data base;-(Cannon_x-5),0,Cannon_x+5,0,Cannon_x+5,15
  data base;Cannon_x+10,15,Cannon_x+10,20,Cannon_x-10,20
  data base;Cannon_x-10,15,Cannon_x-5,15,Cannon_x-5,0
  NumPoints = MaxDim(muzzle,1)/2
  dim Muzzle[NumPoints,2]
  mcopy muzzle,Muzzle
  dim RotateM[2,2]
  dim Balls[MaxBalls,6]
  Max_WindVel = 15 \ Vw = 10
  Vo = 70 \ Delta_Time = 0.15 \ g = 9.81
  Theta = 0.2
  ClearScr Blue
  Rectangle 0,520,800,600,Green,Green
  Rectangle 0,571,800,600,white,white
  xyText 10,580,"Wind Vel.(Q/W)=","Times New Roman",8,fs_Bold  
  xyText 170,580,"Gravity(A/S)=","Times New Roman",8,fs_Bold
  xyText 350,580,"Muzzle Vel.(Z/X)=","Times New Roman",8,fs_Bold
  xyText 560,580,"Angle(       /        ) =","Times New Roman",8,fs_Bold
  //xyText 540,580,"Angle(Lft.Arr/Rt.Arr)=","Times New Roman",8,fs_Bold
  OverlayText 1,550,"Cannon Height Up=     Down="+spaces(20)+"Fire = Space Bar","Times New Roman",9,fs_Bold
  uparrow = "uawsqddd" \   rtarrow = rotshape(uparrow,1)
  dnarrow = rotshape(rtarrow,1) \   ltarrow = rotshape(dnarrow,1)
  
  drawshape uparrow,110,555,3 \ drawshape dnarrow,160,560,3 
  drawshape ltarrow,604,587,3 \ drawshape rtarrow,630,587,3 

  SaveScr
  data Buttons;"&Instructions"
  Addbutton Buttons[0],708,540,90,25
  LeftArrow  	= "llluuaaaassssuurrruuuu"
  RightArrow 	= "rrruussssaaaauullluuuu"
  mconstant Balls,0
  C_Timer = 0 \ C_Time = 100
  CB_Timer = timer() \ CB_Time = 10
  JustFired = 0 \   BombsInAir = 0
Return
//===================================================================
RespondToInputs:
  GetButton btn
  if btn == Buttons[0] then n=MsgBox(I_M)
  if keydown(Ascii("Z")) then Vo = Limit(Vo-0.5,1,100)
  if keydown(Ascii("X")) then Vo = Limit(Vo+2,0.5,100)
  if keydown(Ascii("A")) then g = Limit(g-0.1,0,20)
  if keydown(Ascii("S")) then g = Limit(g+0.1,0,20)
  if keydown(Ascii("Q")) then Vw = Limit(Vw-1,-Max_WindVel,Max_WindVel)
  if keydown(Ascii("W")) then Vw = Limit(Vw+1,-Max_WindVel,Max_WindVel)
  if keydown(kc_UArrow) then Cannon_y  = Limit(Cannon_y-1,80,500)
  if keydown(kc_DArrow) then Cannon_y  = Limit(Cannon_y+1,80,500)
  if keydown(ascii(" ")) || keydown(kc_MMouseB)
    if JustFired then JustFired = JustFired-1 \ return
    for AC_i=0 to MaxBalls-1
      if Balls[AC_i,0] then continue
      BombsInAir = BombsInAir+1
      Balls[AC_i,1] = Mzl[6,0] \ Balls[AC_i,2] = Mzl[6,1] 
      Balls[AC_i,3] = Theta \ Balls[AC_i,5] = Vo
      Balls[AC_i,4]=0
      Balls[AC_i,0] = true
      JustFired = 4
      break
    next  
  endif    
Return
//===================================================================
UpdateDisplay:
  RestoreScr
  if Vw < 0	    //draw wind 
    DrawShape LeftArrow,400,50,abs(Vw),Yellow
  elseif Vw > 0
    DrawShape RightArrow,400,50,abs(Vw),Yellow
  endif
  if Vw !=0 then FloodFill 400+sign(Vw),51,Yellow
  GoSub DrawCannon
  for UD_i=0 to MaxBalls-1
     if Balls[UD_i,0] 
        Circle Balls[UD_i,1]-3,Balls[UD_i,2]-3,Balls[UD_i,1]+3,Balls[UD_i,2]+3,black,black //ball
     endif
  next  
  setcolor black,white
  xyText 110,576,Vw,"",15,fs_Bold
  xyText 250,576,format(g,"0.00"),"",15,fs_Bold
  xyText 450,576,format(Vo,"0.00"),"",15,fs_Bold
  xyText 660,576,format(rToD(Theta),"0.0")+"","",15,fs_Bold
  flip
Return
//===================================================================
AnimateCannonBall:
  if timer()-CB_Timer < CB_Time then return
  CB_Timer = timer()
  for AB_i=0 to MaxBalls-1
    if !Balls[AB_i,0] then continue
    ReadPixel Balls[AB_i,1]+4,Balls[AB_i,2]+4,AB_BC
    if Balls[AB_i,1] < 0 || Balls[AB_i,1] > 800 //----off to right or left
       Balls[AB_i,0] = false \ BombsInAir = BombsInAir-1
    elseif AB_BC == green //----hit the ground  .... you can allow for bounce here
       Balls[AB_i,0] = false \ BombsInAir = BombsInAir-1
    elseif AB_BC == black //----hit another ball
       Balls[AB_i,0] = false \ BombsInAir = BombsInAir-1
    else   //ball dynamics
       //dX = (Vo*Cos(Theta)+Vw)*dT  
       //dY = (Vo*Sin(Theta)-g*t)*dT
       dX = (Balls[AB_i,5]*Cos(Balls[AB_i,3])+Vw)*Delta_Time  
       dY = (Balls[AB_i,5]*Sin(Balls[AB_i,3])-g*Balls[AB_i,4])*Delta_Time
       Balls[AB_i,1] = Balls[AB_i,1]+dX \ Balls[AB_i,2] = Limit(Balls[AB_i,2]-dY,-1000,519)
       Balls[AB_i,4] = Balls[AB_i,4]+Delta_Time
    endif
  next  
Return
//===================================================================
AnimateCannon:
  if timer()-C_Timer < C_Time then return
  C_Timer = timer()
  if keydown(37) || keydown(kc_LMouseB) then Theta = Limit(Theta+0.05,-0.35,pi(0.48))
  if keydown(39) || keydown(kc_RMouseB) then Theta = Limit(Theta-0.05,-0.35,pi(0.48))
Return
//===================================================================
DrawCannon:
   ST = sin(Theta) \ CT = Cos(Theta)
   RotateM[0,0] = CT \ RotateM[0,1] = -ST
   RotateM[1,0] = ST \ RotateM[1,1] = CT
   MMultiply Muzzle,RotateM,Mzl  //----rotate
   for DC_i=0 to NumPoints-1  //----translate to xy pos of cannon
      Mzl[DC_i,0]=Mzl[DC_i,0]+Cannon_x
      Mzl[DC_i,1] = Mzl[DC_i,1]+Cannon_y
   next
   For DC_i= 1 to 3 //----plot muzzle
     line Mzl[DC_i-1,0],Mzl[DC_i-1,1],Mzl[DC_i,0],Mzl[DC_i,1],2,Gray
   next
   linewidth 2
   circle Cannon_x-Cannon_H,Cannon_y-Cannon_H,Cannon_x+Cannon_H,Cannon_y+Cannon_H,gray,gray //----plot back
   circle Mzl[5,0]-3,Mzl[5,1]-3,Mzl[5,0]+3,Mzl[5,1]+3,gray,gray //plot knob
   FloodFill Mzl[4,0],Mzl[4,1],gray
   setcolor darkgray
   linewidth 1
   //----plot base
   mcopy base,Base
   for DC_i = 0 to MaxDim(base,1)/2 -1
      Base[DC_i*2+1] = Base[DC_i*2+1]+Cannon_y
   next 
   Circle Cannon_x-4,Cannon_y-4,Cannon_x+4,Cannon_y+4,black,gray
   mpolygon Base
   FloodFill2 Cannon_x,Cannon_y+4,DarkGray,darkgray
   Circle Cannon_x-2,Cannon_y-2,Cannon_x+2,Cannon_y+2,black,black
   Rectangle 0,Cannon_y+20,Cannon_x+20,540,green,green
Return
//===================================================================
Instructions:
   data I_M;"CannonBall.Bas"
   data I_M;"This program demonstrates the effects of various parameters on the trajectory"
   data I_M;"of a cannon ball fired from a cannon.",""
   data I_M;"The variable parameters are:"
   data I_M;"   -Wind Velocity      (Q=decrease W=Increase)"
   data I_M;"   -Gravity            (A=decrease S=Increase)"
   data I_M;"   -Muzzle Velocity    (Z=Decrease X=Increase)"
   data I_M;"   -Height of Cannon   (UpArrow=Increase DnArrow=Decrease)"
   data I_M;"   -Cannon Inclination (LeftArrow=Increase RightArrow=Decrease)"
   data I_M;"                       (LeftMouse          RightMouse         )",""
   data I_M;"To fire the cannon either press the Spacebar, or Middle Mouse Button."
   data I_M;"The yellow arrow indicates the wind direction and speed.",""
   data I_M;"You can press multiple keys simultaneously, so you can be firing while"
   data I_M;"changing the cannon inclination and wind speed all at the same time.",""
   data I_M;"keeping the firing button down while changing certain parameters results"
   data I_M;"in a very nice visualization of the effect on the trajectory.",""
   data I_M;"The units are all SI units. Speeds (meters/second), Gravity (m/s/s).",""
   data I_M;"All the parameters have maximum and minimum values that will not be"
   data I_M;"exceeded even if you try to by keeping the control button pressed."
Return
//===================================================================
