MainProgram:
   GoSub Initialize
   GoSub MonitorInputs
end
//===================================================================
Initialize:
   PMT = 0 \ PV = 1 \ FV = 2 \ BAL = 3\ TERM = 4 \ INTR = 5 \ TOT = 6
   data values;1,1,1,0,1,1,1
   data edits;"Monthly Payments:$","Present Value:$","Future Value:$"
   data edits;"Balloon Payment:$","Term (months):","Annuaul Interest Rate:"
   data edits;"Total Payed out:$"
   for i=0 to MaxDim(edits,1)-1
      xyText 10,10+30*i,JustifyR(edits[i],"",22),"",8,fs_bold
      AddEdit edits[i],170,5+30*i,100,0,ToString(values[i])," "
   next   
   EnableEdit edits[TOT],false
   xyText 275,155,"%","",15,fs_bold
   xyText 480,10,"Loan Related Calculations","Times New Roman",12,fs_Bold
   xyText 480,115,"Lease Related Calculations","Times New Roman",12,fs_Bold
   xyText 440,220,"Savings Account Related Calculations","Times New Roman",12,fs_Bold
   xyText 435,325,"Compound Interest Related Calculations","Times New Roman",12,fs_Bold
   data buttons;" Calculate Payments given PV,IntR,Term,Balloon"
   data buttons;" Calculate PV given Payments,IntR,Term,Balloon"
   data buttons;" Calculate Term given Payments,IntR,PV,Balloon"
   data buttons;"Calculate Payments given PV,IntR,Term,Balloon"
   data buttons;"Calculate PV given Payments,IntR,Term,Balloon"
   data buttons;"Calculate Term given Payments,IntR,PV,Balloon"
   data buttons;"Calculate FV given Payments,IntR,Term"
   data buttons;"Calculate Payments given FV,IntR,Term"
   data buttons;"Calculate needed Term given Payments,IntR,FV"
   data buttons;"Calculate FV given PV,Intr,Term"
   data buttons;"Calculate needed IntR given PV,FV,Term"
   data buttons;"Calculate needed Term given PV,IntR,FV"
   tt = 30
   for i=0 to maxdim(buttons,1)-1
      AddButton buttons[i],370,i*25+tt,400
      if (i+1)#3 == 0 then tt= tt+30
   next
   FocusEdit edits[0]
Return
//===================================================================
MonitorInputs: 
 while true
   GetButton btn
   if btn != ""
     for i=0 to MaxDim(buttons,1)-1
        if btn == buttons[i] then break
     next
     GoSub CalcValue
   endif
   for i=0 to MaxDim(edits,1)-1 
     if EditChanged(edits[i])
       ok = true
       a = GetEdit(edits[i])
       n = ToNumber(a)
       if !IsNumber(n) then n = 0 \ ok = false 
       n = abs(n)
       if n==0 && i != 3 then n = 1
       if a != "" && !ok then SetEdit edits[i],ToString(n)\ FocusEdit "" \ FocusEdit edits[i]
       values[i] = n
       if i==PMT || i== TERM || i==BAL
         values[TOT] = values[PMT]*values[TERM]+values[BAL]
         SetEdit edits[TOT],ToString(values[TOT])
       endif   
     endif
   next
 wend
Return
//===================================================================
CalcValue:
  IR = values[INTR]/100.0/12
  if i==0 then j=PMT  \n =ff_pvp(values[PV],IR,values[TERM],values[BAL],0)
  if i==1 then j=PV   \n =ff_pv(values[PMT],IR,values[TERM],values[BAL],0)
  if i==2 then j=TERM \n =ff_pvt(values[PMT],IR,values[PV],values[BAL],0)

  if i==3 then j=PMT  \n =ff_pvp(values[PV],IR,values[TERM],values[BAL],1)
  if i==4 then j=PV   \n =ff_pv(values[PMT],IR,values[TERM],values[BAL],1)
  if i==5 then j=TERM \n =ff_pvt(values[PMT],IR,values[PV],values[BAL],1)

  if i==6 then j=FV   \n =ff_fv(values[PMT],IR,values[TERM],1)
  if i==7 then j=PMT  \n =ff_fvp(values[FV],IR,values[TERM],1)
  if i==8 then j=TERM \n =ff_fvt(values[PMT],IR,values[FV],1)

  if i==9  then j=FV   \n =ff_cifv(values[PV],IR,values[TERM])
  if i==10 then j=INTR \n =ff_cii(values[PV],values[FV],values[TERM])
  if i==11 then j=TERM \n =ff_cit(values[PV],IR,values[FV])
  if j==INTR then n=(n*12*100)
  n = Round(n*100)/100.0 \ n2 = round(frac(n)*100)
  Rectangle 0,500,800,600,white,white
  if j == INTR
      sn = Spell(n)+" % annual interest"
  elseif j == TERM
      sn = Spell(n)+" months"
  else    
      sn = Spell(n)+" Dollars"
      if n2 > 0 then sn = sn+" and "+ToString(Round(Frac(n)*100))+" Cents"
  else
  endif    
  xytext 1,500,sn,"",8,fs_Bold
  SetEdit edits[j],ToString(n)
  FocusEdit edits[j]
  if InString("00 02 03 05 07 08 11",format(i,"00"))
      values[TOT] = values[PMT]*values[TERM]+values[BAL]
      SetEdit edits[TOT],tostring(values[TOT])
  endif   
Return
//===================================================================
