//-------This program will plot (or print out) the Fourier series for
//-------five periodic function.  You need to specify three parameter:
//             1- The number of Harmonics in the series            N
//             2- The number of cycles (periods) to plot/printout  Cycles
//             3- The number of points in a cycle (rselution)      Points
//-------You also need to modify Plot_Print to 
//             1 if you want to plot
//             2 if you want to print the points with    comments
//             3 if you want to plot the points  without comments
//
//-------Cycles is only applicable for plotting. For Pretty/Raw data prints
//       only one cycle (0 to 2*PI) since the data is just a repeat for other
//       cycles and thus is not needed for data points.
//
//-------The raw and pretty data prints can be useful when tou use the 
//       clip-to-clipboard option and clip the printout to the clipboard
//       and paste the data in another program like a spread sheet.


        Cycles      = 3             //Cycles to plots
	Points      = 50            //steps in theta
        ThetaStep   = PI(2)/Points  //steos in radians
	N           = 5             //number of harmonics for first run
        Plot_Print  = 1             //1 = plot  2=print pretty    3=raw print points

//-----------------------------------------------
////////////////////////////Variables
//-----------------------------------------------
	offset      = 50
	originY     = 100
	YScale      = 50
	XScale      = 500/Cycles/PI(2)
        Theta       = 0
        Y           = 1
//-----------------------------------------------
////////////////////////////Main
//-----------------------------------------------
:Main
GoSub DisplayInstructions
while true
    if Plot_Print = 1 then gosub PlotPoints
    if Plot_Print = 2 then gosub PrettyPrint
    if Plot_Print = 3 then gosub RawPrint
    while true
       input "Please enter number of harmonics",N
       if !isnumber(N) then continue
       if N >= 1 then break
    wend
wend
end
//-----------------------------------------------
////////////////////////////Subroutines 
//-----------------------------------------------
:PlotPoints
   Y = 1
   GoSub PlotAxis
   xystring 10,30," For ",N," Harmonics  ",Points," Points per Cycle  ",Cycles," Cycles"
   gotoxy 0,originY+offset
   For Y = 1 to 5
     Theta = 0
     For X = 1 to Points*Cycles+1
         if Y = 1 then  gosub SquareWave
         if Y = 2 then  gosub RectifiedSin
         if Y = 3 then  gosub TriangularWave
         if Y = 4 then  gosub SawToothWave1
         if Y = 5 then  gosub SawToothWave2
         lineTo Theta*XScale,offset+originY-a*YScale
         Theta = Theta+ThetaStep
     Next
     gotoxy 0,offset+originY
   next
return
//-----------------------------------------------
:PrettyPrint
  clearscr
  For Y = 1 to 5 
     if Y = 1 then  print "SquareWave"
     if Y = 2 then  print "RectifiedSin"
     if Y = 3 then  print "Triangualr"
     if Y = 4 then  print "Sawtooth 1"
     if Y = 5 then  print "SawTooth 2"
     print "-------------"
     Theta = 0
     x = 0
     for X = 1 to Points
         if Y = 1 then  gosub SquareWave
         if Y = 2 then  gosub RectifiedSin
         if Y = 3 then  gosub TriangularWave
         if Y = 4 then  gosub SawToothWave1
         if Y = 5 then  gosub SawToothWave2
         print  left(ToString(Theta*pi(2))+spaces(10),10)+"  =>  ",a
         Theta = Theta+ThetaStep
         x = x+1
         if x > 32
           Waitkey x
           x = 0
           clearscr
         endif  
     next
     WaitKey x
     clearscr
  next
return
//-----------------------------------------------
:RawPrint
  clearscr
  For Y = 1 to 5 
     if Y = 1 then  print "SquareWave"
     if Y = 2 then  print "RectifiedSin"
     if Y = 3 then  print "Triangualr"
     if Y = 4 then  print "Sawtooth 1"
     if Y = 5 then  print "SawTooth 2"
     print "--------------"
     Theta = 0
     x = 0
     for X = 1 to Points
         if Y = 1 then  gosub SquareWave
         if Y = 2 then  gosub RectifiedSin
         if Y = 3 then  gosub TriangularWave
         if Y = 4 then  gosub SawToothWave1
         if Y = 5 then  gosub SawToothWave2
         print  a
         Theta = Theta+ThetaStep
         x = x+1
         if x > 32
           Waitkey x
           x = 0
           clearscr
         endif  
      next
      WaitKey x
      clearscr
  next
return
//-----------------------------------------------
:PlotAxis
  clearscr
  setcolor red
  for kkk = 1 to 5
     originY = 100*kkk
     if kkk = 2 then originY = originY+20
     gotoxy 0,offset+originY
     lineto 700,offset+originY
     gotoxy 0,offset+originY+1
     lineto 700,offset+originY+1
     gotoxy 0,offset+2*originY
     lineto 0,offset
     gotoxy 1,offset+2*originY
     lineto 1,offset
  next
  setcolor black,white
  xystring 500,100,"Square Wave" 
  xystring 500,220,"Rectified Sine Wave" 
  xystring 500,300,"Triangular Wave" 
  xystring 500,400,"Saw Tooth 1 Wave" 
  xystring 500,500,"Saw Tooth 2 Wave" 
  xystring 20,10,"Plots generated from Fourier Series" 
  gotoxy 20,27
  lineto 350,27 
  originY = 100 
  gotoxy 0,offset+originY
return
//-----------------------------------------------
:SquareWave
    originY = 100
    a = 0
    for kk = 1 to N
       b = kk*2.0 - 1.0
       a =  a+ sin(Theta*b)/b
    next
    a = a*4/pi(1)
return
//-----------------------------------------------
:RectifiedSin
    originY = 220
    a = 0.5     
    for kk = 1 to N
       a =  a- cos(Theta*2.0*kk)/(4.0*(kk^2.0)-1)
    next
    a = a*4/pi(1)
return
//-----------------------------------------------
:TriangularWave
    originY = 300
    a = 0.5     
    for kk = 1 to N
       a =  a- cos(Theta*2.0*kk)/(4.0*(kk^2.0)-1)
       kk = kk+1
    next
    a = a*4/pi(1)
return
//-----------------------------------------------
:SawToothWave1
    originY = 400
    a = pi(1)*pi(1)/8
    for kk = 1 to N
       a =  a- cos((2*kk-1)*Theta)/((2*kk-1)^2)
    next
    a =2*a/pi(1)/pi(1)
return
//-----------------------------------------------
:SawToothWave2
    originY = 500
    a = 0
    for kk = 1 to N
      a =  a+ (-1^(kk+1))*sin(Theta*kk)/kk
    next
    a =a/pi(1)
return
//-----------------------------------------------
DisplayInstructions:
  data IM;"FourierSeries.Bas"
  data IM;"This program demonstrates the power of the RobotBASIC"
  data IM;"language. It uses some math to do Fourier Series plots.",""
  data IM;"Read the instructions at the top of the code to see how"
  data IM;"to modify the plot's parameters."
  n=MsgBox(IM)
Return
//=============================================================
