MainProgram:
   GoSub Initialize
   GoSub MonitorInputs
End
//=======================================================
Initialize:
   if vType(FirstTime) then Return
   FirstTime = false
   Flip On
   clearscr
   GP_x = 50 \ GP_y =120 \ GP_w = 700 \ GP_h = 400
   data GP_Specs; GP_x,GP_y,GP_w,GP_h,cyan,white,3
   data G_Specs ;GP_x,GP_y,GP_w,GP_h,blue,2
   mGraphPaper GP_Specs
   msg = "Generating The Plot... Please Wait"
   Mode = 0 //0 => y=Y(x)   1 => y=Y(t), x=X(t)
   AdjustRatio = false
   x = 0 \ t = 0
   data Evaluator;"EvaluateY","EvaluateXY"
   data F_Specs;"sin(x)","cos(t)","sin(t)"  //Yx,Xt,Yt
   data F_Specs;"-Pi()","Pi()+.1","Pi(0.1)" //LowrL,UpprL,StpSize
   Yx = 0 \ Xt = 1 \ Yt = 2\ LowrL = 3 \ UpprL = 4 \ StpSize = 5
   data Buttons;"&View Instructions","&Plot","&Mode","&Quit","&Aspect Ratio"
   For i=0 to Maxdim(Buttons,1)-2
      AddButton Buttons[i],i*105+1,1,105,25
   next
   data edits;"y=Y(x)=",60,30,200,20,Yx,-50,5
   data edits;"y=Y(t)=",325,30,200,20,Yt,-50,5
   data edits;"x=X(t)=",600,30,200,20,Xt,-50,5
   data edits;"Lower Limit=",100,60,190,20,LowrL,-90,5
   data edits;"Upper Limit=",390,60,190,20,UpprL,-90,5
   data edits;"Step Size=",665,60,135,20,StpSize,-75,5
   for i=0 to MaxDim(edits,1)-1 step 8
      addedit edits[i],edits[i+1],edits[i+2],edits[i+3],edits[i+4],F_Specs[edits[i+5]]
      XYText edits[i+1]+edits[i+6],edits[i+2]+edits[i+7],edits[i],"",8,fs_Bold
   next
   GoSub DisplayMode
   GoSub Instructions
   MaxX = GP_w \ MinX = 0 \ MaxY = GP_h \ MinY = 0
   GoSub DoLabels
   flip
   OnError ErrorHandler
   GoSub PlotFunction
Return
//=======================================================
MonitorInputs:
   while true
      for i=0 to 5
         if EditChanged(edits[i*8]) then F_Specs[i] = GetEdit(edits[i*8])
      next   
      GetButton btn
      if btn == Buttons[0] then n = MsgBox(IM)
      if btn == Buttons[1] then GoSub PlotFunction
      if btn == Buttons[2] 
          Mode = !Mode
          if Mode then AddButton Buttons[4],699,575,100,24
          if !Mode then RemoveButton Buttons[4]
          GoSub DisplayMode
          GoSub PlotFunction
      endif    
      if btn == Buttons[3] then GoSub FinishUp
      if btn == Buttons[4] then AdjustRatio = !AdjustRatio \ GoSub PlotFunction
      Readmouse mx,my,mb
      if within(mx,GP_x,GP_x+GP_w) && within(my,GP_y,GP_y+GP_h)
         if mb
           rectangle 0,560,800,600,white,white
           readpixel mx,my,cc
           if (mb==1) || (mb==2 && cc==blue)
              xx = (MaxX-MinX)*(mx-GP_x)/GP_w+MinX
              yy = (MinY-MaxY)*(my-GP_y)/GP_h+MaxY
              XYText   60,565,"x=","",15,fs_Bold
              XYstring 90,570," ",xx
              XYText   480,565,"y=","",15,fs_Bold
              XYstring 510,570," ",yy
           endif   
           flip 
           WaitNoKey 150
           mb = 0
         endif 
         SetCursor cr_Cross
      else    
          SetCursor
      endif
   wend
Return
//=======================================================
PlotFunction:
  dim Xs[0] \ Dim Ys[0]
  LowerL = Evaluate(F_Specs[LowrL]) 
  UpperL = Evaluate(F_Specs[UpprL])
  StepSize = Evaluate(F_Specs[StpSize]) 
  if LowerL > UpperL then Swap LowerL,UpperL
  StepSize = Abs(StepSize)
  mGraphPaper GP_Specs
  XYText GP_x+10,GP_y+GP_h/2-20,msg,"",20,fs_Bold
  flip
  GoSub Evaluator[Mode]
  if Mode && AdjustRatio then mPlotXY G_Specs,Xs,Ys
  mGraphPaper GP_Specs
  if Mode && AdjustRatio
     G_Specs[6] = G_Specs[6]*14.0/8.0
     G_Specs[7] = G_Specs[7]*14.0/8.0
  endif   
  mPlotXY G_Specs,Xs,Ys
  MinX = G_Specs[6] \ MaxX = G_Specs[7]
  MinY = G_Specs[8] \ MaxY = G_Specs[9]
  for i=6 to 9
     G_Specs[i] = ""
  next
  GoSub DoLabels
  flip
Return
//=======================================================
EvaluateXY:
   t = LowerL
   while t <= UpperL
      x = Evaluate(Lower(F_Specs[Xt]))
      data Xs;x
      y = Evaluate(Lower(F_Specs[Yt]))
      data Ys;y
      t = t+StepSize
   wend       
Return
//=======================================================
EvaluateY:
   x = LowerL
   while x <= UpperL
      data Xs;x
      y = Evaluate(Lower(F_Specs[Yx]))
      data Ys;y
      x = x+StepSize
   wend
Return
//=======================================================
DisplayMode:
   Rectangle 270,GP_y-30,600,GP_y-10,white,white
   if Mode
      XYText 270,GP_y-30,"Parametric Plot","",15,fs_Bold
   else
      XYText 300,GP_y-30,"Normal Plot","",15,fs_Bold
   endif
return
//=======================================================
DoLabels:
  Rectangle 0,GP_y+GP_h+5,800,600,white,white
  Rectangle 0,GP_y-20,250,GP_y-3,white,white
  XYText GP_x-30,GP_y+GP_h/2,"Y","",30,fs_Bold
  XYText GP_x+GP_w/2-10,GP_y+GP_h+5,"X","",30,fs_Bold
  xx1=format(MinX,"0.000000") \ xx2=format(MaxX,"0.000000")
  yy1=format(MinY,"0.000000") \ yy2=format(MaxY,"0.000000")
  XYText GP_x,GP_y+GP_h+15,xx1,"",8
  XYText GP_x+GP_w-30,GP_y+GP_h+15,xx2,"",8
  XYText 2,GP_y-15,yy2,"",8
  XYText 2,GP_y+GP_h+4,yy1,"",8
Return
//=======================================================
ErrorHandler:
   GetError EN,EM
   if EM == "" then EM = "Problem with your function"
   EM = "There is a problem cannot proceed:"+char(13)+EM
   n=ErrMsg(EM,IM[0],MB_ERROR|MB_OK)
   mGraphPaper GP_Specs
   flip
   Goto MainProgram
Return
//=======================================================
FinishUp:
   Flip Off
   for i=0 to MaxDim(Buttons,1)-1
      RemoveButton Buttons[i]
   next
   for i=0 to MaxDim(edits,1)-1 step 8
      RemoveEdit edits[i]
   next
   ClearScr
   XyText 150,250,"Good Bye","",80,fs_Bold
   delay 1500
End
//=======================================================
Instructions:
   data IM;"FunctionPlotter.Bas"
   data IM;"This program allows you to plot functions of the type y = Y(x),"
   data IM;"i.e. y is a function of a variable x (normal plot), or x = X(t)"
   data IM;"and y = Y(t), i.e. x and y are functions of the variable t"
   data IM;"(parametric plot).",""
   data IM;"You need to specify the lower and upper limits for the variable"
   data IM;"and a step size for stepping through it.",""
   data IM;"You can switch between Parametric or Normal mode using the push"
   data IM;"button. To create the plot push the Plot button.",""
   data IM;"You can specify the limits as numbers or as formulas as long as"
   data IM;"the formulas involve numbers only.",""
   data IM;"Depending on the mode you choose you need to provide the function"
   data IM;"[Y(x)] or [Y(t) and X(t)].",""
   data IM;"The formula you provide can use any of the functions provided in "
   data IM;"RobotBASIC but as long as the only variable used is x or t.",""
   data IM;"So for example the functions can be:"
   data IM;"     sin(x^2)   or sin(t*2)",""
   data IM;"Specify a function of x [Y(x)] for the normal plot. Specify functions"
   data IM;"of t [X(t) & Y(t)] for the parametric plot.",""
   data IM;"If you left-click the mouse on the graph paper the x-y coordinates"
   data IM;"of the cursor will be displayed on the bottom of the terminal screen.",""
   data IM;"If you right-click the mouse on the plot the x-y coordinates of the"
   data IM;"point on the plot will be displayed."
Return
//=======================================================
