//=================================================
//=================================================
//===ParametricPlots.Bas
//===     plots various mathematical shapes
//===     using the parametric equations 
//==         y=f(t) and x=g(t)
//==      plot of parametric equations
//==      x = f(t), y = g(t) plot x vs. y
//=================================================
//=================================================
MainProgram:
  GoSub DisplayInstructions
  for j=1 to 19 
    t=0
    StepT = Pi(2)/200.0
    GoSub DrawAxis
    data Subs;"Flower","Petal","Infinity","Spiral","BowTie"
    data Subs;"BugEyes","RadioActive","Prop","Pear","Apple"
    data Subs;"Eggs","Funny","Boomarang","Infinity2","HourGlass"
    data Subs;"Cordic","Circle","Ellipse","Test"
    while true
       GoSub Subs[limit(j,1,19)-1]
       GoSub Scale
       if t > pi(2) then break
       if t = 0 then gotoxy X,Y
       t = t+ StepT
       lineto X,Y
    wend
    waitkey mm
    clearscr
  next
end
//================================================================
//================================================================
//===Subroutines
//================================================================
//================================================================
//-------------------------------
DisplayInstructions:
  data IM;"ParametricPlots.Bas"
  data IM;"This program demonstrates the mathematical and graphical"
  data IM;"power of the RobotBASIC language.",""
  data IM;"It draws various mathematical formulas of sine and cosine"
  data IM;"functions as a parametric equation. Press the spacebar"
  data IM;"to step through the various shapes. They are facinating."
  n=MsgBox(IM)
Return
//=============================================================
:Test
      y = sin(2*t+2)
      x = sin(1*t+3)+cos(2*t-1)
return
//-------------------------------
:Eggs
      y = sin(4*t+8)
      x = sin(t+1)+cos(3*t+6)
return
//-------------------------------
:BugEyes
      y = cos(2*t+1)
      x = cos(t+1)+cos(3*t+6)
return
//-------------------------------
:BowTie
      y = cos(2*t+2)
      x = sin(t)
return
//-------------------------------
:RadioActive
      y = cos(2*t+2)
      x = sin(3*t+4)
return
//-------------------------------
:Pear
      y = cos(sin(t+20)+100)
      x = sin(cos(t+4))
return
//-------------------------------
:Apple
      y = cos(cos(t+4)+5)
      x = sin(sin(t+4))
return
//-------------------------------
:Prop
      y = cos(sin(t+5))
      x = sin(cos(t+10))
return
//-------------------------------
:Circle
      y = sin(t)
      x = cos(t)
return
//-------------------------------
:Ellipse
      y = sin(t)/3
      x = cos(t)/2
return
//-------------------------------
:Flower
   x = cos(3*t)*cos(t)
   y = cos(3*t)*sin(t)
return
//-------------------------------
:Petal
   r = abs(cos(2*t)) 
   y = sqrt(r)*sin(t)
   x = sqrt(r)*cos(t)
return
//-------------------------------
:Infinity
   r = abs(cos(2*t)) 
   y = sqrt(r)*sin(t)
   x = sqrt(r)*cos(t)
   if t > pi(0.25) and t < pi(0.75) 
      x = 0
      y = 0
   endif
   if t > pi(1.25) and t < pi(1.75)
      x = 0
      y = 0
   endif
return
//-------------------------------
:Spiral
   x = t*cos(t)/pi(2)
   y = t*sin(t)/pi(2)
return
//-------------------------------
:Funny
      y = sin(2*t+2)
      x = sin(3*t-1)+cos(2*t-1)
return
//-------------------------------
:Boomarang
      y = sin(2*t+2)
      x = sin(4*t-1)+cos(2*t-1)
return
//-------------------------------
:Infinity2
      y = sin(2*t+2)
      x = sin(t-3)+cos(t-6)
return
//-------------------------------
:HourGlass
      y = sin(2*t+2)
      x = sin(t+100)+cos(3*t+6)
return
//-------------------------------
:Cordic
      r = 1.0-4.0*cos(t)
      y = sin(t)*r/7
      x = cos(t)*r/7
return
//-------------------------------
:Scale
  X = 400+200*x
  Y = 300-200*y
return
//-------------------------------
:DrawAxis
   gotoxy 400,0
   setcolor red
   lineto 400,600
   gotoxy 0,300
   lineto 800,300
   setcolor black
return
//================================================================
	 