//constants
   V0               = 0.0
   T0               = 0.0
   DT               = 0.1
   Spring_Color     = DarkGray
   GraphPaperColor  = 11054080
//================================================================
//================================================================
MainProgram:
   GoSub SetUp
   GoSub Instructions
   GoSub Init_RungeKutta
   GoSub PlotPicture
   repeat
      GoSub GenerateSystem
      GoSub PlotSystem
      GoSub PlotPicture2
      Addbutton Buttons[3],590,100
      while true
         GoSub CheckEdits
         GetButton Btn
         if Btn == Buttons[0] then break
         if Btn == Buttons[1] then n=MsgBox(I_M)     
         if Btn == Buttons[3] then GoSub PlotPicture2 
         if Btn == Buttons[2] then Quit = true \ break
      wend
      if !Quit then Rectangle 0,0,560,600,white,white
   until Quit
Exit
//================================================================
//================================================================
SetUp:
   Flip on
   AbortMethod am_EXIT
   data ValuesNames;"Mass(Kg):","Damping Coeff.(Ns/m):"
   data ValuesNames;"Spring Constant(N/m):","Kinetic Friction:"
   data ValuesNames;" Initial Position(m):","Final Time(Secs):"
   data Values;3.0,0.6,30.0,0.3,8.0,10.0
   MASS = 0 \ DAMPING_COEF = 1 \ SPRING_CONS = 2 
   FRICTION_FACTOR = 3 \  X0 = 4 \ TFINAL = 5 
   data Hints;"Mass of the weight (>0)"
   data Hints;"Defines how lossy the system is(>=0)"
   data Hints;"Defines the elasticity of the spring(>=0)"
   data Hints;"Defines the amount of friction between the mass and the floor (0 to 1.0)"
   data Hints;"The starting stretch or compression position."
   data Hints;"The time for which you want the plot to be generated (>0)."
   ValuesTop = 350 \ frmt = "####0.000" \ AnyChange = false
   for i=0 to 5
     AddEdit ValuesNames[i],708,ValuesTop+i*30,90,0,Format(Values[i],frmt),Hints[i]
     XYText 560,ValuesTop+5+i*30,JustifyR(ValuesNames[i]," ",21),"",8,fs_Bold
   next
   data Buttons;"&Plot","&Instructions","&Quit","&Animate"
   for i=0 to MaxDim(Buttons,1)-2
      AddButton Buttons[i],700,10+i*25,95
   next
   Y_Offset = 30 \ X_Offset = 50 \ X_Step = 10 \ Y_Step = 10
   Width = 500 \ Height = 500
   Data GP_Specs;X_Offset,Y_Offset,Width,Height,GraphPaperColor,white
   Data G_SpecsX; X_Offset,Y_Offset,Width,Height,blue,2
   Data G_SpecsX; "","","",""
   Data G_SpecsV; X_Offset,Y_Offset,Width,Height,red,2
   Data G_SpecsV; "","","",""
   Quit = false
Return
//================================================================
FinishUp:
   for i=0 to MaxDim(Buttons,1)-1
      RemoveButton Buttons[i]
   next
   for i=0 to MaxDim(ValuesNames,1)-1
      RemoveEdit ValuesNames[i]
   next
Exit
//================================================================
CheckEdits:
  err = false
  for i=0 to MaxDim(ValuesNames,1)-1
     s = ValuesNames[i]
     if EditHasFocus(s) then break
     if !EditChanged(s) then continue
     n = ToNumber(GetEdit(s))
     if !IsNumber(n) 
        nn=ErrMsg(Msgs[3],Msgs[0],mb_ERROR|mb_OK)
        err = true
     elseif n==0 && (i == 0 || i == 5)
        nn=ErrMsg(Msgs[1],Msgs[0],MB_ERROR|MB_OK)
        err = true
     elseif n < 0 && i != 4
        nn=ErrMsg(Msgs[2],Msgs[0],MB_ERROR|MB_OK)
        err = true
     elseif n > 1 && i == 3
        nn=ErrMsg(Msgs[4],Msgs[0],MB_ERROR|MB_OK)
        err = true
     endif
     if err then break
     Values[i] = n
     SetEdit s,Format(n,frmt)
     nn=EditChanged(s)
     AnyChange = true
  next
  if err
     getbutton nn
     SetEdit s,Format(Values[i],frmt)
     nn=EditChanged(s)
     FocusEdit s
  elseif AnyChange
      AnyChange = false
  endif   
Return
//================================================================
PlotPicture:
   Spring = "rwsswwsswwsr"
   Arrows = "luaassurrdwwqqdl"
   Rectangle 560,100,800,300,black,black
   Rectangle 580,100,800,280,white,white
   LineWidth 4
   drawshape Spring,580,240,14,Spring_Color
   LineWidth 1
   drawshape Arrows,700,180,5,cyan
   Rectangle 750,200,780,280,blue,blue
Return
//================================================================
PlotPicture2:
   PP_bt = "&Stop Animation"
   Addbutton PP_bt,590,100
   Rectangle 560,100,800,300,black,black
   Rectangle 580,100,800,280,white,white
   PP_Zp = "arrq"
   DrawShape PP_Zp,685,280,7,yellow
   FloodFill 685,282,yellow
   PP_Scale = 170.0/(MaxX-MinX)
   for i=0 to MaxDim(Xs,1)-1
      Getbutton PP_btn
      if PP_btn == PP_bt then break
      rectangle 580,100,800,280,white,white
      PP_X = (Xs[i]-MinX)*PP_Scale+600
      PP_dX = (PP_X-590)/8
      line 580,240,590,240,3,Spring_Color
      line 590,240,590+PP_dX,220,3,Spring_Color
      lineto 590+PP_dX*3,260,3,Spring_Color
      lineto 590+PP_dX*5,220,3,Spring_Color
      lineto 590+PP_dX*7,260,3,Spring_Color
      lineto 590+PP_dX*8,240,3,Spring_Color
      Rectangle PP_X,200,PP_X+30,280,Blue,Blue
      flip 
      delay 50
   next
   RemoveButton PP_bt 
return
//================================================================
GenerateSystem:
   CurrV = V0  \ CurrX = Values[X0] \ CurrT = T0
   RK_dT = DT
   MaxVe= CurrV \ MinVe = CurrV
   MaxX = CurrX \ MinX = CurrX
   MaxT = Values[TFINAL] \ MinT = T0
   Dim Ts[0] \ Dim Xs[0] \ Dim Vs[0]
   XYText X_Offset,Y_Offset+50,Msgs[5],"",20,fs_Bold
   flip 
   while CurrT <= MaxT
      data Ts;CurrT \ Data Vs;CurrV \ Data Xs;CurrX
      RK_Zn[0] = CurrV \ RK_Zn[1] = CurrX \ RK_Tn = CurrT
      GoSub RungeKutta 
      CurrV = RK_Zn1[0] \ CurrX = RK_Zn1[1] \ CurrT = RK_Tn1
      MinX  = MinV(MinX,CurrX)
      MinVe = MinV(MinVe,CurrV)
      MaxX  = MaxV(MaxX,CurrX)
      MaxVe = MaxV(MaxVe,CurrV)
   wend
Return
//================================================================
PlotSystem:
   MaxX  = MaxV(Abs(MaxX),Abs(MinX))
   MinX  = -MaxX
   MaxVe = MaxV(Abs(MaxVe),Abs(MinVe))
   MinVe = -MaxVe
   VScale = Height/(MinVe-MaxVe)
   XScale = Height/(MinX-MaxX)
   TScale = Width/(MaxT-MinT)
   G_SpecsX[8]= MinX \ G_SpecsX[9] = MaxX   
   G_SpecsV[8]= MinVe \ G_SpecsV[9] = MaxVe
   G_SpecsX[6]= MinT \ G_SpecsX[7] = MaxT   
   G_SpecsV[6]= MinT \ G_SpecsV[7] = MaxT   
   mGraphPaper GP_Specs
   setcolor red
   for y=0 to Height step  Height/10
      XYText 0,y+Y_Offset-15,format(1.0*y/VScale+MaxVe,"###0.0"),"",8
   next
   setcolor blue
   for y=0 to Height step  Height/10
      XYText 0,y+Y_Offset+1,format(1.0*y/XScale+MaxX,"###0.0"),"",8
   next
   setcolor black
   for x=0 to Width step  Width/10
      XYText x+X_Offset-20,Height+Y_Offset+15,format(x/TScale+MinT,"#0.0"),"",8
   next
   line 0,580,20,580,5,red
   line 0,590,20,590,5,blue
   XYText 25,570,"Velocity (m/s)","",8
   XYText 25,585,"Position (m)","",8
   XYText Width/2-50+X_Offset,Height+Y_Offset+35,"Time (Secs)","",15,fs_BOLD
   mPlotXY G_SpecsX,Ts,Xs
   mPlotXY G_SpecsV,Ts,Vs
   flip
Return
//================================================================
Init_RungeKutta:
   //----set these values for different differential equations
   RK_CalcRoutine = "CalcVX"
   RK_NumFormulas = 2
   //-----don't change these----------------
   dim RK_Zn[RK_NumFormulas]
   dim RK_Zn1[RK_NumFormulas]
   dim RK_tempZn[RK_NumFormulas]
   dim RK_Value[RK_NumFormulas]
   dim RK_dZ[5,RK_NumFormulas] \ mconstant RK_dZ,0
   dim RK_Factors[0]
   data RK_Factors;0,0,0.5,0.5,1.0
Return
//================================================================
RungeKutta:
   //expects initial value RK_Zn[0 to NumFormulas-1], RK_Tn and time increment RK_dT
   //expects the subroutine name to do the formula inside the variable RK_CalcRoutine
   //this subroutine must do its calculations on the variables RK_tempZn[0 to NumFormulas-1]
   //and RK_tempTn and return the result RK_Value[0 to NumFormulas-1]
   //returns Zn+1 as RK_Zn1[0 to NumFormulas-1]  and  Tn+1 as RK_Tn1 = RK_Tn+RK_dT 

   //---Calculate dZ1-4
   for j=1 to 4
      for i=0 to RK_NumFormulas-1
         RK_tempZn[i] = RK_Zn[i]+RK_dZ[j-1,i]*RK_Factors[j]
      next
      RK_tempTn = RK_Tn+RK_dT*RK_Factors[j]
      Gosub RK_CalcRoutine
      for i=0 to RK_NumFormulas-1
         RK_dZ[j,i] = RK_Value[i]*RK_dT
      next
   next
   //---Calculate Zn+1[0 to NumFormulas-1] and Tn+1
   for i=0 to RK_NumFormulas-1
      RK_Zn1[i] = RK_Zn[i]+RK_dZ[1,i]/6.0+RK_dZ[2,i]/3.0+RK_dZ[3,i]/3.0+RK_dZ[4,i]/6.0
   next
   RK_Tn1 = RK_Tn+RK_dT   
Return
//================================================================
CalcVX:
   //calculates a value as a function of RK_tempZn[0 to NumFormulas-1] and RK_tempTn
   //and result in RK_Value[0 to NumFormulas-1]
   n=sign(RK_tempZn[0])*Values[FRICTION_FACTOR]*9.81
   RK_Value[0] = -(Values[DAMPING_COEF]*RK_tempZn[0]+Values[SPRING_CONS]*RK_tempZn[1])/Values[MASS]-n
   RK_Value[1] = RK_tempZn[0]
Return
//================================================================
Instructions:
   data Msgs;"Spring.Bas"
   data Msgs;"Mass and Final Time are not allowed to be zero..."
   data Msgs;"Negative values allowed only for Initial Position..."
   data Msgs;"Not a valid number..."
   data Msgs;"Friction Factor cannot exceed 1.0"
   data Msgs;"Please Wait..Generating Data.."
   
   data I_M;Msgs[0]+"....Instructions..."
   data I_M;"This program will solve the second order differential equation that represents"
   data I_M;"the dynamics of a mass at the end of a spring and resting on the floor. The "
   data I_M;"spring is attatched to a wall at the other end. When the mass is displaced from"
   data I_M;"the natural resting position the spring will either be compressed or stretched.",""
   data I_M;"Once you release the mass the spring will try to go back to its uncompressed or"
   data I_M;"unstretched position. The way the system behaves depends on the initial deflection,"
   data I_M;"the Mass, the spring elasticity, the fricition coefficient between the mass and the"
   data I_M;"ground and a damping factor that represents other energy losses in the system.",""
   data I_M;"The diffrential equation is M*dX^2/dt^2+Mu*dX/dt+K*X = Fk*M*9.81. M is the mass"
   data I_M;"in Kg, Mu is the Damping factor (Ns/m), K is the spring constant (N/m) and Fk "
   data I_M;"is the kinetic friction factor (no units).",""
   data I_M;"You specify these parameters and press the 'Plot' button to generate the"
   data I_M;"plot of the system behavior. An additional parameter is for how many seconds"
   data I_M;"you want the plot to be generated. Also you enter the initial deflection.",""
   data I_M;"To change a parameter click on the box. A dialog box will prompt you for the"
   data I_M;"value. Enter the value and press OK, if you press Cancel the value will not"
   data I_M;"be changed. Once you have changed all the parameters you want, press the 'Plot'"
   data I_M;"button to view the solution of the differential equation. The plot shows the "
   data I_M;"velocity and position of the mass during the time period.",""
   data I_M;"Once a plot is generated, an animation will commence showing the behavior of"
   data I_M;"system in HALF real time. The time span is about half the actual time span."
   data I_M;"This is so that the animation does not take too much time. You can stop the"
   data I_M;"animation at any stage by pressing the button. Once the animation is terminated"
   data I_M;"you can start it again using the button. Other buttons do not functon during"
   data I_M;"the animation so that you have to terminate the animation if you want to "
   data I_M;"do other actions. The pointer on the floor indicates the end of the spring when"
   data I_M;"not stretched or compressed."
   //n=MsgBox(I_M)
Return
//================================================================
