MainProgram:
  GoSub Initialize
  GoSub MonitorInputs
End
//====================
Initialize:
   xytext 5,10,"Value(X)Frequency(Y)","",10,fs_Bold
   dim Vals[2,10]
   For i=0 to 9
     n= random(50)
     Vals[0,i] = n
     Vals[1,i] = 1
     AddEdit "Vals0"+i,10,30+20*i,50,20,ToString(n),""
     AddEdit "Vals1"+i,65,30+20*i,50,20,"1",""
   next
   Data Buttons;"Calc. Stats","Sort","Randomize"
   for i= 0 to MaxDim(Buttons,1)-1
      Addbutton Buttons[i],120,60+25*i,100
   next   
   data Stats;"Count","Sum","Minimum","Maximum","Range","Average"
   data Stats;"Variance","Std Dev","Corr. Coeff.","Formula"
   for i=0 to Maxdim(Stats,1)-1
      xyText 210,10+i*15,JustifyR(Stats[i]," ",15)+":","",10,fs_Bold
   next
Return
//====================
MonitorInputs:
   while true
     GetButton btn
     if btn == Buttons[0] then GoSub Calculate
     if btn == Buttons[1] then GoSub SortData
     if btn == Buttons[2] then GoSub Randomize
     for j=0 to 1
       mm = "Vals"+j
       for i=0 to 9
          m = mm+i
          if EditHasFocus(m) then continue
          if !EditChanged(m) then continue
          n = ToNumber(GetEdit(m))
          if !IsNumber(n) then n = 0
          SetEdit m,ToString(n) \ Vals[j,i] = n
          n = EditChanged(m)
       next
     next 
   wend
Return
//====================
Calculate:
   dim StatsCalcs[0]
   data StatsCalcs;Count(Vals),Sum(Vals),Min(Vals),Max(Vals),Range(Vals),Average(Vals)
   data StatsCalcs;Variance(Vals),StdDev(Vals)
   for i=0 to maxdim(StatsCalcs,1)-1
      xystring 340,10+i*15,StatsCalcs[i]
   next
   r = -10 \ xystring 340,130,spaces(70)
   OnError CorrErr
   r = CorrCoef(Vals)
   OnError
   if r > -10 then xystring 340,130,r
   xyText 340,145,spaces(50),"",15
   a = "" \ b = ""
   OnError RegrErr
   mRegression Vals,a,b
   OnError 
   if vType(a) != String 
      m = "X+"
      if(b<0) then  m = "X-"
      xyText 340,145,"Y=","",15,fs_Bold
      xyString -1,150,a
      xyText -1,145,m,"",15,fs_Bold
      xyString -1,150,abs(b)
   endif   
Return
//====================
Randomize:
   For i=0 to 9
      m = "Vals0"+i
      n = Random(50)
      Vals[0,i] = n
      SetEdit m,ToString(n)
      m= EditChanged(m)  
   next
   For i=0 to 9
      m = "Vals1"+i
      SetEdit m,"1"
      Vals[1,i] = 1
      m= EditChanged(m)  
   next
Return
//====================
SortData:
   mSort Vals,0
   for j=0 to 1
      mm = "Vals"+j
      For i=0 to 9
         m = mm+i
         SetEdit m,ToString(Vals[j,i])
         m= EditChanged(m)  
      next
   next
Return
//====================
CorrErr:
      xyString 340,130,"Data Not Valid"
Return
//====================
RegrErr:
      xyText 340,145,"Data Not Valid","",15
Return
//====================