/**************************************************
  notice the binary include file and the normal include file.
  also notice that since I1_.Bas has an include statement to
  include I2.Bas then it will also be included
**************************************************/
#Include "I1_.Bas","I3.Bas"

Print "Calling I1_Test:"
Call I1_Test(1)

/**************************************************
  Notice this include statement here will not 
  do anything since I2.Bas is already included implicityly 
  due to the inclusion of it within I2_.Bas
  thus RB will detect that and will not include the file again
**************************************************/
#Include "I2.bas"

Print "Calling I2_Test:"
Call I2_Test(2)

/**************************************************
  Notice this include statement will cause an error
  since it includes I2_.Bas and RB is unable to realize that 
  I2_.Bas is really the same as I2.Bas but is binary.
  so you still need to make sure to avoid such things yourself.
  The error is caused since the files (binary and text) will be
  appended and since both have the same Sub names there will be 
  an error
  -----uncomment it to see how the error is caused.
**************************************************/
//#Include "I2_.Bas"

Print "Calling I3_Label:"
n = 3
GoSub I3_Label

/**************************************************
notice how that even though there is no End statement at the end
of this program there will be no porblem since RB will put one when 
the include files are appended and thus there is no risk of this program's
flow continuing to flow into the appended code.
**************************************************/


