//--Figure 9.3
//-----Constants
  TableColor            = White
  F_RandomTurn          = 3
  F_RandomTurn_Percent  = 10
  LineAvoidA            = 3
  LA_RandomTurn         = 3
  TurnAroundA           = 60 
//=============================================================
MainProgram:
  GoSub SetTable
  rlocate 100,100,90
  rInvisible Gray  //---no cheating
 GoSub TableRoam
End
//=============================================================
//--  Roam On Table for ever
//=============================================================
TableRoam:
  while true
    GoSub TestSensors
    S = Sensors
    If not S
      If not (rBumper() & 4)  
        //---only forward if no obstacles
        rForward 1
        if random(10000) < 10000%F_RandomTurn_Percent
          //--add a bit of turning for better coverage
          rTurn random(F_RandomTurn)
        endif
      else
        gosub Reverse  //--avoid obstacle
      endif
    elseif ((S & 24) AND not(S & 3)) 
      //-- only left sensors and not right sensors
      //-- don't care about front sensor
      rTurn LineAvoidA+random(LA_RandomTurn)
    elseif ((S & 3) AND not(S & 24)) 
      //-- only right sensors and not left sensors
      //-- don't care about front sensor
      rTurn -(LineAvoidA+random(LA_RandomTurn))
    else
      //---catch all other conditions
      rTurn 180-TurnAroundA/2+random(TurnAroundA)
    endif
  wend
Return
//=============================================================
//-- Creates 5 ground sensors
//=============================================================
TestSensors:
  Sensors = 0
  for i = 0 to 4
     if rGroundA(90-i*45) <> TableColor 
        Sensors = Sensors | (2^i)
     endif
  next
return
//=============================================================
//-- Makes a random reverse and turn
//=============================================================
Reverse:
  for i = 1 to (random(10)+10) 
    //--reverse so long no object on the 
    //--back and only max 20 pixels
    if rBumper() & 1 then break
    rForward -1
  next
   //--turn min 45 degrees max 90
  //-- in a random direction
  if random(1000) >= 500
    rTurn 90-random(45)
  else
    rTurn -90+random(45)
  endif
return
//=============================================================
//--Sets the table environment 
//=============================================================
SetTable:
  rectangle 0,0,800,600,gray,gray
  rectangle 50,50,650,550,TableColor,TableColor
  circle 200,200,250,250,black,black
  circle 400,400,450,450,blue,blue
  rectangle 250,400,300,480,magenta,magenta
  rectangle 450,300,480,410,cyan,cyan
return
//=============================================================
