//--Figure 9.4 and 9.6
//-----Constants
  F_RandomTurn          = 3
  F_RandomTurn_Percent  = 10
  LA_RandomTurn         = 3
  LineAvoidA            = 3
  TurnAround            = 60 
  BoundaryColor         = Gray
//=============================================================
MainProgram:
  GoSub DrawBoundary
  GoSub SetEnvironment
  rlocate 330,200
  rInvisible BoundaryColor  //---no cheating
  GoSub RoamAround
End
//=============================================================
//---move around for ever
//=============================================================
RoamAround:
 While true
  GoSub TestViolation
  S = Violation
  If not S
    if not(rBumper() & 4)  
      //---only forward if no obstacles
      rForward 1
      if random(10000) < 10000%F_RandomTurn_Percent
        //--add a bit of turning for better coverage
        rTurn random(F_RandomTurn)
      endif
    else
      gosub Reverse  //--avoid obstacle
    endif
    continue  //--go back to top of loop
  endif
  gosub Reverse
 wend
Return
//=============================================================
//-- Makes a random reverse and turn
//=============================================================
Reverse:
  for i = 1 to (random(10)+10) 
    //--reverse so long no object on the 
    //--back and only max 20 pixels
    if rBumper() & 1 then break
    rForward -1
  next
  //--turn min 45 degrees max 90
  //-- in a random direction
  if random(1000) >= 500
    rTurn 90-random(45)
  else
    rTurn -90+random(45)
  endif
return
//=============================================================
//--Sets the environment 
//=============================================================
SetEnvironment:
  circle 200,200,250,250,black,black
  circle 400,400,450,450,blue,blue
  rectangle 250,400,300,480,magenta,magenta
  rectangle 450,300,480,410,cyan,cyan
return
//=============================================================
//-- define & draw the boundary
//=============================================================
DrawBoundary:
  LineWidth 1 
  setcolor BoundaryColor
  Data Boundary; -89,  77,  255,  34,  685,  64
  Data Boundary; 766, 210,  665, 333,  721, 451
  Data Boundary; 740, 565,  341, 566,   28, 495
  Data Boundary; 125, 313,   39, 242,  105, 194
  Data Boundary;  46, 111,   89,  77
  MPolygon Boundary
  Boundary[0] = -Boundary[0]
  setcolor black
return
//=============================================================
//---test to see if crossinf the boundary
//=============================================================
TestViolation:
  Violation = false
  rGPS Rx,Ry
  for j = 1 to MaxDim(Boundary,1)/2 -1 //--for each line
    mm = (j-1)*2
    X1 = Boundary[mm]
    Y1 = Boundary[mm+1]
    X2 = Boundary[mm+2]
    Y2 = Boundary[mm+3]
    //--Line formula Y = mX+b
    m = 1.0*(Y2-Y1)/(X2-X1)
    b = Y1-m*X1
    //--quadratic X=(-B+Sqrt(B*B-4*A*c))/2/A
    //--          X=(-B-Sqrt(B*B-4*A*c))/2/A
    //--if there is a solution then the
    //--circle and line intersect (possibly)
    A = 1+m^2
    B = 2*m*(b-Ry)-2*Rx
    C = Rx^2+(b-Ry)^2-625 //625=(20+5)^2
    BB = B^2-4*A*C
    if (BB) >= 0 
      BB = Sqrt(BB)
      XX1 = (-B+BB)/2/A  //--first intercept
      XX2 = (-B-BB)/2/A  //--second intercept
      //--check if intercept is actual
      //--not on extended line
      if Within(XX1,X1,X2) OR Within(XX2,X1,X2)
        Violation  = true
        break //no need to check any more boundary lines
      endif
    endif
  next
return
//=============================================================
