//Figure 11.4A & 11.4B

//---Variables
   TurnDirection = 0
   TurnAmount    = 1
   MaxTurnAmount = 3

   ResetPercentTime   = 1
   MaxTurnPercentTime = 30
   TurnPercentTime    = 0
//=============================================================
MainProgram:
  GoSub DrawOffice
  GoSub InitRobot
  gosub MoveRobot
End
//=============================================================
InitRobot:
  RR = 11
  LnClr = Cyan
  rlocate 400,300,random(360),RR
  rInvisible LnClr
  rpen down
  linewidth (RR-3)*2
Return
//=============================================================
DrawOffice:   
  LineWidth 15 
  Data Walls;-165,140,165,0,-357,245,0,245,-590,513,590,600
  Data Walls;-165,140,255,140,-360,140,517,140
  Data Walls;-644,140,797,140,-517,140,517,0,-474,245,699,245
  Data Walls;-474,246,474,419,797,419,-357,247,357,470,113,470
  MPolygon Walls

  Cabinet_H = "rrrddddllluuuu"
  Cabinet_V = "dddlllluuurrrr"
  Desk_H    = "rrrrrrrrrrdddddlllluuuulllllddddluuuuu"
  Desk_V    = "ddddddddddllllluuuurrrruuuuullllurrrrr"
  linewidth 1
  //Desks & Cabinets Locations
  Data Furniture; "CH",478,0,"CH",597,559,"CH",769,370
  Data Furniture; "CH",0,252,"CH",551,559,"CH",0,0
  Data Furniture; "CV",564,0,"CV",40,569,"CV",214,569
  Data Furniture; "CV",548,569,"CV",169,569,"CV",156,0
  Data Furniture; "DV",348,300,"DV",800,496,"DV",800,0
  Data Furniture; "DH",481,252,"DH",259,0
  //Draw them
  For I = 0 to MaxDim(Furniture,1)-1 step 3
     if Furniture[I] = "CH" then ss = Cabinet_H
     if Furniture[I] = "DH" then ss = Desk_H
     if Furniture[I] = "CV" then ss = Cabinet_V
     if Furniture[I] = "DV" then ss = Desk_V
     DrawShape ss,Furniture[I+1],Furniture[I+2],10
  next
  //Shade them
  Data FF_Furniture;10,-17,10,-271,488,-21,573,-579,782,-395        
  Data FF_Furniture; 612,-585,140,-19,544,-24,22,-584,151
  Data FF_Furniture; -586,198,-580,530,-591,337,-34,776,-80
  Data FF_Furniture; 323,-388, 565,-274, 772,-580
  MPolygon FF_Furniture,gray

  //Tables
  Circle 59,69,109,119,darkgray,darkgray
  Circle 118,329,168,379,darkgray,darkgray
  //Chairs
  Data Chairs;275,67,699,16,500,319,245,316,693,512,75,279
  for I = 0 to MaxDim(Chairs,1)-1 step 2
     X = Chairs[I]
     Y = Chairs[I+1]
     Sp = 35  //leg spacing
     LD = 4   //leg diameter
     Cl = Brown  //color for legs
     Circle X,Y,X+LD,Y+LD,Cl,Cl
     Circle X+Sp,Y,X+Sp+LD,Y+LD,Cl,Cl
     Circle X,Y+Sp,X+LD,Y+Sp+LD,Cl,Cl
     Circle X+Sp,Y+Sp,X+Sp+LD,Y+Sp+LD,Cl,Cl
  next
Return
//=============================================================
MoveRobot:
  m =1
  while true
     F = rFeel()
     if F
       if F&3 and !(F&24) 
            m = -1
       elseif F&24 and !(F&3)
             m = 1
       else
           m = -1
           if random(10000) < 5000 then m = 1
       endif
       rTurn m*(random(4000)/1000+1)
     endif
     while rBumper()&4 
        rturn m
     wend
     GoSub ForwardRobot
  wend
return
//=============================================================
ForwardRobot:
  rForward 1
  //now see if we need to turn too
  GoSub TestSensors
  if Sensors = 0  //fully new area
    TurnPercentTime = 0 //recent %time
    TurnDirection = 0  //no turn
    TurnAmount = 1     //reset amount
  else
    //increment %time but to a maximum
    TurnPercentTime = TurnPercentTime+1
    if TurnPercentTime > MaxTurnPercentTime
       TurnPercentTime = MaxTurnPercentTime
    endif
    //turn right unless we need to turn left
    TurnDirection = 1
    if Sensors = 31   //fully old area
      //increment turn amount but to a maximum
      TurnAmount = TurnAmount+1
      if TurnAmount > MaxTurnAmount
         TurnAmount = MaxTurnAmount
      endif
      //random turn direction
      if random(10000) < 5000 then TurnDirection = -1
    elseif Sensors&3 and !(Sensors&24)
      //if painted area on right turn left
      //no need to check for left since turndir is set to
      //right by default
      TurnDirection = -1
    elseif Sensors = 4 
      //if painted area is only straight ahead
      //randomize the direction
      if random(10000) < 5000 then TurnDirection = -1   
    endif
  endif
  //if not correct percent of time 
  //turn off turning
  if random(100000) > 100000%TurnPercentTime
     TurnDirection = 0
  endif
  //reset the %time for turning on occasion
  if random(100000) < 100000%ResetPercentTime
     TurnPercentTime = 0
  endif
  //make the turn if required
  if TurnDirection <> 0
     rTurn sign(TurnDirection)*TurnAmount
  endif
Return
//=============================================================
//-- Creates 5 ground sensors
//-- at +/-90, +/-45 and 0 degrees
TestSensors:
  Sensors = 0
  for TS_i = 0 to 4
     if rGroundA(90-TS_i*45) = LnClr
        Sensors = Sensors | (2^TS_i)
     endif
  next
return
//=============================================================
