//Figure 11.6

//---Variables
   TurnDirection      = 0
   TurnAmount         = 1
   MaxTurnAmount      = 3
   ResetPercentTime   = 1
   MaxTurnPercentTime = 30
   TurnPercentTime    = 0
   RR      = 15    //robot's radius
   LnClr   = Cyan  //pen color
   BrdrClr = white //border color
//=============================================================
MainProgram:
  GoSub DrawLawn
  GoSub InitRobot
  gosub MoveRobot
End
//=============================================================
InitRobot:
  rlocate 400,300,30,RR
  rInvisible LnClr,LightGreen
  rpen down
  linewidth (RR-2)*2
Return
//=============================================================
DrawLawn:   
    LineWidth 4
    SetColor lightgreen
    Data Lawn; -44,  58,  173,  28,  534,  45
    Data Lawn; 753, 182,  744, 516,  520, 510
    Data Lawn; 402, 574,  401, 574,   60, 552
    Data Lawn;  35, 406,   43,  59,  589, -255
    MPolygon Lawn,lightgreen

    LineWidth 2
    SetColor black
    Data FlowerBed; -589, 255,  566, 228,  510, 209
    Data FlowerBed;  442, 218,  424, 245,  426, 284
    Data FlowerBed;  459, 296,  500, 281,  519, 280
    Data FlowerBed;  534, 290,  550, 305,  577, 306
    Data FlowerBed;  602, 283,  589, 256,  521,-271
    MPolygon FlowerBed,brown

    Data Trees; 129, 453,  257, 280,  90, 245
    Data Trees; 182, 134,  600, 400, 316, 450
    Data Trees; 391,  94
    DP_D = 50
    for DP_I = 0 to MaxDim(Trees,1)-1  Step 2
         DP_X = Trees[DP_I]
         DP_Y = Trees[DP_I+1]
         Circle DP_X,DP_Y,DP_X+DP_D,DP_Y+DP_D,black,brown
    next   
Return
//=============================================================
MoveRobot:
  m =1
  while true
    Gosub CheckBorder
    If Borders
      if Borders & 24 and !(Borders & 3)
         rTurn (5+random(5))
      elseif Borders & 3 and !(Borders & 24)
         rTurn -(5+random(5))
      else   
         GoSub Reverse
      endif
    else
      F = rFeel()
      if F
        if F&3 and !(F&24) 
           m = -1
        elseif F&24 and !(F&3)
           m = 1
        else 
           m = -1
           if random(10000) < 5000 then m = 1
        endif
        rTurn m*(random(4000)/1000+1)
      endif      
    endif
    if (rBumper()&4) or (rFeel()&12)
        TurnDir = -1  //left
        gosub WallFollow
    elseif (rBumper()&4) or (rFeel()&6)
        TurnDir = 1  //right
        gosub WallFollow
    endif
    while rBumper()&4 
      rturn m
    wend
    GoSub ForwardRobot
  wend
return
//=============================================================
ForwardRobot:
  rForward 1
  //now see if we need to turn too
  GoSub TestSensors
  if Sensors = 0  //fully new area
    TurnPercentTime = 0 //recent %time
    TurnDirection = 0  //no turn
    TurnAmount = 1     //reset amount
  else
    //increment %time but to a maximum
    TurnPercentTime = TurnPercentTime+1
    if TurnPercentTime > MaxTurnPercentTime
       TurnPercentTime = MaxTurnPercentTime
    endif
    //turn right unless we need to turn left
    TurnDirection = 1
    if Sensors = 31   //fully old area
      //increment turn amount but to a maximum
      TurnAmount = TurnAmount+1
      if TurnAmount > MaxTurnAmount
         TurnAmount = MaxTurnAmount
      endif
      //random turn direction
      if random(10000) < 5000 then TurnDirection = -1
    elseif Sensors&3 and !(Sensors&24)
      //if painted area on right turn left
      //no need to check for left since turndir is set to
      //right by default
      TurnDirection = -1
    elseif Sensors = 4 
      //if painted area is only straight ahead
      //randomize the direction
      if random(10000) < 5000 then TurnDirection = -1   
    endif
  endif
  //if not correct percent of time 
  //turn off turning
  if random(100000) > 100000%TurnPercentTime
     TurnDirection = 0
  endif
  //reset the %time for turning on occasion
  if random(100000) < 100000%ResetPercentTime
     TurnPercentTime = 0
  endif
  //make the turn if required
  if TurnDirection <> 0
     rTurn sign(TurnDirection)*TurnAmount
  endif
Return
//=============================================================
//-- Creates 5 ground sensors
//-- at +/-90, +/-45 and 0 degrees
//=============================================================
TestSensors:
  Sensors = 0
  for i = 0 to 4
     if rGroundA(90-i*45) = LnClr
        Sensors = Sensors | (2^i)
     endif
  next
return
//=============================================================
CheckBorder:
   Swap BrdrClr,LnClr   
   GoSub TestSensors
   Swap BrdrClr,LnClr   
   Borders = Sensors
return
//=============================================================
Reverse:
  for i = 1 to (random(10)+10) 
    //--reverse so long no object on the 
    //--back and only max 20 pixels
    if rBumper() & 1 then break
    rForward -1
  next
   //--turn min 45 degrees max 90
  //-- in a random direction
  if random(1000) >= 500
    rTurn 90-random(45)
  else
    rTurn -90+random(45)
  endif
return
//=============================================================
WallFollow: 
  rTurn TurnDir*random(150)
  while !rSense()
    while (rFeel() & 6) or (rBumper() &6)
      rTurn TurnDir
    wend
    if rBumper() &4 then return
    rForward 1  // forward always to prevent stall
    if rFeel()=1 or rFeel()=0  // too far from wall or no wall
      while not rFeel() // turn back quickly to find wall again
        rTurn -TurnDir*5
        rForward 1
      wend
    endif
  Wend
return
//=============================================================
