//---Figure 13.5
//---Variables & Constants
  LOW_LEVEL   = 65
  MAX_CHARGE  = 100
  BeaconX     = 600
  BeaconY     = 520
  Battery     = 0

//========================================
MainProgram:
  GoSub SetEnvironment
  While true
    gosub RoamAround
    gosub FindBeacon
    gosub FollowLine
    gosub ChargeBattery
  wend
End
//========================================
SetEnvironment:
  // Draw four circles and four squares
  for i=1 to 4
     SetColor Black
     LineWidth 4
     x = random(420) + 120
     y = random(250)+60
     size = random(50)+50
     circle x,y,x+size,y+size
     x = random(450)+100
     y = random(250)+100
     size = random(100)+50
     rectangle x,y,x+size,y+size
  next
  //--draw docking line
  SetColor Green
  LineWidth 2
  gotoxy BeaconX+100,BeaconY
  lineto BeaconX+50,BeaconY
  Lineto BeaconX,BeaconY-20
  Lineto BeaconX-50,BeaconY-20
  Line BeaconX-50,BeaconY+20,BeaconX,BeaconY+20
  Lineto BeaconX+50,BeaconY
  Arc BeaconX-70,BeaconY-20,BeaconX-30,BeaconY+20,DtoR(90),DtoR(180)
  //draw beacon
  circle BeaconX-30,BeaconY-10,BeaconX-10,BeaconY+10,red,red
  //draw charging station
  Rectangle BeaconX+105,BeaconY-12,BeaconX+180,BeaconY+12,blue,blue
  SetColor White,Blue
  xyString BeaconX+110,BeaconY-10,"CHARGER"
  //--Battery meter
  SetColor Black,White
  LineWidth 3
  Rectangle 0,0,76,130,black
  gotoxy 1,123-LOW_LEVEL
  LineTo 75,123-LOW_LEVEL,3,Brown
  SetColor Black,White
  xyString 5,2,"BATTERY"
  //--charge the robot initially
  GoSub PlaceRobot
  GoSub SimulateCharging
return
//========================================
PlaceRobot:
  rLocate BeaconX+80,BeaconY,-90
  // designate the beacon and line colors as non-objects
  rInvisible Green,Red
  rIgnoreCharge False
Return
//========================================
RoamAround:
  while true
    GoSub BatteryMeter
    if Battery < LOW_LEVEL then return
    // forward until an object is found
    while not (rFeel( )&14) AND not (rBumper()&14))
       rForward 1
    wend
    D=random(100)
    for i=0 to random(50)+50
      if D>50
        rTurn 1
      else
        rTurn -1
      endif
    next 
  wend
return
//========================================
FindBeacon:
  cnt=0
  Repeat
    GoSub BatteryMeter
    cnt=cnt+1
    gosub FaceBeacon
    if cnt <20
      gosub ForwardTillBlocked
      // decide to follow left or right
      if (cnt=1) and (rFeel()&8) then cnt=10
      if (cnt<10) or (random(20)<2) 
        TurnDir = -1
      else
        TurnDir = 1
      endif 
      GoSub GoAround
    else
      gosub UnStick
      cnt=0
    endif
  Until rSense()&2 // Line Found
Return
//========================================
FaceBeacon:
  while not rBeacon(Red)
    rTurn 1
  wend
  // Show battery condition
  GoSub BatteryMeter
return
//========================================
ForwardTillBlocked:
  while not (rFeel() & 14) AND not (rBumper() & 14)
    rForward 1
    if rSense() then break
  wend    
  GoSub BatteryMeter
return
//========================================
GoAround: 
  if rSense() then return
  If TurnDir > 0 
     FN = 6
  Else
     FN = 12
  Endif
  for i=1 to 20 + random(250)
     While (rFeel()&FN) or (rBumper()&4)
       rTurn -TurnDir
     Wend
     rForward 1
     rTurn TurnDir
  Next
Return
//========================================
UnStick:
  if random(100)<50 then rTurn 180
  for i=0 to 100+random(200)
     while not(rbumper()&14) 
        rForward 1
     wend 
     rTurn random(8)-3
  next
Return
//========================================
FollowLine:
  while rFeel()=0
    rForward 1
    while rSense() & 1
      rTurn 1
    wend
    while rSense() & 4
      rTurn -1
    wend
  wend
Return
//========================================
ChargeBattery:
  rTurn 180
  while not rBumper()
    rForward -1
  wend
  GoSub SimulateCharging
Return
//========================================
SimulateCharging:
  SetColor LightMagenta
  for i= Battery to MAX_CHARGE
   gotoxy 5,125-i
   lineto 70,125-i
   Delay 100
   gotoxy 1,123-LOW_LEVEL
   LineTo 75,123-LOW_LEVEL,3,Brown
  next
  rCharge MAX_CHARGE
  Battery = MAX_CHARGE
Return
//========================================
BatteryMeter:
   // Show battery condition
   Battery=rChargeLevel()
   SetColor White
   gotoxy 5,120-Battery
   lineto 70,120-Battery
   gotoxy 1,123-LOW_LEVEL
   LineTo 75,123-LOW_LEVEL,3,Brown
Return
//========================================
