//Figure 14.4
//---Variables
    GoalClr = Red
    LnClr = Cyan
//=============================================================
MainProgram:
   FirstTime = true
   GoSub DisplayInstructions
   while true
     GoSub PlotMaze
     GoSub PlaceRobot
     GoSub SelectGoal
     GoSub SolveMaze
     FirstTime = false
     Message = "Goal Found---Press Any-Key or Right-Mouse"
     Message = Message + "-Button to repeat with same maze"
     GoSub DisplayMessage
     Beep
     GoSub WaitForKeyOrMouse
   wend
end
//=============================================================
WaitForKeyOrMouse:
  repeat
    readmouse x,y,b
    getkey k
  until k <>0 Or b = 2
return
//=============================================================
DisplayInstructions:
  data IM;"Figure14.04.Bas"
  data IM;"This program creates a random Line-Maze then allows"
  data IM;"you to place the robot anywhere on the maze by"
  data IM;"clicking the Left-Mouse-Button on that position.",""
  data IM;"Keep the mouse button down to make the robot rotate"
  data IM;"to the desired direction. Always make sure the robot"
  data IM;"is facing a line not empty space.",""
  data IM;"Then select any position on the maze to place the"
  data IM;"goal to be found.",""
  data IM;"If there is no connection between the place where"
  data IM;"the robot is and where the goal is then it will not"
  data IM;"be possible for the robot to reach the goal."
  n = MsgBox(IM)
return
//=============================================================
PlotMaze:  
  SetColor Black,White
  ClearScr
  if FirstTime then Dim Maze[5,7] 
  For i = 0 to 4
    for j = 0 to 6
      S = 0
      If not FirstTime then S=Maze[i,j]
      X =(j+1)*100
      Y =(i+1)*100
      for k = 0 to 3
        if FirstTime and (random(10000)<8000) then S=S|(2^k)
        if S & (2^k)
          GotoXY X,Y        
          dX = 55*round(cos(Pi(k)/2))
          dY = -55*round(sin(Pi(k)/2))
          LineTo X+dX,Y+dY,4,LnClr
        endif
      next   
      if FirstTime then Maze[i,j] = S
    next
  next
return
//=============================================================
PlaceRobot:
   Message ="Place Robot"
   GoSub DisplayMessage
   while true
     readmouse x,y,b
     if b = 1
       ReadPixel x,y,pc
       if pc = LnClr then break 
     endif
   wend
   //make sure is on center of line
   xx = x#100
   if within(xx,96,104) 
       x = (x/100+1)*100
   endif
   //make sure is on center of line
   yy = y#100
   if within(yy,96,104) 
       y = (y/100+1)*100
   endif
   Rx = x
   Ry = y
   rLocate Rx,Ry,90
   rInvisible LnClr
   repeat
     delay 400 //allow for too long press
     readmouse x,y,b
     if b = 1 then rTurn 90
   until b <> 1
   while not rSense()
      rTurn 90
   wend
return
//=============================================================
SelectGoal:
   Message = "Select Goal"
   GoSub DisplayMessage
   while true
     readmouse x,y,b
     if b = 1
       ReadPixel x,y,pc
       if pc = LnClr then break 
     endif
   wend
   Gx = x
   Gy = y
   Circle Gx-6,Gy-6,Gx+6,Gy+6,GoalClr,GoalClr
return
//=============================================================
DisplayMessage:
  Rectangle 0,0,800,20,white,white
  Rectangle 0,0,Length(Message)*10,20,Blue,Blue
  SetColor Yellow,blue
  xystring 2,2,Message
  SetColor black,White
return
//=============================================================
SolveMaze:
  Message ="Searching"
  GoSub DisplayMessage
  while true
    S= rSense()
    if S = 0
       rTurn 180
    elseif S &5
       GoSub MakeATurn
       rTurn m
    endif
    if rBumper() then break
    rForward 1
  wend
return
//=============================================================
MakeATurn:
  for MT_i = 1 to 20 
    if !(rBumper()&4)
      rForward 1
    else
      m=0
      return
    endif
  next
  m = 90
  if rSense() <> 0
     Prcnt = 5000
     for MT_i = -45 to 45
         if rLook(MT_i) = GoalClr
            Prcnt = 500
            break
         endif
     next
     if random(10000) > Prcnt 
        m = 0
        return
     endif
  endif 
  if S = 7
    Prcnt = 5000
    for MT_i = -135 to -45
       if rLook(MT_i) = GoalClr
          m = -90
          Prcnt = 500
          break
       endif
    next
    if random(10000) < Prcnt then m = -m
  elseif S = 6
    m = -m
  endif    
return
//=============================================================
