//Figure 14.5
// Debugon
// uncomment the above line if you wish to see the robot's
//      "thoughts" as it moves through the maze

//=============================================================
MainProgram:
   gosub DisplayInstructions
   gosub PlotMaze
   gosub SolveMaze
   gosub RetraceMaze
End
//=============================================================
DisplayInstructions:
  data IM;"Figure14.05.Bas"
  data IM;"This program creates a random Corridor-Maze then puts"
  data IM;"the robot at one end. The robot will move through the"
  data IM;"maze until it sees the red wall at the other end.",""
  data IM;"The robot saves all its moves and remembers the ones"
  data IM;"that work. ",""
  data IM;"The second time through, the robot will negotiate the"
  data IM;"the maze perfectly leaving a trail behind it showing"
  data IM;"the path it took."
  n = MsgBox(IM)
Return
//=============================================================
PlotMaze:
  ClearScr
  LineWidth 3
  // draw basic blocks
  y=60
  for j=0 to 3
    x=80
    for i=0 to 4
      gosub DrawPiece
      x=x+119
    next  
    y=y+119
  next
  gotoxy 678,536
  lineto 740,536
  lineto 740,362
  SetColor Red
  lineto 678,362
  SetColor White
  LineWidth 4
  // open doors between blocks
  y=60
  for j=0 to 3
    x= 200
    for i=0 to 4
      nn=random(10)
      if (nn<5 and i<4) or j=3
        gotoxy x,y+60
        n=random(10)
        if n<5 then lineto x,y+3
        if n>=5 then lineto x,y+120-3
      else
          gotoxy x-60,y+120
          n=random(10)
          if n<5 then lineto x-120,y+120
          if n>=5 then lineto x,y+120
      endif
      x=x+119
    next
    y=y+119
  next
  gotoxy 80,60
  lineto 80,120
  rLocate 108-60,90
  rTurn 90
Return
//=============================================================
DrawPiece:
  // draw 4 cell piece at x,y
  rectangle x,y,x+120,y+120
  // draw a random line
  gotoxy x+60,y+60
  n=Random (4)
  if n=0 then lineto x+60,y
  if n=1 then lineto x+60,y+120
  if n=2 then lineto x,y+60
  if n=3 then lineto x+120,y+60
Return
//=============================================================
SolveMaze:
  Dim Stack[100,4] //100 records of Compass,Turn,gpsX,gpsY
  StackPtr = 0
  rForward 60
  while rLook() <> Red
    // determine if current cell has more than one exit
    numExits = 0
    dir = 0
    cnt = 0
    if not(rFeel()& 16)
       cnt = cnt+1
       dir = 4 // left side
    endif
    if not(rFeel() & 4)
       cnt = cnt+1
       dir = dir+2 // straight ahead
    endif
    if not(rFeel() & 1)
       cnt = cnt+1
       dir = dir+1 // right side
    endif
    // if there is only one exit, take it
    if cnt = 1
       if dir=4 then rTurn -90
       if dir=1 then  rTurn  90
       rForward 60
       continue
    endif
    if cnt = 0 // no exit, turn around and go back
       rTurn 180
       rForward 60
       continue
    endif
    // there are multiple exits to this cell
    // see if we have been here before
    gosub CheckBefore
    if yep
debug "been here before"
      // been here before so take the other route
      // first face the saved direction
      while rCompass() <> Stack[StackPtr-1,0]
        rTurn 90
      wend
debug "now facing original direction"
      // must get and resave stack data to elminate wrong turns
      // get original dir
      dir = Stack[StackPtr-1,1]
      // check to see if multiple choices still exist
      if dir=3 or dir=5 or dir=6 or dir=7
         if dir & 4 // left was the first choice taken
            dir =dir & 3  // eliminate first choice 
                          // could still be straight or right
         else // check to see if straight was a possibility
            dir = 1 // orig. dir had to be 3
         endif
         Stack[StackPtr-1,1]=dir // save it again
debug "data resaved with last choice removed ",dir
         // now make the next move
         if dir&2   // 2nd choice must be straight 
            rForward 60
         else   // or a right turn
            rTurn 90
            rForward 60
         endif
      else // this is at least the second time back here
           // but only one choice remains
           // means we have taken all paths and came back
debug "no choices left"
         // get original heading
         while rCompass() <> Stack[StackPtr-1,0]
           rTurn 90
         wend
         rTurn 180 // go back
         rForward 60
         // remove this node
         StackPtr = StackPtr - 1
debug "bad path - choice romoved from stack"
      endif  
    else
      // never been here before and multiple exits
      // Save compass, possible turns, gpsX, gpsY
      Stack[StackPtr,0] = rCompass()
      Stack[StackPtr,1] = dir
      Stack[StackPtr,2] = rGPSx()
      Stack[StackPtr,3] = rGPSy()
      StackPtr = StackPtr+1
      // assume two exits so take first one 
      //(start with left, then CW)
      if dir & 4
        rTurn -90
        rForward 60
      else // forward MUST be first option
        rForward 60
      endif
    endif
  wend
Return
//=============================================================
CheckBefore:
  yep = false
  if StackPtr = 0 then return
  dX = rGPSx()-Stack[StackPtr-1,2]
  dY = rGPSy()-Stack[StackPtr-1,3]
  if PolarR(dX,dY) < 10 then yep = true
Return
//=============================================================
RetraceMaze:
  // now do it again - but no mistakes
  x=rGPSx()  // save current position
  y=rGPSy()
  rLocate 108-60,90 // put robot back in the beginning
  rTurn 90
  SetColor White // and erase old one
  circle x-20,y-20,x+20,y+20
  rPen Down,LightGreen
  rForward 60
  StackPtr = 0
  while rLook()<>Red
    // determine if current cell has more than one exit
    numExits = 0
    dir = 0
    cnt = 0
    if not(rFeel()& 16)
      cnt = cnt+1
      dir = 4 // left side
    endif
    if not(rFeel() & 4)
      cnt = cnt+1
      dir = dir+2 // straight ahead
    endif
    if not(rFeel() & 1)
      cnt = cnt+1
      dir = dir+1 // right side
    endif
    // if there is only one exit, take it
    if cnt = 1
       if dir=4 then rTurn -90
       if dir=1 then  rTurn  90
       rForward 60
       continue
    else
       // take the exit on the stack
       dir = Stack[StackPtr,1]
       if dir & 4
          rTurn -90
       elseif dir&2
          // do nothing
       else
          rTurn 90
       endif
       rForward 60
       StackPtr = StackPtr+1
    endif
  wend
Return
//=============================================================
