//Figure 14.10
//---Variables
    GoalClr = Red
    LnClr = Cyan
//=============================================================
MainProgram:
   FirstTime = true
   GoSub DisplayInstructions
   while true
     GoSub PlotMaze
     GoSub PlaceRobot
     GoSub SelectGoal
     GoSub SolveMaze
     FirstTime = false
     if Found
        Message = "Goal Is Found"
     else
        Message = "Goal Is Unreachable"
     endif
     Message = Message+"---Press Any-Key or Right-Mouse"
     Message = Message + "-Button to repeat with same maze"
     GoSub DisplayMessage
     Beep
     GoSub WaitForKeyOrMouse
   wend
end
//=============================================================
WaitForKeyOrMouse:
  repeat
    readmouse x,y,b
    getkey k
  until k <>0 Or b = 2
return
//=============================================================
DisplayInstructions:
  data IM;"Figure14.01.Bas"
  data IM;"This program creates a random Line-Maze then allows"
  data IM;"you to place the robot anywhere on the maze by"
  data IM;"clicking the Left-Mouse-Button on that position.",""
  data IM;"Keep the mouse button down to make the robot rotate"
  data IM;"to the desired direction. Always make sure the robot"
  data IM;"is facing a line not empty space.",""
  data IM;"Then select any position on the maze to place the"
  data IM;"goal to be found.",""
  data IM;"If there is no connection between the place where"
  data IM;"the robot is and where the goal is then it will not"
  data IM;"be possible for the robot to reach the goal."
  n = MsgBox(IM)
return
//=============================================================
PlotMaze:  
  SetColor Black,White
  ClearScr
  if FirstTime then Dim Maze[5,7] 
  For i = 0 to 4
    for j = 0 to 6
      S = 0
      If not FirstTime then S=Maze[i,j]
      X =(j+1)*100
      Y =(i+1)*100
      for k = 0 to 3
        if FirstTime and (random(10000)<8000) then S=S|(2^k)
        if S & (2^k)
          GotoXY X,Y        
          dX = 55*round(cos(Pi(k)/2))
          dY = -55*round(sin(Pi(k)/2))
          LineTo X+dX,Y+dY,4,LnClr
        endif
      next   
      if FirstTime then Maze[i,j] = S
    next
  next
  MWrite Maze,"Maze.Mz"
return
//=============================================================
PlaceRobot:
   Message ="Place Robot"
   GoSub DisplayMessage
   while true
     readmouse x,y,b
     if b = 1
       ReadPixel x,y,pc
       if pc = LnClr then break 
     endif
   wend
   //make sure is on center of line
   xx = x#100
   if within(xx,96,104) 
       x = (x/100+1)*100
   endif
   //make sure is on center of line
   yy = y#100
   if within(yy,96,104) 
       y = (y/100+1)*100
   endif
   Rx = x
   Ry = y
   rLocate Rx,Ry,90
   rInvisible LnClr
   repeat
     delay 400 //allow for too long press
     readmouse x,y,b
     if b = 1 then rTurn 90
   until b <> 1
   while not rSense()
      rTurn 90
   wend
return
//=============================================================
SelectGoal:
   Message = "Select Goal"
   GoSub DisplayMessage
   while true
     readmouse x,y,b
     if b = 1
       ReadPixel x,y,pc
       if pc = LnClr then break 
     endif
   wend
   Gx = x
   Gy = y
   Circle Gx-6,Gy-6,Gx+6,Gy+6,GoalClr,GoalClr
return
//=============================================================
DisplayMessage:
  Rectangle 0,0,800,20,white,white
  Rectangle 0,0,Length(Message)*10,20,Blue,Blue
  SetColor Yellow,blue
  xystring 2,2,Message
  SetColor black,White
return
//=============================================================
BuildMapGraph:
  Dim MapGraph[35,35]
  MConstant MapGraph,0
  for i = 0 to 4
     for j = 0 to 6
        S = Maze[i,j]
        NN = i*7+j
        if (S&1) and (j<6)
           if Maze[i,j+1]&4
              MapGraph[NN,NN+1] = 1
           endif
        endif              
        if (S&2) and (i>0)
           if Maze[i-1,j]&8
              MapGraph[NN,NN-7] = 1
           endif
        endif              
        if (S&4) and (j>0)
           if Maze[i,j-1]&1
              MapGraph[NN,NN-1] = 1
           endif
        endif              
        if (S&8) and (i<4)
           if Maze[i+1,j]&2
              MapGraph[NN,NN+7] = 1
           endif
        endif              
     next
  next
return
//=============================================================
SolveMaze:
   //get Node Nearest to Goal
   Tx = Gx
   Ty = Gy
   GoSub CalcNodeNumber
   GoalNode  = NodeNumber
   //Get Node Nearest to Robot
   rGPS Tx,Ty
   GoSub CalcNodeNumber
   RobotNode = NodeNumber
   if FirstTime then GoSub BuildMapGraph //Build Graph
   if RobotNode <> GoalNode
      GoSub FindPath //Search Graph
   else
      Found = True
      Sp = 0
   Endif
   If Found 
     if Sp > 0
        For I = 0 to Sp  //for each node on path
           Dnn = Stack[I,0] //destination node number
           x = (Dnn#7 + 1)*100
           y = (Dnn/7 + 1)*100
           GoSub GotoPoint
        next
     else
         x = (RobotNode#7+1)*100
         y = (RobotNode/7+1)*100
         GoSub GotoPoint
     endif
     // go to the actual goal after reaching its 
     // nearest junction
     x = Gx
     y = Gy
     if !rBumper() then GoSub GotoPoint
   endif
return
//=============================================================
CalcNodeNumber:
   //Input----Tx and Ty 
   //Output---NodeNumber
   Tj=Tx/100+Round(frac(Tx/100.0))
   if Tj = 0 then Tj = 1
   if Tj > 7 then Tj = 7
   Ti=Ty/100+Round(frac(Ty/100.0))
   if Ti = 0 then Ti = 1
   if Ti > 5 then Ti = 5
   NodeNumber = (Ti-1)*7+Tj-1 //Node Number
   NodeX      = Tj*100
   NodeY      = Ti*100
   dX = NodeX-Tx
   dY = NodeY-Ty
   if abs(dX) > 35
      ReadPixel NodeX-sign(dX)*12,NodeY,Pc
      if Pc <> LnClr then NodeNumber = NodeNumber-sign(dX)
   endif
   if abs(dY) > 35
      ReadPixel NodeX,NodeY-sign(dY)*12,Pc
      if Pc <> LnClr then NodeNumber = NodeNumber-sign(dY)*7
   endif
return
//=============================================================
FindPath:
   Dim Queue[35]
   QHead = 0
   QTail = 0
   Dim Visited[35,3]
   MConstant Visited,999999
   Queue[QTail] = RobotNode //add to queue
   QTail = QTail+1
   Visited[RobotNode,0] = 1  //visited
   Visited[RobotNode,1] = 0  //distance
   Visited[RobotNode,2] = -1 //predecessor
   while Visited[GoalNode,0]<>1 and QHead < QTail
      v = Queue[QHead]  //deque
      QHead = QHead+1
      For w = 0 to 34
        if MapGraph[v,w] = 1 and Visited[w,0] <> 1
           Visited[w,0]=1
           Visited[w,1] = Visited[v,1]+1
           Visited[w,2] = v
           Queue[QTail] = w //add to queue
           QTail = QTail+1
        endif
      next
   wend
   if Visited[GoalNode,0]  = 1
      Found = true
      dim Stack[35]
      Sp = Visited[GoalNode,1]
      Stack[Sp] = GoalNode
      For FP_i = Sp-1 to 0
        Stack[FP_i] = Visited[Stack[FP_i+1],2]
      next
   else
      Found = false
   endif
return
//=============================================================
GotoPoint:
   dx = x-rGpsX()
   dy = y-rGpsY()
   if dx=0 AND dy = 0 then return
   Theta = PolarA(dx,dy)*180/pi(1)+90-rCompass()
   if Theta > 180 then Theta = Theta-360
   if Theta < -180 Then Theta = Theta+360
   rTurn Theta
   Distance = Round(PolarR(dx,dy))
   For GP_I = 1 to Distance
     if rBumper() & 4 then break
     rForward 1
   next
return
//=============================================================
