//Figure 15.12 obstacle and slip resistant uses GPS
//---Variables
   TimeOutLimit   = 60
   LowChargeLimit = 20
   ChargeDelay    = 2000
   RobotSize      = 15
   LnClr          = Cyan
   BcnClr         = Red
   SlipValue      = 20

//=============================================================
//=============================================================
MainProgrm:
  GoSub DisplayInstructions
  GoSub DrawOffice
  GoSub MapOffice
  GoSub PlaceRobot
  While true
    GoSub WaitForCommand
    GoSub MoveToRoom
  wend
End
//=============================================================
//=============================================================
//--- Subroutine PlaceRobot
//--- Inputs  : BcnClr,LnClr,RobotSize,SlipValue,NodesCount
//--- Outputs : RobotNode
//--- Calls To: none
//-------------------------------------------------------------
PlaceRobot:
  rLocate 558,565,0,RobotSize
  rInvisible LnClr,BcnClr
  rSlip SlipValue
  rIgnoreCharge false
  RobotNode = NodesCount-1
Return
//=============================================================
//=============================================================
//--- Subroutine DrawOffice
//--- Inputs  : none
//--- Outputs : none
//--- Calls To: none
//-------------------------------------------------------------
DrawOffice:   
  ClearScr
  LineWidth 15 
  Data Walls;-165,140,165,0,-357,245,0,245,-590,513,590,600
  Data Walls;-165,140,255,140,-360,140,517,140,-530,513,530,600
  Data Walls;-644,140,797,140,-517,140,517,0,-474,245,699,245
  Data Walls;-474,246,474,419,797,419,-357,247,357,470,113,470
  MPolygon Walls

  Cabinet_H = "rrrddddllluuuu"
  Cabinet_V = "dddlllluuurrrr"
  Desk_H    = "rrrrrrrrrrdddddlllluuuulllllddddluuuuu"
  Desk_V    = "ddddddddddllllluuuurrrruuuuullllurrrrr"
  linewidth 1
  //Desks & Cabinets Locations
  Data Furniture; "CH",478,0,"CH",597,559,"CH",769,370
  Data Furniture; "CH",0,252,"CH",0,0
  Data Furniture; "CV",564,0,"CV",40,569,"CV",214,569
  Data Furniture; "CV",169,569,"CV",156,0
  Data Furniture; "DV",348,300,"DV",800,496,"DV",800,0
  Data Furniture; "DH",481,252,"DH",259,0
  //Draw them
  For I = 0 to MaxDim(Furniture,1)-1 step 3
     if Furniture[I] = "CH" then ss = Cabinet_H
     if Furniture[I] = "DH" then ss = Desk_H
     if Furniture[I] = "CV" then ss = Cabinet_V
     if Furniture[I] = "DV" then ss = Desk_V
     DrawShape ss,Furniture[I+1],Furniture[I+2],10
  next
  //Shade them
  Data FF_Cabinets; 10,-17, 10,-271, 488,-21
  Data FF_Cabinets;782,-395, 612,-585, 140,-19, 544,-24
  Data FF_Cabinets; 22,-584, 151,-586, 198,-580
  MPolygon FF_Cabinets,darkgray
  Data FF_Desks;337,-34, 776,-80, 323,-388, 565,-274
  Data FF_Desks;772,-580
  MPolygon FF_Desks,gray

  //Tables
  Circle 59,69,109,119,darkgray,darkgray
  Circle 118,329,168,379,darkgray,darkgray
  //Charger Station
  Rectangle 558-10,554+35-10,558+10,554+35+10,blue,blue
  //Chairs
  Data Chairs;275,27,699,16,500,319,245,316,723,512,75,279
  for I = 0 to MaxDim(Chairs,1)-1 step 2
     X = Chairs[I]
     Y = Chairs[I+1]
     Sp = 35  //leg spacing
     LD = 4   //leg diameter
     Cl = Brown  //color for legs
     Circle X,Y,X+LD,Y+LD,Cl,Cl
     Circle X+Sp,Y,X+Sp+LD,Y+LD,Cl,Cl
     Circle X,Y+Sp,X+LD,Y+Sp+LD,Cl,Cl
     Circle X+Sp,Y+Sp,X+Sp+LD,Y+Sp+LD,Cl,Cl
  next
  data labels; 34,  0,"Break Room", 370,  0,"Office 1"
  data labels;579,  0,"Office 2"  , 590,253,"Office 3"
  data labels;241,253,"Office 4"  , 652,584,"Office 5"
  data labels;220,584,"HallWay 1" ,  46,584,"HallWay 2"
  setcolor LnClr
  for I=0 to MaxDim(labels,1)-1 step 3
     xystring labels[I],labels[I+1],labels[I+2]
  next
Return
//=============================================================
//=============================================================
//--- Subroutine MapOffice
//--- Inputs  : none
//--- Outputs : MapGraph[], Nodes[], NodesCount
//--- Calls To: FindNode
//---
//--- The Nodes[]array is a data base with name of the 
//--- node and the x,y coordinates of it.
//-------------------------------------------------------------
MapOffice:
  //Rooms 
  Data OF;"BreakRoom" , 35, 99, "Office1" ,345, 83
  Data OF;"Office2"   ,641, 44, "Office3" ,685,346
  Data OF;"Office4"   , 45,351, "Office5" ,660,500
  Data OF;"HallWay1"  ,343,570, "HallWay2", 82,570
  //Doors
  Data OF;"BreakRoom_D", 35, 139, "Office1_D",305, 141
  Data OF;"Office2_D"  ,585, 142, "Office3_D",757, 240
  Data OF;"Office4_D"  , 45, 468, "Office5_D",597, 455
  //Corridors 
  Data OF;"Corridor1" , 35, 186, "Corridor2" ,305, 186
  Data OF;"Corridor3" ,420, 186, "Corridor4" ,585, 186
  Data OF;"Corridor5" ,757, 186, "Corridor6" ,420, 515
  Data OF;"Corridor7" , 45, 515, "Corridor8" ,420, 455
  Data OF;"Corridor9" ,558, 455, "Corridor10",420, 316
  Data OF;"Corridor11",155, 515
  //Charging Station
  Data OF;"ChargeRoom_D",558, 508, "ChargeRoom",558,554

  NodesCount = MaxDim(OF,1)/3
  Dim Nodes[NodesCount,3]
  MCopy OF,Nodes

  Data Edges;"BreakRoom","BreakRoom_D","Corridor1","Corridor2"
  Data Edges;"Office1_D","Office1",-1
  Data Edges;"Office2","Office2_D","Corridor4","Corridor5"
  Data Edges;"Office3_D","Office3",-1
  Data Edges;"Corridor3","Corridor10","Corridor8","Corridor6"
  Data Edges;"HallWay1","Corridor11","Corridor7",-1
  Data Edges;"Office4","Office4_D","Corridor7","HallWay2",-1
  Data Edges;"Office5","Office5_D","Corridor9","ChargeRoom_D"
  Data Edges;"ChargeRoom",-1
  Data Edges;"Corridor2","Corridor3","Corridor4",-1
  Data Edges;"HallWay2","Corridor11","Corridor6","Corridor9"
  Data Edges;"Corridor8",-1
    
  Dim MapGraph[NodesCount,NodesCount]
  MConstant MapGraph,0
  NName = Edges[0]
  GoSub FindNode
  FNode = NodeNumber
  For MO_I = 1 to MaxDim(Edges,1)-2
    If IsNumber(Edges[MO_I])
       NName = Edges[MO_I+1]
       GoSub FindNode
       FNode = NodeNumber
       MO_I = MO_I+2
    Endif
    NName = Edges[MO_I]
    GoSub FindNode
    TNode = NodeNumber
    If FNode >= 0 and TNode >= 0 
       MapGraph[FNode,TNode] = 1
       MapGraph[TNode,FNode] = 1
    Endif
    FNode = TNode
  Next
  //GoSub PlotNodes
Return
//=============================================================
//=============================================================
//--- Subroutine FindNode
//--- Inputs  : NName, NodesCount, Nodes[]
//--- Outputs : NodeNumber
//--- Calls To: none
//---
//--- If Node is not found the NodeNumber will be -1
//--- otherwise it will be the number of the node in the array.
//-------------------------------------------------------------
FindNode:
   NodeNumber = -1
   For FN_I = 0 to NodesCount-1
      If NName = Nodes[FN_I,0]
        NodeNumber = FN_I
        Return
      Endif
   Next
Return
//=============================================================
//=============================================================
//--- Subroutine PlotNodes
//--- Inputs  : MapGraph[], Nodes[]
//--- Outputs : none
//--- Calls To: none
//---
//--- Uses the arrays Nodes[] and MapGraph[]
//--- to plot a network of the nodes and their connections
//--- using the line color.
//-------------------------------------------------------------
PlotNodes:
  For PN_I =0 to NodesCount-1
    SN_X = Nodes[PN_I,1]
    SN_Y = Nodes[PN_I,2]
    Circle SN_X-5,SN_Y-5,SN_X+5,SN_Y+5,LnClr,LnClr
    For PN_J = 0 to NodesCount-1
       if MapGraph[PN_I,PN_J]=1 
         Gotoxy SN_X,SN_Y
         LineTo Nodes[PN_J,1],Nodes[PN_J,2],3,LnClr
       endif
    Next
  Next
Return
//=============================================================
//=============================================================
//--- Subroutine WaitForCommand
//--- Inputs  : LowChargeLimit
//--- Outputs : GoalNode
//--- Calls To: GetTimeInSecs,DockWithCharger,ChooseRoom
//---           
//--- this routine uses ChooseRoom to set the variable
//--- GoalNode which indicates what room the robot is to go.
//-------------------------------------------------------------
WaitForCommand:
   if rChargeLevel()<LowChargeLimit 
     StartTime=-TimeOutLimit
   Else
     GoSub GetTimeInSecs
     StartTime = Tm
   endif
   repeat
     GoSub GetTimeInSecs
     if Tm-StartTime > TimeOutLimit
        GoSub DockWithCharger
        StartTime = 99999
     Endif
     readmouse xx,yy,b
     getkey k
     k = char(k)
     if b = 2 or k="m" or k="M"
       GoSub ChooseRoom
       Break
     endif
   until false
Return
//=============================================================
//=============================================================
//--- Subroutine GetTimeInSecs
//--- Inputs  : none
//--- Outputs : Tm
//--- Calls To: none
//---           
//--- this routine sets Tm to the current minutes and seconds
//--- in seconds. It is used like a stop watch.
//-------------------------------------------------------------
GetTimeInSecs:
  Tm  = Time(1)
  TmH = ToNumber(Substring(Tm,1,2))
  TmM = ToNumber(Substring(Tm,4,2))
  TmS = ToNumber(SubString(Tm,7,2))
  Tm  = TmH*3600+TmM*60+TmS  
Return
//=============================================================
//=============================================================
//--- Subroutine MoveToRoom
//--- Inputs  : RobotNode,GoalNode
//--- Outputs : none
//--- Calls To: FindPath,GotoPoint
//---           
//--- causes the robot to move to the goal node from where 
//--- it is. It calls FindPath to get the shortest path.
//-------------------------------------------------------------
MoveToRoom:
   if RobotNode <> GoalNode
      GoSub FindPath
      If Found and PathLength > 0
         For I = 1 to PathLength  //for each node on path
            Dnn = PathList[I,0] //destination node number
            x = Nodes[Dnn,1]
            y = Nodes[Dnn,2]
            GoSub GotoPoint
         next
         RobotNode = GoalNode
      endif
   endif
return
//=============================================================
//=============================================================
//--- Subroutine FindPath
//--- Inputs  : RobotNode,GoalNode,MapGraph[],NodesCount
//--- Outputs : PathList[],PathLength
//--- Calls To: none
//---           
//--- this routine searches the MapGraph[] for a shortest path
//--- between the RobotNode and GoalNode.
//-------------------------------------------------------------
FindPath:
   Dim Queue[NodesCount]
   QHead = 0
   QTail = 0
   Dim Visited[NodesCount,3]
   MConstant Visited,999999
   Queue[QTail] = RobotNode //add to queue
   QTail = QTail+1
   Visited[RobotNode,0] = 1  //visited
   Visited[RobotNode,1] = 0  //distance
   Visited[RobotNode,2] = -1 //predecessor
   while Visited[GoalNode,0]<>1 and QHead < QTail
      v = Queue[QHead]  //deque
      QHead = QHead+1
      For w = 0 to NodesCount-1
        if MapGraph[v,w] = 1 and Visited[w,0] <> 1
           Visited[w,0]=1
           Visited[w,1] = Visited[v,1]+1
           Visited[w,2] = v
           Queue[QTail] = w //add to queue
           QTail = QTail+1
        endif
      next
   wend
   if Visited[GoalNode,0]  = 1
      Found = true
      Dim PathList[NodesCount]
      PathLength = Visited[GoalNode,1]
      PathList[PathLength] = GoalNode
      For FP_I = PathLength-1 to 0
        PathList[FP_I] = Visited[PathList[FP_I+1],2]
      next
   else
      Found = false
   endif
return
//=============================================================
//=============================================================
//--- Subroutine GotoPoint
//--- Inputs  : x,y
//--- Outputs : none
//--- Calls To: CheckObstacles
//---           
//--- this routine turns the robot towards the location x,y
//--- and then moves the robot there. If there is an object
//--- it waits in a loop until the object goes away. Also the
//--- routine keeps trying to turn and move the robot until it
//--- definitely reaches the goal point.
//-------------------------------------------------------------
GotoPoint:
  while true
    dx = x-rGpsX()
    dy = y-rGpsY()
    if dx=0 AND dy = 0 then return
    Theta = PolarA(dx,dy)*180/pi(1)+90-rCompass()
    if Theta > 180 then Theta = Theta-360
    if Theta < -180 Then Theta = Theta+360
    rTurn Theta
    GoSub CheckObstacles
    If not Obstructed then rForward 1
  wend 
Return
//=============================================================
//=============================================================
//--- Subroutine DisplayInstructions
//--- Inputs  : none
//--- Outputs : none
//--- Calls To: none
//---           
//--- displays the instructions in a window and an OK and Cancel 
//--- buttons and waits for mouse click on the button or the
//--- Space bar or Enter or Esc
//-------------------------------------------------------------
DisplayInstructions:
   data IM;"Office Messnger"
   data IM;"This program simulates an office messenger robot."
   data IM;"Pressing ""m"" or ""M"" or right-mouse-button brings"
   data IM;"up a tcommand menu.",""
   data IM;"The menu allows you to command the robot to go to"
   data IM;"any room in the office. It also shows stats on the"
   data IM;"robot's current position and the battery level.",""
   data IM;"The robot will go to that room and await further"
   data IM;"instructions. If you do not command it with a new"
   data IM;"room to go to within 60 seconds, or if the battery"
   data IM;"charge level goes too low, the robot will go to"
   data IM;"the charging station and wait for more instructions"
   data IM;"while charging."
   n = MsgBox(IM)
Return
//=============================================================
//=============================================================
//--- Subroutine ChooseRoom
//--- Inputs  : Nodes[]
//--- Outputs : GoalNode
//--- Calls To: none
//---           
//--- this routine displays a menu of rooms to choose from
//--- once the user selects a room number it sets GoalNode 
//--- to the number chosen.
//--- The routine also displays the battery charge level and
//--- the name of the room where the robot is currently 
//--- situated when the routine is called. It uses the Nodes[]
//--- array to get the name of the node.
//-------------------------------------------------------------
ChooseRoom:
  if not VType(CR_t)
     CR_t = true
     data CR_btns;"&Cancel","&BreakRoom","Office &1"
     data CR_btns;"Office &2","Office &3","Office &4"
     data CR_btns;"Office &5","&HallWay 1","Hall&Way 2"
  endif   
  SaveScr
  Rectangle 55,55,755,555,black,black
  Rectangle 50,50,750,550,cyan,cyan
  ERectangle 52,52,750,550,2,white
  setcolor white,cyan
  xytext 160,80,"Select the Room To Go To:","",15,fs_Bold
  xytext 140,400,"Battery =        Robot is at:","",15,fs_Bold
  setcolor black,white
  xytext 260,400,Format(rChargeLevel(),"##0%"),"",15,fs_Bold
  xytext 493,400," "+Nodes[RobotNode,0]+" ","",15,fs_Bold
  for CR_I = 0 to MaxDim(CR_btns,1)-1
     AddButton CR_btns[CR_I],300,110+CR_I*25,150
  next   
  while true
    GetButton CR_btn
    if keydown(kc_Esc) then break
    if CR_btn <> "" then break
  wend
  RestoreScr
  for CR_I = 0 to MaxDim(CR_btns,1)-1
    RemoveButton CR_btns[CR_I]
  next
  GoalNode = RobotNode
  if CR_btn <> "" and CR_btn <> CR_btns[0]
    for GoalNode=1 to MaxDim(CR_btns,1)-1
      if CR_btn = CR_btns[GoalNode] then break
    next   
    GoalNode = GoalNode-1
  endif  
Return
//=============================================================
//=============================================================
//--- Subroutine CheckObstacles
//--- Inputs  : none
//--- Outputs : Obstructed
//--- Calls To: none
//---           
//--- checks for obstacles, also allows for simulated transient
//--- obstacles indicated by the left mouse button kept pushed
//--- down in front of the robot.
//--- sets Obstructed to true or false.
//-------------------------------------------------------------
CheckObstacles:
    Obstructed = true
    CO_B = rBumper()&4
    readmouse xx,yy,bb
    if bb=1 or CO_B
       rGPS Rx,Ry
       if PolarR(xx-Rx,yy-Ry) <= RobotSize+2 or CO_B
          //flash a beacon on the robot
          circle Rx-3,Ry-3,Rx+3,Ry+3,BcnClr,BcnClr //on
          delay 60
          circle Rx-3,Ry-3,Rx+3,Ry+3,white,white //off
          delay 40
          return
       endif
    endif
    Obstructed = false
Return
//=============================================================
//=============================================================
//--- Subroutine DockWithCharger
//--- Inputs  : NodesCount,ChargeDelay
//--- Outputs : none
//--- Calls To: MoveToRoom
//---           
//--- makes the robot move to the charge room. Once there it
//--- turns around and docks with the charging station with
//--- its back. It keeps turning until the robot's heading is 
//--- definitely north.
//-------------------------------------------------------------
DockWithCharger:
    GoalNode = NodesCount-1
    if GoalNode = RobotNode then return
    GoSub MoveToRoom
    while true
      dA = -rCompass()
      if dA = 0 then break
      if dA > 180 then dA = 360-dA
      if dA < -180 then dA = 360+dA
      rTurn dA
    wend
    while not (rBumper()&1)
      rForward -1
    wend
    delay ChargeDelay
    rCharge 100
Return
//=============================================================
//=============================================================
