MainProgram:
   GoSub InitArm
   GoSub Initialize
   GoSub MonitorInputs
End
//=================================================================
MonitorInputs:
   while true
     GoSub CheckMouse
     if !K then GoSub CheckKeyBoard
     if !K then GoSub CheckButtons
     if !K then GoSub CheckJoystick
     if K == Ascii("L") then GoSub LoadDisk
     if K == Ascii("U") then GoSub DiskPickUp
     if K == Ascii("D") then GoSub DiskPutDown
     if K == Ascii("C") then ClearScreen = true 
     if K == Ascii("A") then GoSub SetPenAttributes
     if K == Ascii("P") then PenDown = !PenDown
     if K == Ascii(" ")
         waitnokey
         TX = mx \ TY = my \ GoSub AutoDrive
     else
         GoSub MoveArm
     endif
     dTh1 = 0 \ dTh2 = 0 \ dElbo = 0
   wend
Return
//=================================================================
CheckMouse:
     K = 0
     readmouse mx,my,mb
     if mb != 1 then return
     if within(mx,0,650)   && within(my,0,600)   then K = Ascii(" ") \ return
     if within(mx,737,7762) && within(my,230,255)then K = Ascii("P") \waitnokey \ return
     if within(mx,690,720) && within(my,320,360) then dTh2  = 1  
     if within(mx,740,770) && within(my,320,360) then dTh2  = -1 
     if within(mx,710,750) && within(my,300,330) then dTh1  = 1  
     if within(mx,710,750) && within(my,350,380) then dTh1  = -1 
     if within(mx,700,730) && within(my,420,460) then dElbo = -1 
     if within(mx,730,760) && within(my,420,460) then dElbo = 1  
Return
//=================================================================
CheckKeyBoard:
     K = 0
     if keydown(Ascii("L")) then K = Ascii("L") \ return
     if keydown(Ascii("U")) then K = Ascii("U") \ return
     if keydown(Ascii("D")) then K = Ascii("D") \ return
     if keydown(Ascii("A")) then K = Ascii("A") \ return
     if keydown(Ascii("P")) then K = Ascii("P") \waitnokey \ return
     if keydown(Ascii("C")) then K = Ascii("C") \ return
     if keydown(kc_LArrow)  then dTh2 = 1  \ K=1
     if keydown(kc_RArrow)  then dTh2 = -1 \ K=1
     if keydown(kc_UArrow)  then dTh1 = 1  \ K=1
     if keydown(kc_DArrow)  then dTh1 = -1 \ K=1
     if keydown(Ascii("I")) then dElbo = -1 \ K=1
     if keydown(Ascii("O")) then dElbo = 1  \ K=1
     if K then GetButton btn
Return
//=================================================================
CheckButtons:
     K = 0
     Getbutton btn
     if btn == Buttons[INST] then TTT = MsgBox(I_M)
     if btn == Buttons[LD_DSK] then K = Ascii("L") \ return
     if btn == Buttons[PICK_U] then K = Ascii("U") \ return
     if btn == Buttons[PUT_D]  then K = Ascii("D") \ return
     if btn == Buttons[PEN_A]  then K = Ascii("A") \ return
     if btn == Buttons[CLR_TR] then K = Ascii("C") \ return
Return
//=================================================================
CheckJoystick:
  K = 0
  joysticke 1,JS_a
  if JS_a[0,0] == -1 then JS_FT = true \return
  if !vType(JS_FT) then JS_FT = true
  if JS_FT
      JS_X_LL = JS_a[0,1]+(JS_a[0,2]-JS_a[0,1])/3
      JS_X_UL = JS_a[0,2]-(JS_a[0,2]-JS_a[0,1])/3
      JS_Y_LL = JS_a[1,1]+(JS_a[1,2]-JS_a[1,1])/3
      JS_Y_UL = JS_a[1,2]-(JS_a[1,2]-JS_a[1,1])/3
      JS_Z_LL = JS_a[2,1]+(JS_a[2,2]-JS_a[2,1])/3
      JS_Z_UL = JS_a[2,2]-(JS_a[2,2]-JS_a[2,1])/3
      JS_FT = false
  endif
  if JS_a[0,0] < JS_X_LL then dTh2 = 1
  if JS_a[0,0] > JS_X_UL then dTh2 = -1
  if JS_a[1,0] < JS_Y_LL then dTh1 = 1
  if JS_a[1,0] > JS_Y_UL then dTh1 = -1
  if JS_a[2,0] < JS_Z_LL then dElbo = -1
  if JS_a[2,0] > JS_Z_UL then dElbo = 1
  if JS_a[6,0] == 1  then K = Ascii("P") \ delay 250
  if JS_a[6,0] == 2  then K = Ascii("L")
  if JS_a[6,0] == 4  then K = Ascii("U")
  if JS_a[6,0] == 8  then K = Ascii("A")
  if JS_a[6,0] == 16 then K = Ascii("D")
  if JS_a[6,0] == 32 then K = Ascii("C")
return
//=================================================================
Initialize:
    ProgramName = "2D_Arm_Simulator.Bas"
    data I_M;ProgramName
    data I_M;"This program is a simulation for a Planar Articulated Robot Arm with 3 degrees of freedom."
    data I_M;"The arm is hung from the ceiling and can reach a circular area that has a radius of L1+L2."
    data I_M;"L1 is of variable length depending on where the lower arm is jointed to the upper arm. The"
    data I_M;"hinge point of the lower arm is prismatic and can be telescoped in and out along the length"
    data I_M;"of the upper arm. L2 is the constant length of the lower arm. The upper arm can be rotated"
    data I_M;"360 degrees about the revolute hinge point hanging from the ceiling. The lower arm, besides"
    data I_M;"being able to move in and out along the length of the upper arm, can also rotate about its"
    data I_M;"hinge point (360 degrees).",""
    data I_M;"The view of the simulator is as if you are looking down from the ceiling. The end effecter at"
    data I_M;"the end of the lower arm is either an electromagnet or a pen. The electromagnet can be activated"
    data I_M;"to pick up (or load) a disk of a specifiable size and color. If the magnet is deactivated while"
    data I_M;"holding a disk, the disk will be dropped on the floor below the position of end effecter. If the"
    data I_M;"magnet is activated above a disk on the ground within its range, the disk will be picked up. The"
    data I_M;"pen can be loaded or unloaded and once loaded the arm will draw on the floor when moved. If the"
    data I_M;"pen is loaded while there is a disk the disk will be considered to have been removed. The pen"
    data I_M;"color and tip size can be specified.",""
    data I_M;"The arm can be controlled manually or automatically. For automatic control you tell the arm to"
    data I_M;"go to a particular spot within its range by clicking the left mouse button on the place you want"
    data I_M;"the arm end effecter to go to. The arm will decide what hinge angles and prismatic telescoping"
    data I_M;"to do and will go to the indicated point smoothly while minimizing movement. The arm will not"
    data I_M;"try to move if you specify a target point that is not within the range of the arm.",""
    data I_M;"The arm can be manually operated using the controls from the control panel on the right, or using"
    data I_M;"the arrow keys. All operations can be effected with the keyboard, mouse, buttons, or Joystick.",""
    data I_M;"The control panel on the right allows for all the operations, which can also be effected with"
    data I_M;"a keyboard key as indicated inside the parenthesis (). The up/Dn/Lft/Rt arrow keys can be used"
    data I_M;"to rotate the joints of the arm, and they can be pressed simultaneously and with the 'I' and 'O'"
    data I_M;"keys to effect the rotations and prismatic movements in a smooth manner. If you use the mouse"
    data I_M;"you can press on the black arrows, but the white little squares can also be used to indicate"
    data I_M;"both arrows together.",""
    data I_M;"The bottom of the control panel indicates the current position of the end effecter in Cartesian"
    data I_M;"(X,Y) and Polar (R,A) coordinates in relationship to the hinge of the upper arm (the origin). Also"
    data I_M;"the position of the mouse pointer is indicated on the top left corner of the screen. The angle of "
    data I_M;"the polar coordinates is positive counterclockwise from the positive x-axis (horizontal to the right)"
    data I_M;"and negative clockwise. The x-axis is positive to the right and negative to the left. The y-axis is"
    data I_M;"positive upwards and negative downwards. The radius of the polar coordinates is the distance to the"
    data I_M;"origin.",""
    data I_M;"The hinge angles are also shown. The angles are +/- 180 degrees. For the upper arm hinge angle (Th1)"
    data I_M;"is measured counterclockwise from the horizontal to the right (positive x-axis) as positive. Negative"
    data I_M;"is clockwise from the x-axis. The lower arm hinge angle (Th2) is measured in a similar manner but in"
    data I_M;"reference to the hinge point on the upper arm not the x-axis. Additionally the distance of the hinge"
    data I_M;"of the lower arm from the hinge of the upper arm is indicated (L1).",""
    data I_M;"The code of the simulated arm is written in such a way so as to be easily used by you to program"
    data I_M;"any situation you desire. Additionally, of you substitute the Code inside the MoveArm routine"
    data I_M;"with code to communicate with a real that can respond to certain codes you can then control"
    data I_M;"a real arm instead of a simulated one using the very same code.",""
    data I_M;"The code can also be used as if it were a real arm and you can develop a set of routines"
    data I_M;"to do Inverse Kinematics and Path control to do all sorts of control projects.",""
    data I_M;"For example, instead of using the mouse to specify a target point, you can use some form of"
    data I_M;"vision system to calculate the position of an object and then use the same routines to make"
    data I_M;"the arm go to the automatically generated target position. You can also do projects that try"
    data I_M;"to make the arm draw a certain shape (straight lines can be hard)."

    data Buttons;"&Instructions","","Pen &Attributes (A)","C&lear Trace (C)",""
    data Buttons;"Load &Disk (L)","Put &Down (D)","Pick &Up (U)"
    INST = 0 \ PEN_A = 2 \ CLR_TR = 3 \ LD_DSK = 5 \ PUT_D = 6 \ PICK_U = 7 
    for i=0 to MaxDim(Buttons,1)-1
      if Buttons[i] == "" then continue
      Addbutton Buttons[i],660,10+25*i,130
    next
    ERectangle 650,0,797,597,3,black
    Line 650,220,797,220,3,black
    Line 650,470,797,470,3,black
    ERectangleWH 737,230,25,30,3,black
    xyText 670,235,"Pen (P):","Time New Roman",12,fs_Bold
    PD_D = "U" \ if PenDown then PD_D = "D"
    xyText 743,235,PD_D,"",15,fs_Bold
    LA = "uluaassuru" \ RA = "urussaaulu"
    UA = "lulwwssldl" \ DA = "ldlsswwlul"
    drawshape LA,720,340,10 \ FloodFill 718,340,0
    drawshape RA,740,340,10 \ FloodFill 742,340,0
    drawshape UA,730,330,10 \ FloodFill 730,328,0
    drawshape DA,730,350,10 \ FloodFill 730,352,0
    drawshape LA,730,440,10 \ FloodFill 728,440,0
    drawshape RA,730,440,10 \ FloodFill 732,440,0
    xytext 710,285,"Shldr +","Times New Roman",8,fs_Bold
    xytext 710,380,"Shldr -","Times New Roman",8,fs_Bold
    xytext 665,320,"Elbo +" ,"Times New Roman",8,fs_Bold
    xytext 765,320,"Elbo -" ,"Times New Roman",8,fs_Bold
    xytext 715,405,"Elbow"  ,"Times New Roman",8,fs_Bold
    xytext 675,425,"In (I)" ,"Times New Roman",7,fs_Bold
    xytext 760,425,"Out (O)","Times New Roman",7,fs_Bold
    xyText 655,480,"(X,Y)=","Times New Roman",10,fs_Bold
    xyText 655,505,"(R,A)=","Times New Roman",10,fs_Bold
    xyText 655,530,"( L1 )=","Times New Roman",10,fs_Bold
    xyText 655,550,"(Th1,Th2)=","Times New Roman",12,fs_Bold
    savescr
    ScrToCB 650
    Flip On
Return
//=================================================================
SetPenAttributes:
    if !vType(SPA_LW)
        data SPA_Buttons;"&OK","&Cancel"
        data SPA_Edits;"PenWidth"
    endif
    GetLineWidth SPA_LW
    LineWidth 5
    rectanglewh 105,105,500,220,black,black
    rectanglewh 100,100,500,220,black,white
    LineWidth 2
    xyText 120,120,"Select Pen Attributes Required:","",17,fs_Bold
    xyText 130,170,"Down:","",12,fs_Bold    
    rectanglewh 180,165,30,30
    xyText 280,170,"Width (1-50):","",12,fs_Bold
    xyText 130,210,"PenColor(click to change):","",12,fs_Bold
    AddEdit SPA_Edits[0],410,170,60,0,PenWidth
    rectanglewh 400,200,40,40,PenColor,PenColor
    AddButton SPA_Buttons[0],200,270,100
    AddButton SPA_Buttons[1],350,270,100
    s = "N" \if PenDown then s="Y"
    xyText 185,170,s,"",12,fs_Bold    
    SPA_PC = PenColor \ SPA_PD = PenDown
    flip
    while true
      getbutton btn
      readmouse SPA_mx,SPA_my,SPA_mb
      GetKey SPA_kc 
      if SPA_kc == kc_Enter then btn = SPA_Buttons[0]
      if SPA_kc == kc_ESC   then btn = SPA_Buttons[1]
      if SPA_kc == Ascii("y") then SPA_PD = 0 \SPA_mb = 1 \ SPA_mx = 190 \ SPA_my = 180
      if SPA_kc == Ascii("n") then SPA_PD = 1 \SPA_mb = 1 \ SPA_mx = 190 \ SPA_my = 180
      if SPA_mb == 1
        if within(SPA_mx,180,210) && within(SPA_my,170,200)
          SPA_PD = !SPA_PD
          s = "N" \if SPA_PD then s="Y"
          xyText 185,170,s,"",12,fs_Bold    
          flip
        elseif within(SPA_mx,400,440) && within(SPA_my,200,240)
          SPA_PC = PromptColor(SPA_PC)
          rectanglewh 400,200,40,40,SPA_PC,SPA_PC
          flip
        endif 
        waitnokey
      endif
      if btn == SPA_Buttons[0]
        PenColor = SPA_PC
        PenDown = SPA_PD
        if PenDown then DiskInHand = -1
        SPA_PW = ToNumber(GetEdit(SPA_Edits[0]))
        if IsNumber(SPA_PW) then PenWidth = Limit(SPA_PW,1,50)
        break
      endif
      if btn != "" then \ break
    wend
    LineWidth SPA_LW
    RemoveEdit SPA_Edits[0]
    RemoveButton SPA_Buttons[0]
    RemoveButton SPA_Buttons[1]
    waitnokey
Return
//=================================================================
LoadDisk:
    if DiskInHand <0 && EmptySlot >= NumDisks && NumDisks > 5//MaxDim(Disks,1)
        LD_t = ErrMsg("No More Disks Available!",ProgramName,MB_OK|MB_ERROR)
        return
    endif
    if DiskInHand == -1 
        if EmptySlot < NumDisks
           DiskInHand = EmptySlot 
        else
           DiskInHand = NumDisks \ NumDisks = NumDisks+1
        endif
        EmptySlot = NumDisks
    endif
    LD_n = DiskInHand
    if !vType(SPA_LW)
        data SPA_Buttons;"&OK","&Cancel"
        data SPA_Edits;"PenWidth"
    endif
    GetLineWidth SPA_LW
    LineWidth 5
    rectanglewh 105,105,500,220,black,black
    rectanglewh 100,100,500,220,black,white
    LineWidth 2
    xyText 120,120,"Select Disk Attributes Required:","",17,fs_Bold
    xyText 130,170,"Shape:","",12,fs_Bold    
    rectanglewh 195,165,70,30
    xyText 280,170,"Width(10-50):","",12,fs_Bold
    xyText 130,210,"Disk Color(click to change):","",12,fs_Bold
    AddEdit SPA_Edits[0],410,170,60,0,Disks[LD_n,2]
    rectanglewh 410,200,40,40,Disks[LD_n,3],Disks[LD_n,3]
    AddButton SPA_Buttons[0],200,270,100
    AddButton SPA_Buttons[1],350,270,100
    s = "Circle" \if Disks[LD_n,1] then s="Square"
    xyText 200,170,s,"",12,fs_Bold    
    LD_DC = Disks[LD_n,3] \ LD_DS = Disks[LD_n,1]
    flip
    while true
       getbutton btn
       readmouse LD_mx,LD_my,LD_mb
       GetKey LD_kc 
       if LD_kc == kc_Enter then btn = SPA_Buttons[0]
       if LD_kc == kc_ESC   then btn = SPA_Buttons[1]
       if LD_kc == Ascii("s") then LD_DS = 0 \LD_mb = 1 \ LD_mx = 210 \ LD_my = 180
       if LD_kc == Ascii("c") then LD_DS = 1 \LD_mb = 1 \ LD_mx = 210 \ LD_my = 180
       if LD_mb == 1
         if within(LD_mx,200,270) && within(LD_my,170,200)
           LD_DS = !LD_DS
           s = "Circle" \if LD_DS then s="Square"
           xyText 200,170,s,"",12,fs_Bold    
           flip
         elseif within(LD_mx,410,450) && within(LD_my,200,240)
           LD_DC = PromptColor(LD_DC)
           rectanglewh 410,200,40,40,LD_DC,LD_DC
           flip
         endif 
         waitnokey
       endif
       if btn == SPA_Buttons[0]
          Disks[LD_n,3] = LD_DC
          Disks[LD_n,1] = LD_DS
          LD_DW = ToNumber(GetEdit(SPA_Edits[0]))
          if IsNumber(LD_DW) then Disks[LD_n,2] = Limit(LD_DW,10,50)
          PenDown = false
          break
       endif
       if btn != "" then  EmptySlot = DiskInHand \ DiskInHand = -1 \ break
    wend
    LineWidth SPA_LW
    RemoveEdit SPA_Edits[0]
    RemoveButton SPA_Buttons[0]
    RemoveButton SPA_Buttons[1]
    waitnokey
Return
//=================================================================
DiskPickUp:
    if PixelClr(X2,Y2) == White || NumDisks < 1 then return
    for i=0 to NumDisks-1
      xx = Disks[i,4] \ yy = Disks[i,5] \ ww = Disks[i,2]
      if within(X2,xx-ww,xx+ww) && within(Y2,yy-ww,yy+ww)
        Disks[i,0] = 0
        DiskInHand = i
        PenDown = false
        return
      endif
    next
Return
//=================================================================
DiskPutDown:
    i = DiskInHand
    if i < 0 then return
    Disks[i,0] = 1 \ Disks[i,4] = X2 \ Disks[i,5] = Y2        
    DiskInHand = -1
Return
//=================================================================
//=================================================================
//===This routine is what simulates controlling the Arm
//===You call this routine with the following parameters set
//===dTh1,dTh2,dElbo,PenDown 
//===   Shoulder, Elbo angular step and direction and Prismatic
//===   Elbo step and direction 
//===DiskInHand
//===   this for simulating loading a disk into the robots end effecter
//===   and turning the electromagnet on and off. 
//===ClearScreen to cause the pen trace to be erased
//=================================================================
//=================================================================
MoveArm:
    GoSub CalcThetas
    RestoreScr
    X0 = X+L0*cos(Th1)      \  Y0 = Y-L0*sin(Th1)
    X1 = X+L1*cos(Th1)      \  Y1 = Y-L1*sin(Th1)
    X2 = X1+L2*cos(Th2+Th1) \  Y2 = Y1-L2*sin(Th2+Th1)
    
    if ClearScreen then ClearScr \ ClearScreen = false
    if PenDown
        if OldX2 != X2 || OldY2 != Y2 then Line OldX2,OldY2,X2,Y2,PenWidth,PenColor
    endif
    if PenDown then DiskInHand = -1
    OldX2 = X2 \ OldY2 = Y2
    SaveScr
    ScrFromCb 650
    if NumDisks > 0
      for i=0 to NumDisks-1
        if ! Disks[i,0] then continue
        xx= Disks[i,4] \ yy = Disks[i,5] \ ww = Disks[i,2] \ cc = Disks[i,3]
        if Disks[i,1]
           Rectangle xx-ww,yy-ww,xx+ww,yy+ww,cc,cc
        else
           Circle xx-ww,yy-ww,xx+ww,yy+ww,cc,cc
        endif
      next
    endif
    i = DiskInHand
    if i >= 0
      ww = Disks[i,2] \ cc = Disks[i,3]
      if Disks[i,1]
         Rectangle X2-ww,Y2-ww,X2+ww,Y2+ww,cc,cc
      else
         circle X2-ww,Y2-ww,X2+ww,Y2+ww,cc,cc
      endif
    endif
    Line X1,Y1,X2,Y2,15,ClrOut //outer arm
    Line X1,Y1,X2,Y2,8,ClrIn   
    if PenDown then Circle X2-2,Y2-2,X2+2,Y2+2,PenColor,PenColor //pen top 
    Circle X1-10,Y1-10,X1+10,Y1+10,ClrOut,ClrOut  //elbow hinge
    Line X,Y,X0,Y0,15,ClrOut //inner arm
    Line X,Y,X0,Y0,8,ClrIn
    Circle X-10,Y-10,X+10,Y+10,0,ClrOut //shoulder hinge
    X_ = X2-X \ Y_ = Y-Y2 \ 
    R_ = Round(PolarR(X_,Y_)) \ A_ = Round(rtod(PolarA(X_,Y_)))
    xystring 695,480,Round(X_),","+Round(Y_)
    xystring 695,505,R_,","+A_
    xystring 695,528,Format(L1,"0.00")
    xystring 692,572,round(rToD(Th1)),","+round(rtod(Th2))
    PD_D = "U" \ if PenDown then PD_D = "D"
    xyText 743,235,PD_D,"",15,fs_Bold
    if (within(mx,0,650) && within(my,0,600))
      xystring 0,0, "(X,Y)=",mx-X,",",Y-my
      xystring 0,20,"(R,A)=",round(PolarR(mx-X,Y-my)),",",round(rtod(PolarA(mx-X,Y-my)))
    endif
    flip
Return
//=================================================================
CalcThetas:
    Th1 = Th1+dTh1*I \ Th2 = Th2+dTh2*I
    L1 = Limit(L1+II*dElbo,0.5,L0)
    if Th1 < -Pi() then Th1 = Th1+pi(2)
    if Th1 >  Pi() then Th1 = Th1-Pi(2)
    if Th2 < -Pi() then Th2 = Th2+pi(2)
    if Th2 >  Pi() then Th2 = Th2-Pi(2)
Return
//=================================================================
InitArm:
    //------Arm Parameters
    L1 = 150.0 \ L2 = 100.0\ L0 = L1
    X  = 300   \ Y  = 300
    X2 = 0     \ Y2 = 0
    OldX2 = 0  \ OldY2 = 0
    Th1 = dtor(30) \ Th2 = dtor(45)     
    I = Pi()/100 \ II= 0.5
    PenDown = 0 \PenColor = 0 \ PenWidth = 2
    dTh1 = 0 \ dTh2 = 0 \ dElbo = 0
    ClrOut = DarkGray \ ClrIn = Gray
    ClearScreen = false
    Dim Disks[300,6]
    mConstant Disks,0
    for i=0 to 299
      Disks[i,2] = 10
      Disks[i,3] = red
    next
    NumDisks = 0 \ DiskInHand = -1 \ EmptySlot = 300
Return
//=================================================================
//=================================================================
//==This routine drives the robot arm automatically to a particular
//==TX,TY coordinate (screen coordinates)
//==it uses reverse kinematics to calculate the required joint
//==angles and then calculates how many steps the angles have to
//==be stepped and then calls the Arm simulater for as many steps as
//==required to position the arm.
//==It calculates the 
//=================================================================
//=================================================================
AutoDrive:
   GoSub CalcDThetas
   n = round(dTh1/I) \ nn = round(dTh2/I)
   dTh1 = sign(n) \ dTh2 = sign(nn)
   n = abs(n) \ nn = abs(nn)
   repeat
     readmouse mx,my,mb
     if mb == 1 then waitnokey \break
     GoSub MoveArm
     n = n-1 \ nn = nn-1
     if n == 0 then dTh1 = 0
     if nn == 0 then dTh2 = 0
   until n<=0 && nn<=0
Return
//=================================================================
CalcDThetas:
    DX = TX-X \ DY = Y-TY
    LLL = sqrt(DX*DX+DY*DY)
    dTh1 = 0 \ dTh2 = 0 \dElbo = 0
    if LLL > L2+L0 then return
    if  LLL > L1+L2 then dElbo = LLL-L2-L1
    if LLL < L1-L2 then dElbo = -L1+L2+LLL
    if dElbo != 0 
        n = round(dElbo/II) \ dElbo = sign(n)
        for iii=0 to abs(n)
            GoSub MoveArm
        next
        dElbo = 0
    endif
    C2 = (DX*DX+DY*DY-L1*L1-L2*L2)/2.0/L1/L2
    C2 = Limit(C2,-1,1)
    S2 = Sqrt(1-C2*C2)
    dTh2  = atan2(C2,S2) -Th2
    dTh2_ = atan2(C2,-S2)-Th2
    K1 = L1+L2*C2
    K2 = L2*S2
    dTh1  = atan2(DX,DY)-atan2(K1,K2)-Th1
    dTh1_ = atan2(DX,DY)-atan2(K1,-K2)-Th1
    if abs(dTh1) > pi() then dTh1 = dTh1 - (pi(2)*sign(dTh1))
    if abs(dTh2) > pi() then dTh2 = dTh2 - (pi(2)*sign(dTh2))
    if abs(dTh1_) > pi() then dTh1_ = dTh1_ - (pi(2)*sign(dTh1_))
    if abs(dTh2_) > pi() then dTh2_ = dTh2_ - (pi(2)*sign(dTh2_))
    if abs(dTh1_) < abs(dTh1) then dTh1 = dTh1_ \ dTh2 = dTh2_
Return
//=================================================================
