//===========================================================
//===========================================================
MainProgram:
  GoSub SetUp
  GoSub Instructions
  while true
     GoSub MoveRobot
  wend
End
//===========================================================
//===========================================================
SetUp:
  clearscr
  AbortMethod am_Exit
  rlocate 400,300
  rinvisible red,cyan
Return
//===========================================================
MoveRobot:
   joystickE 1,a
   x = 0 \ y = 0
   if a[1,2] != a[1,1] then y = a[1,0]/(a[1,2]-a[1,1])  //get the y-Axis
   if a[2,2] != a[2,1] then x = a[2,0]/(a[2,2]-a[2,1])  //get the x-axis
   if a[3,2] != a[3,1] then x = a[3,0]/(a[3,2]-a[3,1])  //get the Twist-Axis make into x-axis
   if a[7,0] >= 0 then rHeading a[7,0]\delay 150  //use hat button
   btn = a[6,0]
   if btn==1 then rPen Down,Cyan \ Pen = cyan
   if btn==2 then rPen Down,Red  \ Pen = Red
   if btn==4 then rPen Up \ Pen = 0
   if btn==8 then clearscr \ rrelocate
   trn = round(x*10-5)  //transform (0 to 1) to (-5 to 5)
   if within(trn,-1,1) then trn=0 //--make the joystick have a dead center zone
   frwrd = round(y*10-5) //transform range (0 to 1) to (-5 to 5)
   if within(frwrd,-1,1) then frwrd = 0 //--make the joystick have a dead center zone
   while trn!=0 || frwrd!=0 //make simultaneous turn and forward one step at a time
      if trn !=0
         rturn 1*sign(trn)
         trn = trn-(1*sign(trn))
      endif
      if frwrd <0
         if !(rbumper()&4) then rforward 1  //forward as long as no obstacle ahead
         frwrd = frwrd+1
      elseif frwrd >0
         if !(rbumper()&1) then rforward -1 //backwaord as long as no obstacle behind
         frwrd = frwrd-1
      endif
   wend
Return
//===========================================================
Instructions:
  data I_M;"JoyStickE_Robot.Bas.... Instructions..."
  data I_M;"This program demonstrates the use of the extended (not standard) JoyStick"
  data I_M;"command to control RobotBASIC's simulated robot.",""
  data I_M;"The joystick's y-axis is used to forward/back the robot. The twist of the"
  data I_M;"stick is used to turn the tobot. The more you move the stick the faster the "
  data I_M;"movement. So you can make tighter and wider turns and circles.",""
  data I_M;"Also you can use button 1 to lower a Cyan (button 2 a Red) pen. Button 3 is"
  data I_M;"used to raise the pen and stop drawing. The pen is initially up. Button 4"
  data I_M;"clears the screen.",""
  data I_M;"Additionally the Hat button on the extended josystick can be used to turn the"
  data I_M;"robot to N/S, W/E, NE/SW and NW/SE.",""
  data I_M;"If your joystick does not have a twist axis then the x-axis will be used to"
  data I_M;"turn. Also if no Hat button exists it will be ignored."
  n = MsgBox(I_M)
Return
//===========================================================
