''----------RB2PRop_IO_Binary.Spin------------------------
{{
  Use the RobotBASIC program RB2Prop_IO_Binary.Bas.
  This Spin program performs comms with RobotBASIC to receive
  two 32 bit binary numbers and then adds them and then sends
  the result back to RB as one 32 bit binary number.
  (The Propeller uses Little-endian format and so does RB)
  
  Note:
  -----
  If you use the Programming port for IO with RB then
  you must write the program to EEPROM (F11 not F10)
  Also start the RB program after you have compiled the
  Spin program. The RB program will reset the propeller
  to start its program running for a correct sequence.
  
  Note:
  -----
  If you use different Rx/Tx pins than 31/30 then you
  can save to RAM (F10) but you also have to run the
  RB program before you compile the Spin program.
  That way the RB program would be ready for the Spin
  program to run for a correct sequencing.

  Note:
  -----
  Make sure that RB is using the right Com number per
  your setup.   
}}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  RxPin         = 31     'can use a different pin...see note above
  TxPin         = 30     'can use a different pin...see note above 
  BaudRate      = 115200 'this is a good baud for 80MHz
   
OBJ
  SerIO : "FullDuplexSerialPlus" 'object that implements serial I/O 
                                 'for the Propeller. It is part of 
                                 'the Propeller Education Kit library
Var
  Long Vals[2]
  byte buff_index
  
PUB RB_IO_Demo_Binary

  SerIO.Start(RxPin, TxPin, %0000, BaudRate) 
  SerIO.Str(String("Rdy")) 'send the Rdy to synchronize
  repeat
     GetBinaries                  'get the binary 8 bytes
     Vals[0] := Vals[0]+Vals[1]   'add the values
     SendBinary                   'send the binary 4 bytes

Pri GetBinaries
  'reads in 8 bytes and puts them in the memory area starting
  'at the Vals[] array....that effectively writes in the two
  'numbers into the arrays 
  repeat buff_index from 0 to 7
    byte[@Vals + buff_index] := SerIO.Rx
    

Pri SendBinary     
  'sends 4 bytes starting at the address of Vals[]
  'that effectively sends the first element in the array.
  repeat buff_index from 0 to 3
    SerIO.Tx(byte[@Vals + buff_index])

