MainProgram:
  gosub Initialization
  gosub Demo
end
//=====================================================================
Initialization:
 // changing these 2 parameters changes the motor's characteristics
    Friction = 10
    Mass = 200.0  // (MOI)
  Vel = 0
  potX=417 \ potY=575
  motX=403 \ motY=405
  potA = pi(0.5) \ motA = potA
  gX=5 \  mY=195 \  pY=195
  Flip on
  FitBmp "GearMot",200,300,400,300
  ReadPixel 400,310,BG
  ReadPixel potX-110,potY-8,Brn
  ClearScr BG
  FitBmp "GearMot",200,300,400,300
  Rectangle 200,300,600,350,BG,BG
  Rectangle 200,300,380,406,BG,BG
  Rectangle 430,300,600,414,BG,BG
  SaveScr 150,200,650,600
  clearscr BG
  gosub UpdateAnimation
  Rectangle 0,0,799,199,Blue,White
  xyString 10,10,"This program simulates a DC gearhead motor connected to a potentiometer (in rear)."
  xyString 10,25,"There is also a potentiometer in the front (use the mouse to move this pointer)."
  xyString 10,40,"When you click this window, the program will begin.  A SIMPLE demo algorithm will"
  xyString 10,55,"make the motor try to keep its pointer aligned with the one you move. As you will"
  xyString 10,70,"see, it does not do a very good job.  Your assignment is to alter the Demo routine"
  xyString 10,85,"to improve the tracking (Hine:try proportional or PID control)."
  xyString 10,105,"                  Click this window to start the program."
  xyString 10,125," NOTE: You can pause the program by holding down the mouse button in this window."
  flip
  repeat
    ReadMouse x,y,b
  until b=1
  Data GraphPaper;0,0,799,197,gray
  mGraphPaper GraphPaper
  gosub ReadPotMotAngles
return
//=====================================================================
ReadPotMotAngles:
  //----in real life this subroutine would interrogate two A/D circuits connected
  //----to two potentiometers and store those values in POT (pointer angle) and 
  //----MOT (motor angle).  These values are calculated here from the simulation.
   
  MOT=Round(motA*255/pi())  
  

  // allow user to move the front pointer (connected to a potentiometer)
  ReadMouse x,y,mb
  if mb=1 and y>200
    y = Limit(y,0,potY-5)
    if y=potY
      potA = Pi()
    else
      potA=-(atan(1.0*(potX-x)/(y-potY))-Pi(0.5))
    endif
  endif
  repeat  //allow for pausing if mouse is in the graph area
    ReadMouse x,y,mb
  until !(y<200 and mb=1)
  POT=Round(potA*255/pi()) 
Return
//=====================================================================
UpdateAnimation:
  RestoreScr 150,200
  //---plot Motor lever
  Line motX,motY,motX+190*cos(-motA),motY+190*sin(-motA),8,Red
  Line motX,motY,motX+180*cos(-motA),motY+180*sin(-motA),8,Black

  //---Plot Pot Lever
  Circle potX-50,potY-25,potX+50,potY+30,Brn,Brn
  Circle potX-7,potY-1,potX+7,potY+7,Black,Black
  Line potX,potY,potX+190*cos(potA),potY-190*sin(potA),10,Blue
  Line potX,potY,potX+180*cos(potA),potY-180*sin(potA),10,Black
  

  
  //---Plot graph
  Line gX,mY,gX+1,195-motA*50,3,Red
  Line gX,pY,gX+1,195-potA*50,3,Blue
  pY = 195-potA*50
  mY = 195-motA*50
  gX=gX+1
  if gX>795
    gX=5
    mGraphPaper GraphPaper
  endif
  Flip
Return
//=====================================================================
Motor: 
   //---input  motA and PotA in radians  (motor and Pot angles)
   //---output   motA 
  GoSub ReadPotMotAngles  // determine current angles 
  // limit duty cycle to 0 - 15
  DutyCycle = Limit(DutyCycle,0,15)
  //---calculate response
  Acceleration=((Dir*DutyCycle)-(Friction* Vel*10))/(Mass*10.0)
  Vel = Vel+Acceleration
  motA=motA+Vel
  // limit movement due to stops at each end
//  if motA >= pi() then motA = pi() \ Vel = 0
//  if motA <= 0 then motA = 0 \ Vel = 0
  GoSub UpdateAnimation  
Return
//=====================================================================
Demo:  //Input---- MOT and POT 
                //output--- DutyCycle and Direction
  
  //---In this demo, we are just giving a limited response example where 
  //---the motor is turned on if there is a difference in the POT and MOT angles
  while true
                // First determine which Direction the motor has to turn
                // The variable MOT and POT contain a value from 0-255
                // indicating where the two pointers are.
    if POT<MOT
      Dir= -1
    else
      Dir = +1
    endif
               // then decide if motor needs to be turned on or off
    if ABS(POT-MOT)>3
      DutyCycle=2  // Turn Motor on if pointers are not close togther
    else
      DutyCycle=0  // Turn Motor off
    endif
    gosub Motor
  wend
Return
//=====================================================================
