MainProgram:
  gosub Initialize
  gosub Demo
end
//===================================================================
Demo:
  print "                                       "
  print " This program simulates a STEPPER MOTOR"
  print " that turns a spool that winds and     "
  print " unwinds a string that lifts and drops "
  print " an elevator.                          "
  print "                                       "
  print " Your assignment is to replace this    "
  print " subroutine with one that will control "
  print " the elevator in an appropriate way.   "
  print " For example, the buttons on each floor"
  print " should be able to call the elevator   "
  print " just like the buttons on a real one.  "
  print "                                       "
  print " To control the stepper motor, you     "
  print " must set the variable MotorData equal "
  print " to 8,4,2 or 1 (standard step data)    "
  print " and call the subroutine Step.  If you "
  print " send the data in the proper order the "
  print " motor will turn properly.             "
  print "                                       "
  print " As with most Step-Motor applications, "
  print " you must get the motor to a known     "
  print " position. This can be done using the  "
  print " limit switch at the bottom of the     "
  print " shaft.  The variable LimSw indicates  "
  print " the state of the switch after each    "
  print " motor movement.                       "
  print "                                       "
  print " To demo the elevator just CLICK the   "
  print " 3ed Floor button (for down) or the    "
  print " 1st Floor button (for up).  In the    "
  print " demo mode, you MUST keep clicking the "
  print " buttons to make the elvator move.     "
  print " NOTE: if you move the elevator to far "
  print " you can damage it.                    " 
  flip on
  while true
    GetButton But
    for ii = 1 to 60
      if But=" 1 UP " then StepData = StepData*2
      if But=" 3 DN " then StepData = StepData/2
      if StepData>8 then StepData = 1
      if StepData<1 then StepData = 8
      delay 50
      gosub Step
      flip
    next
  wend
return
//===================================================================
Initialize:
  Dim Mot[4,5]
  Data Points;-10,0,0,0,0,  0,10,0,0,0,  30,0,0,0,0,  0,-10,0,0,0
  mCopy Points,Mot
  Data View; 50,120,20,100,400,300
  ge3Dto2DA Mot,View
  flip on
  SetColor black,gray
  bkColor = 13552329
  clearscr bkColor
  IndColr = 16756912
  Ex = 660
  Ey = 150 //300
  OD = 1
  motA = .2
  StepData = 1
  AddButton " 1 UP ",530,500
  AddButton " 2 UP ",530,335
  AddButton " 2 DN ",530,360
  AddButton " 3 DN ",530,200
  AddButton " 3 ",745,320
  AddButton " 2 ",745,345
  AddButton " 1 ",745,370
  Data Err; "","The elevator has been damaged", "because you have moved it too far."
  Data Err; "","The program will now terminate."
  gosub DrawMot
return
//===================================================================
Step:
  // The variable StepData must be 8,4,2,or 1
  SD=StepData
  if (OD=8 and SD=4)or(OD=4 and SD=2)or(OD=2 and SD=1)or(OD=1 and SD=8)
    // forward
    motA = .2
    Ey=Ey+5
    gosub Rot
    ge3Dto2DA Mot,View
    gosub DrawMot
  elseif (OD=8 and SD=1)or(OD=4 and SD=8)or(OD=2 and SD=4)or(OD=1 and SD=2)
    // reverse
    motA = -.2
    Ey=Ey-5
    gosub Rot
    ge3Dto2DA Mot,View
    gosub DrawMot
  endif
  OD=SD
return    

//===================================================================
Rot:
  for i = 0 to 3
    geRotVz Mot[i,0],Mot[i,1],Mot[i,3],motA,a,b,c 
    Mot[i,0]=a
    Mot[i,1]=b
    Mot[i,3]=c
  next
return   
//===================================================================
DrawMot:
    //Ey=Ey+5
    ClearScr bkColor
    FitBMP "StepMot",286,260,200,200
    rectangle 286,260,500,295,bkColor,bkColor
    Line Mot[0,3],Mot[0,4],Mot[3,3],Mot[3,4],1,Black
    for i = 2 to 0
      LineTo Mot[i,3],Mot[i,4],1,Black
    next
    FloodFill2 400,300,IndColr
    Line 400,300,400,50,10,black
    for ti = 50 to 10 step 3
      Circle 375,ti,425,ti+10
    next
    Line 400,39,650,39
    Circle 640,39,660,59
    Line 660,49,660,Ey
    gosub DrawElevator
    flip
return
//===================================================================


DrawElevator:
  Line Ex-30,Ey,Ex+30,Ey,5,Black
  LineTo Ex+30,Ey+130,5,Black
  LineTo Ex-30,Ey+130,5,Black
  LineTo Ex-30,Ey,5,Black
  Line 700,90,700,590,10,DarkGray
  LineTo 620,590,10,DarkGray
  LineTo 620,90,10,DarkGray
  Line 620,440,700,440,10,DarkGray
  Line 620,290,700,290,10,DarkGray
  Line 620,140,700,140,10,DarkGray 
  Line 650,590,670,590,10,Blue
  SetColor Black,bkColor
  xyText 720,274,"Elevator"
  xyText 723,289,"Buttons"
  xyText 520,160," Floor"
  xyText 520,175,"Buttons"
  if Ey>445
    LimSw=1
    Line 645,584,672,584,3,Blue
    if Ey>445 then flip
  else
    LimSw=0
    Line 645,586,670,578,3,Blue
  endif
  if Ey>450 or Ey<62
    if MsgBox(Err)or True then end
  endif
return