  Cx           = 205
  Cy           = 197
  GraphColor   = 13693056 
  IsSimulation = true
  CommPortNo   = 10
//=====================================================================
//=====================================================================
MainProgram:
  gosub SetUp
  gosub Instructions
  gosub MonitorInputs
  gosub FinishUp
End
//=====================================================================
//=====================================================================
SetUp:
  AbortMethod am_Flag
  SetComm = false
  TimeScale = 15000
  T         = 0.0060 
  Kp        = 4.0
  Ki        = .011
  Kd        = 17.5
  
  J         = 0.002
  VCOF      = 0.005
  Radius    = 0.23  
  
  desiredTheta = 180
  desired      = dtor(desiredTheta)
  aTheta       = 0
  oaTheta      = -1
  W            = 0
  Alpha        = 0
  
  AccumulatedThrusts = 0
  X_offset           = 40
  Y_offset           = 395
  
  data Buttons;"&Auto Control","&Manual Control","&Instructions","&Quit"
  for i=0 to MaxDim(Buttons,1)-1
     Addbutton Buttons[i],401+i*100,1,100,25
  next

  GoSub Initialize
  Flip on
  GoSub SetUpDataFields
  GoSub GraphPaper
  GoSub DrawBase
  UpArr = "RRRaaarrrrrrqqq"
  DnArr = "ssswwwllllll"
  LineWidth 1
  DrawShape UpArr,622,200,3 \  DrawShape DnArr,622,215,3
  FloodFill 632,205,black \    FloodFill 632,220,black
  savescr 0,0,400,390
Return
//=====================================================================
Initialize:
  ddThetaZ1 =0
  ddTheta   =0
  dThetaZ1  =0
  dTheta    =0
  ThetaZ1   =0
  Theta     =0

  PID_outputZ1   =0
  PID_output     =0
  PID_errorZ1    =0
  PID_errorZ2    =0
  A0             =Kp+T*Ki/2+Kd/T
  A1             =-Kp+T*Ki/2-2*Kd/T
  A2             =Kd/T
  BurnRate       = 0

  s_time        =0
  ITAE_outputZ1 =0
  ITAE_output   =0
  ITAE_errorZ1  =0
  ITAE          =0
  
  ox = X_offset \ oy = 180-aTheta/2+Y_offset \ T_Count = 0
  oyy = 180-desiredTheta/2+Y_offset
  AccumulatedThrusts = 0
  Pause = false
  if IsSimulation
     ResponseRoutine =  "CalcResponse"
  else
     if !SetComm then setcommport CommPortNo,br115200 \ SetComm = true
     ResponseRoutine =  "CalcStationResponse"
  endif   
Return
//=====================================================================
MonitorInputs:
  repeat
     actual = dtor(aTheta)
     GoSub UpdateDisplay
     GetButton btn
     Readmouse mx,my,mb
     if btn == Buttons[0] then ControllerSubroutine = "CalcPID" \ B_Time = 150 \ GoSub StartControl
     if btn == Buttons[1] then ControllerSubroutine = "CalcFirings" \ B_Time = 120 \ GoSub StartControl
     if btn == Buttons[2] then n=MsgBox(I_M)
     if btn == Buttons[3] then break
     if AbortFlag() then break
     if mb == 1 || KeyDown(kc_UArrow) || KeyDown(kc_DArrow)
        if KeyDown(kc_UArrow) || (within(mx,622,642) && within(my,200,212)) then desiredTheta = desiredTheta+1
        if KeyDown(kc_UArrow) || (within(mx,622,642) && within(my,213,225)) then desiredTheta = desiredTheta-1
        if desiredTheta < 0 then desiredTheta = desiredTheta+360
        if desiredTheta >= 360 then desiredTheta = desiredTheta-360
        desired = dtor(desiredTheta)
        if within(mx,445,525) && within(my,50,75) //Kp
           s = StrInput(Msgs[0],Msgs[1],""+Kp)
           if IsNumber(s) then Kp = ToNumber(s) 
        elseif within(mx,560,640) && within(my,50,75) //Ki
           s = StrInput(Msgs[0],Msgs[2],""+Ki)
           if IsNumber(s) then Ki = ToNumber(s) 
        elseif within(mx,680,760) && within(my,50,75) //Kd
           s = StrInput(Msgs[0],Msgs[3],""+Kd)
           if IsNumber(s) then Kd = ToNumber(s) 
        elseif within(mx,670,750) && within(my,100,125) //VCOF
           s = StrInput(Msgs[0],Msgs[4],""+VCOF)
           if IsNumber(s) then VCOF = Limit(ToNumber(s),0.00001,100000)
        elseif within(mx,670,750) && within(my,150,175) //Radius
           s = StrInput(Msgs[0],Msgs[5],""+Radius)
           if IsNumber(s) then Radius = Limit(ToNumber(s),0.00001,5000)
        elseif within(mx,487,567) && within(my,150,175) //J
           s = StrInput(Msgs[0],Msgs[6],""+J)
           if IsNumber(s) then J = Limit(ToNumber(s),0.000001,100000)
        elseif within(mx,487,567) && within(my,100,125) //T
           s = StrInput(Msgs[0],Msgs[7],""+T)
           if IsNumber(s) then T = Limit(ToNumber(s),0.001,1)
        elseif within(mx,540,620) && within(my,200,225) //desiredTheta
           s = StrInput(Msgs[0],Msgs[8],""+desiredTheta)
           if IsNumber(s) then desiredTheta = Limit(ToNumber(s),0,359) 
           desired = dtor(desiredTheta)
        elseif within(mx,540,650) && within(my,230,255) //aTheta
           s = StrInput(Msgs[0],Msgs[9],""+aTheta)
           if IsNumber(s) then aTheta = Limit(ToNumber(s),0,359) 
        elseif within(mx,520,540) && within(my,367,390) //simulation or not
           IsSimulation = !IsSimulation
           if IsSimulation then xystring 523,369,"Y" 
           if !IsSimulation then xystring 523,369,"N" 
           delay 200
        endif
        xystring 448,52,format(Kp,fmt)
        xystring 563,52,format(Ki,fmt)
        xystring 683,52,format(Kd,fmt)
        xystring 490,102,format(T,fmt) 
        xystring 673,102,format(VCOF,fmt)
        xystring 490,152,format(J,fmt) 
        xystring 673,152,format(Radius,fmt)
        xystring 543,202,format(desiredTheta,"##0") 
        xystring 543,232,format(aTheta,aTfmt) 
     endif
  until false
Return
//=====================================================================
FinishUp:
  clearScr
  n=fildelete("tempscr.bmp")
  if !IsSimulation then gosub StopStation
Exit
//=====================================================================
StartControl:
  iactual = dtor(aTheta)
  actual  = iactual
  desired = dtor(desiredTheta)
  GoSub Initialize
  dim bN[0]
  data bN;"&Pause","Un&Pause","&Stop"
  RemoveButton Buttons[0]
  RemoveButton Buttons[1]
  AddButton bN[2],406,1,100,25
  AddButton bN[0],506,1,100,25
  ReadBmp "tempscr",X_offset-2,Y_offset-2
  A_Timer = 0 \ B_Timer = Timer()
  //if !IsSimulation then serout char(255)\delay 3000
  if !IsSimulation then serout -5000,char(13)\delay 1000
  CommsError = false
  while true
     if timer()-A_Timer < 1000*T then continue
     A_Timer = timer()
     getbutton btn
     if btn == Buttons[2] then n = MsgBox(I_M)
     if btn == Buttons[3] then GoSub FinishUp
     if btn == bN[2] || keydown(kc_Esc) then break
     if btn == bN[Pause]
        RemoveButton bN[Pause] 
        Pause = !Pause
        if Pause && !IsSimulation then GoSub StopStation
        AddButton bN[Pause],506,1,100,25        
     endif
     if Pause then continue
     readmouse mx,my,mb
     if mb==1 && within(mx,540,620) && within(my,200,225)
        if !IsSimulation then GoSub StopStation
        s = StrInput(Msgs[0],Msgs[8],""+desiredTheta)
        if IsNumber(s) then desiredTheta = Limit(ToNumber(s),0,359) \ desired = dtor(desiredTheta)
     endif
     if timer()-B_Timer >= B_Time
        readmouse mx,my,mb
        if mb==1 && within(mx,622,642) && within(my,200,212) then desiredTheta = desiredTheta+1
        if mb==1 && within(mx,622,642) && within(my,213,225) then desiredTheta = desiredTheta-1
        if keydown(kc_UArrow)
            desiredTheta = desiredTheta+1
        elseif keydown(kc_DArrow)
            desiredTheta = desiredTheta-1
        endif    
        if desiredTheta < 0 then desiredTheta = desiredTheta+360
        if desiredTheta >= 360 then desiredTheta = desiredTheta-360
        desired = dtor(desiredTheta)
        B_Timer = timer()
     endif   
     if AbortFlag() then gosub FinishUp
     GoSub CalcError
     GoSub ControllerSubroutine
     GoSub ResponseRoutine 
     if CommsError then Break
     GoSub CalcITAE
     gosub UpdateDisplay     
  wend
  RemoveButton bN[0]
  RemoveButton bN[Pause]
  for i=0 to 1
    AddButton Buttons[i],401+i*100,1,100,25
  next  
  xystring 663,352,format(0,"####0") 
  flip
  if !IsSimulation then  GoSub StopStation
Return
//=====================================================================
CalcPID:
   PID_output = A0*error+A1*PID_errorZ1+A2*PID_errorZ2+PID_outputZ1
   PID_outputZ1 = PID_output
   PID_errorZ2 = PID_errorZ1
   PID_errorZ1 = error
   BurnRate = Limit(PID_output,-5,5)
Return
//=====================================================================
CalcFirings:
  BurnRate = 0
  readmouse mx,my,mb
  if mb==1 && within(mx,622,642) && within(my,200,212) then return
  if mb==1 && within(mx,622,642) && within(my,213,225) then return
  CF_t = KeyDown(1)
  if keydown(kc_LArrow) || KeyDown(1)
      BurnRate = -5
      AccumulatedThrusts = AccumulatedThrusts-2
  elseif keydown(kc_RArrow) || KeyDown(2)
      BurnRate = 5
      AccumulatedThrusts = AccumulatedThrusts+2
  elseif keydown(kc_PUP)
      BurnRate = -2.5
      AccumulatedThrusts = AccumulatedThrusts-1
  elseif keydown(kc_PDN)
      BurnRate = 2.5
      AccumulatedThrusts = AccumulatedThrusts+1
  endif    
  xystring 663,352,format(AccumulatedThrusts,"####0") 
Return
//=====================================================================
CalcError:
   error = desired -actual
   if abs(error) > Pi() then error = error - sign(error)*Pi(2)
Return
//=====================================================================
CalcResponse:
   //----Calc Theta, dTheta (W), ddTheta (Alpha)
   Torque = BurnRate*VCOF*Radius
   ddThetaZ1 = ddTheta
   dThetaZ1 = dTheta
   ThetaZ1 = Theta
   ddTheta = Torque/J
   dTheta = dThetaZ1+T/2*(ddTheta+ddThetaZ1)
   Theta = ThetaZ1+T/2*(dTheta+dThetaZ1)
   Alpha = ddTheta
   W = dTheta
   actual = frac((iactual+Theta)/Pi(2))*Pi(2)
   if actual < 0 then actual = actual+Pi(2)
   aTheta = round(rtod(actual))
Return     
//=====================================================================
CalcStationResponse:
   if BurnRate < 0
      CS_Speed =-500+BurnRate/5.0*500
   elseif BurnRate > 0
      CS_Speed =450+BurnRate/5.0*550
   else
      CS_Speed = 0
   Endif
   serout round(CS_Speed),char(13)
   serbytesin 4,CS_dAngle,CS_NoIn
   if CS_NoIn < 4 
      n=ErrMsg(Msgs[10],Msgs[0],MB_OK|MB_ERROR)
      GoSub StopStation
      CommsError = true
      return
   endif
   CS_dAngle = BuffReadI(CS_dAngle,0)
   ddThetaZ1 = ddTheta
   dThetaZ1 = dTheta
   ThetaZ1 = Theta
   Theta = CS_dAngle*dtor(2.5)
   dTheta = (Theta-ThetaZ1)/T
   ddTheta = (dTheta-dThetaZ1)/T
   Alpha = ddTheta
   W = dTheta
   actual = frac(Theta/Pi(2))*Pi(2)
   if actual < 0 then actual = actual +pi(2)
   aTheta = round(rtod(actual))
Return     
//=====================================================================
StopStation:
   'serout char(0)
   serout 0,char(13)
   delay 50
   clearserbuffer
Return
//=====================================================================
CalcITAE:
   s_time = s_time+T
   ITAE_error = abs(error)*s_time
   ITAE = ITAE_outputZ1+T/2*(ITAE_error+ITAE_errorZ1)
   ITAE_errorZ1 = ITAE_error
   ITAE_outputZ1 = ITAE
Return          
//=====================================================================
UpdateDisplay:
   restorescr
   //---draw desired indicator
   dx = 156*cos(desired-pi(0.5)) \ dy = 156*sin(desired-pi(0.5))
   line Cx+dx,Cy+dy,Cx+dx*1.03,Cy+dy*1.03,4,red
   gosub DrawStation
   xystring 543,202,format(desiredTheta,"##0") 
   xystring 543,232,format(rtod(actual),aTfmt) 
   xystring 543,262,format(W,wafmt) 
   xystring 543,292,format(Alpha,wafmt) 
   xystring 543,322,format(ITAE,wafmt) 
   xystring 11,23,format(BurnRate,"0.0000000") 
   GoSub PlotPoint
   flip
Return
//=====================================================================
PlotPoint:
   x = ((s_time*1000)#TimeScale)/20+X_offset
   if x < ox
      ox = X_offset
      T_Count = T_Count+15
      readbmp "tempscr",X_offset-2,Y_offset-2
      xytext 340,587,"+"+T_Count+"secs","",8,fs_bold
      flip
   endif   
   y = 180-aTheta/2+Y_offset
   line ox,oy,x,y,2,blue
   oy = y
   y = 180-desiredTheta/2+Y_offset
   line ox,oyy,x,y,2,red
   ox = x \ oyy = y
Return
//=====================================================================
DrawStation:
   for i= 0 to 2
     tt = actual+i*pi(2)/3-pi(0.5)
     ttt = tt-dtor(10)
     dx = 149*cos(ttt) \ dy = 149*sin(ttt)
     line Cx,Cy,Cx+dx,Cy+dy,1,blue
     ttt = tt+dtor(10)
     dx = 149*cos(ttt) \ dy = 149*sin(ttt)
     line Cx,Cy,Cx+dx,Cy+dy,1,blue
     dx = 110*cos(tt) \ dy = 110*sin(tt)
     floodfill Cx+dx,Cy+dy,blue
   next
   dx = 147*cos(actual-pi(0.5)) \ dy = 147*sin(actual-pi(0.5))
   line Cx+dx*0.9,Cy+dy*0.9,Cx+dx,Cy+dy,4,red
Return
//=====================================================================
DrawBase:
  LineWidth 3
  circle 54,46,356,348,black,blue
  circle Cx-140,Cy-140,Cx+140,Cy+140,blue,white
  circle Cx-30,Cy-30,Cx+30,Cy+30,blue,blue
  circle Cx-10,Cy-10,Cx+10,Cy+10,blue,white
  LineWidth 2
  for i=0 to 359 step 10
     DB_R = 157 \ DB_p = false
     if !(i#30) then DB_R = 165 \ DB_p = true
     if !(i#90) then DB_R = 177
     dx1 = DB_R*cos(dtor(i-90)) \ dy1 = DB_R*sin(dtor(i-90))
     dx2 = 151*cos(dtor(i-90)) \ dy2 = 151*sin(dtor(i-90))
     line Cx+dx2,Cy+dy2,Cx+dx1,Cy+dy1
     if i == 0  then ddx = -5 \ ddy = -7
     if within(i,1,90) then ddx = 2 \ ddy = -7
     if within(i,91,179)  then ddx = 2 \ ddy = 1
     if within(i,180,270) then ddx = -15 \ ddy = -1
     if within(i,270,360) then ddx = -25 \ ddy = -7
     if DB_p then xytext Cx+dx1+ddx,Cy+dy1+ddy,tostring(i),"",-1,fs_bold
  next
Return
//=====================================================================
GraphPaper:
  ERectangle X_offset,Y_offset,750+X_offset,180+Y_offset,3,GraphColor
  s = "Theta"
  for i=1 to length(s)
    xytext 3,Y_offset+i*25,substring(s,i,1),"",9,fs_Bold 
  next   
  for i=0 to 180 step 30
    xytext 15,Y_offset+180-10-i,tostring(i*2),"",9
  next
  for i=5 to 180 step 5
    lw = 1
    if !(i#30) then lw = 2
    line X_offset,Y_offset+i,X_offset+750,Y_offset+i,lw,GraphColor
  next
  for i=5 to  745 step 5
    lw = 1
    if !(i#25) then lw = 2
    line X_offset+i,Y_offset,X_offset+i,Y_offset+180,lw,GraphColor
  next
  xytext 250,587,"Time (secs)","",8,fs_bold
  for i=0 to  750 step 50
    xytext X_offset+i-5,577,tostring(i/50),"",8
  next
  writebmp "tempscr",X_offset-2,Y_offset-2,754+X_offset,184+Y_offset
Return
//=====================================================================
SetUpDataFields:
   xyText 421,55,"Kp"+spaces(11)+"Ki"+spaces(11)+"Kd","",-1,fs_Bold
   xyText 421,105,"T secs"+spaces(11)+"  VCOF m/s"+spaces(13),"",-1,fs_Bold
   xyText 421,155,"J Kgm^2"+spaces(12)+"Radius m","",-1,fs_Bold
   xyText 421,205,"Desired Theta"+spaces(12)+"degrees","",-1,fs_Bold
   xyText 421,235,"Actual Theta"+spaces(14)+"degrees","",-1,fs_Bold
   xyText 421,265,"Omega rad/s                    Velocity","",-1,fs_Bold
   xyText 421,295,"Alpha rad/s/s                  Accel.","",-1,fs_Bold
   xyText 421,323,"ITAE Index","",-1,fs_Bold
   xyText 421,352,"Accumulated Manual Firings","",-1,fs_Bold
   xyText 8,3,"Firing Kg/s","",-1,fs_Bold
   xyText 421,370,"Simulation","",-1,fs_Bold

   fmt   = "##0.0000"
   aTfmt = "##0.000000"
   wafmt = "0.00000000e+00 "

   rectangle 445,50,525,75   \  xystring 448,52,format(Kp,fmt)
   rectangle 560,50,640,75   \  xystring 563,52,format(Ki,fmt)
   rectangle 680,50,760,75   \  xystring 683,52,format(Kd,fmt)
   rectangle 487,100,567,125 \  xystring 490,102,format(T,fmt) 
   rectangle 670,100,750,125 \  xystring 673,102,format(VCOF,fmt)
   rectangle 487,150,567,175 \  xystring 490,152,format(J,fmt) 
   rectangle 670,150,750,175 \  xystring 673,152,format(Radius,fmt)
 
   rectangle 540,200,620,225 \  xystring 543,202,format(desiredTheta,"##0") 
   rectangle 540,230,650,255 \  xystring 543,232,format(aTheta,aTfmt) 
   rectangle 540,260,690,285 \  xystring 543,262,format(W,wafmt) 
   rectangle 540,290,690,315 \  xystring 543,292,format(Alpha,wafmt) 
   rectangle 540,320,680,345 \  xystring 543,322,format(ITAE,wafmt) 
   rectangle 660,350,720,375 \  xystring 663,352,format(AccumulatedThrusts,"####0") 
   rectangle 8,20,103,45     \  xystring 11,23,format(BurnRate,"0.0000000") 
   rectangle 520,367,540,390 \  xystring 523,369,"Y" 
   flip
Return
//=====================================================================
Instructions:
  data Msgs;"SpaceStation.Bas"
  data Msgs;"Enter the PID Proportional Factor:"
  data Msgs;"Enter the PID Integral Factor:"
  data Msgs;"Enter the PID Differential Factor:"
  data Msgs;"Enter the Velocity Coefficient (> 0 m/s):"
  data Msgs;"Enter the Station Radius ( > 0 m):"
  data Msgs;"Enter the Moment Of Inertia J (> 0 Kgm^2):"
  data Msgs;"Enter the Sampling Period (0.001 to 1.0 seconds):"
  data Msgs;"Enter Desired Heading (0 to 359 degrees):"
  data Msgs;"Enter Current Heading (0 to 359 degrees):"
  data Msgs;"Could not communicate with the space station"
  data I_M;Msgs[0]+"...Instructions..."
  data I_M;"This program simulates a space station control scenario.",""
  data I_M;"The objective is to command the station to a desired heading. There"
  data I_M;"are two ways you can achieve this: Manually or Automatically.",""
  data I_M;"In the auto mode the computer will fire the rockets to move the station"
  data I_M;"in a smooth and efficient manner using feed back control methods to "
  data I_M;"determine when, for how long, in what direction and at what rate to fire"
  data I_M;"the rockets so as to achieve the desired response. During the auto control"
  data I_M;"you can click on the Desired Theta field to change the desired heading."
  data I_M;"Also you can change the desired heading using Up and Down Arrows or by"
  data I_M;"clicking on the scroll arrows next to the field.",""
  data I_M;"In the manual mode you will need to fire the rockets yourself to achieve"
  data I_M;"the control (if you can). You fire the rockets using the Left or right arrows"
  data I_M;"or the left and right mouse buttons. These will give a full strength firing"
  data I_M;"on the rockets for as long as you have the button down. The rocket will stop"
  data I_M;"firing once the button is released. You can have half strength firings using"
  data I_M;"the PageUp and PageDn buttons. The accumulated firings field will show how"
  data I_M;"much firing you have done. When this field is zero the station will have no"
  data I_M;"rotational speed. The field can help you in controlling the station by "
  data I_M;"reminding you how much acceleration you have given it in what direction."
  data I_M;"You can change the desired heading the same as during the auto control.",""
  data I_M;"The physical properties of the station can only be changed while not"
  data I_M;"controlling the station. Click on the field to change it.",""
  data I_M;"The factors that affect the feed back control mechanism (PID controller),"
  data I_M;"can also be changed only when not under control. Click on the field.",""
  data I_M;"On the top left corner the Firing field shows the amount of rocket firing"
  data I_M;"that is currently happening.",""
  data I_M;"The ITAE shows a number that reflects the history of accumulated errors"
  data I_M;"during the control process. This number gives a measure of how good the"
  data I_M;"control has been. The lower the number the more efficient the control has"
  data I_M;"been. Using this number and the graph will help in deciding on the Kp, Ki"
  data I_M;"and Kd factors while fine tuning the process. Also if you do manual control"
  data I_M;"you can see how badly you have done in comparison to the auto-control.",""
  data I_M;"The Graph shows the current heading (blue) and the desired heading (red)."
  data I_M;"The Time scale shows the time (0 to 15 secs) in addition to the time shown"
  data I_M;"below the time axis as already elapsed. The vertical axis is the heading in"
  data I_M;"degrees. To stop the graph from clearing, stop or pause the control process"
  data I_M;"before 15 secs pass.",""
  data I_M;"The Y/N box allows you to specify if the program is working as a simulated"
  data I_M;"mathematical model of the space station, or is controlling a Real Physical"
  data I_M;"space station that you will have to have built. If the filed is N then the"
  data I_M;"program will switch to communication with a microprocessor on the physical"
  data I_M;"station that will receive a byte indicating the desired direction and firing"
  data I_M;"rate of the fans to move the station. The processor will also have to send "
  data I_M;"back a two byte number indicating the number of incrmenets the wheel has"
  data I_M;"since the start of control. These two bytes will be combined into a number"
  data I_M;"that will be used to calculate the current station heading i.e. Actual Theta."
  data I_M;"This will then be used to calculate the error and instead of using a simulated"
  data I_M;"mathematical model the physical system will be the source of Actual Therta.",""
  data I_M;"When in the non-simulator mode the parameters VCOF, J, Radius will not be"
  data I_M;"used since these are parametrs for the simultaion mathematical model of the"
  data I_M;"station.",""
  data I_M;"You can do exactly the same actions using the real station as during the"
  data I_M;"control of the simulated station. You can have it automatically or manually"
  data I_M;"controlled. Also you can command heading changes in the same way.",""
  data I_M;"The program will communicate to the microprocessor via a real or virtual"
  data I_M;"serial port, via direct serial line or using a Bluetooth protocol.",""
  data I_M;"The serial port number is specified at the top of the program."
  //n=MsgBox(I_M)
Return
//=====================================================================
