MainProgram:
   GoSub Initialization
   If AllOk
     xyText 10,20,"Temperature =","Time new roman",15,fs_Bold
     while true
        if !Fahrenheit
           S = Format(Tc,"##0.00C")
        else
           S = Format(Tf,"##0.00F")
        endif
        xyText 170,20,S+spaces(10),"Times new roman",15,fs_Bold
        S = "Temperature = "+S+spaces(10)
        GoSub Write_LCD
     wend   
   endif  
end
//================================================
Initialization:
  DeviceNum = 0      //use device 0
  Thermo_Pin = 4     //use pin A4 for input from the DS1820 
  LED_Pin = 5 \ LED_On = 1 \  PB_Pin = 6 
  Fahrenheit = false \ AllOk = false
  Tc = 25 \ Tf = 77
  if usbm_DllSpecs() == "" then  print "The USBmicro DLL is not installed" \ return
  if !usbm_FindDevices() then print "There are no Devices" \ return
  if usbm_DeviceValid(DeviceNum)
    n= usbm_initports(DeviceNum)
    n= usbm_DirectionA(DeviceNum,255-2^PB_Pin,255) //all output but PB_Pin is set as
    n= usbm_SetBit(DeviceNum,PB_Pin)          //input with internal pull-up resistor
    n= usbm_DirectionB(DeviceNum,255,255)     
    GoSub Init_LCD
    addtimer "t1",150 \ onTimer tHandler
    AllOk = true
  else
    print "Device is invalidated"         
  endif  
Return
//================================================
tHandler:
  lt = LastTimer()
  n = usbm_WriteABit(DeviceNum,255-2^LED_Pin,2^LED_Pin*LED_On) 
  LED_On = !LED_On   
  GoSub Check_PushButton
  GoSub Read_ThermoData
  onTimer tHandler
Return
//================================================
Check_PushButton:
  if !usbm_DeviceValid(DeviceNum) then return
  n = usbm_ReadA(DeviceNum) & (2^PB_Pin)
  if !n then Fahrenheit = !Fahrenheit  //active low Push button so we act on 0
Return
//=========================================================
Read_ThermoData:
  if !usbm_DeviceValid(DeviceNum) then Tc = -40 \ Tf = -40 \return
  n = usbm_reset1wire(DeviceNum,Thermo_Pin)
  n = usbm_write1wire(DeviceNum,0xCC) \ n = usbm_write1wire(DeviceNum,0x44)
  n = usbm_reset1wire(DeviceNum,Thermo_Pin)
  n = usbm_write1wire(DeviceNum,0xCC) \ n = usbm_write1wire(DeviceNum,0xBE)
  n = usbm_read1wire(DeviceNum) \ m = usbm_read1wire(DeviceNum)
  x = 0 \ if(m & 0x80) then x = 0xFFFFF000
  Tc = (x | ( ( (m & 0x0F)<< 8 )+ n) )*0.0625
  Tf = Tc*1.8+32
Return
//=========================================================
Init_LCD:
  if !usbm_DeviceValid(DeviceNum) then return
  n = usbm_InitLCD(DeviceNum, 0x12, 0x13)   //---RW=A1,RS=A2,E=A3,Data=Port B     
  n = usbm_SetBit(DeviceNum,0)  \ delay 20  //---RES connected to A0
  n = usbm_ResetBit(DeviceNum,0)\ delay 100 //High-Low-High to reset with 100 ms pulse
  n = usbm_SetBit(DeviceNum, 0) \ delay 100 //give the LCD time to settle
  n = usbm_LCDCmd(DeviceNum, 0x1C)  //---command sequence to setup the LCD
  n = usbm_LCDCmd(DeviceNum, 0x14)  //---this is obtainable from the device
  n = usbm_LCDCmd(DeviceNum, 0x28)  //---specs sheet
  n = usbm_LCDCmd(DeviceNum, 0x4F)  //
  n = usbm_LCDCmd(DeviceNum, 0xE0)  //
  n = usbm_LCDCmd(DeviceNum, 0x1)   //--clear the LCD display
Return
//=========================================================
Write_LCD: //S is the string to write
  if !usbm_DeviceValid(DeviceNum) then return
  n = usbm_LCDCmd( DeviceNum, 0x2) //code 0x2 to Go to 1st char position
  if Length(S) == 0 then Return
  for i = 1 To Length(S)    
    n=usbm_LCDData(DeviceNum,GetStrByte(S,i))//send the ascii code of each character
  next
Return
//=========================================================
