MainProgram:
  GoSub Initialization
  while true
     GoSub Read_ADC
     xyText 200,100,Format(V1,"0.00V"),"",15
     xyText 200,120,Format(V2,"0.00V"),"",15
  wend   
end
//================================================
Initialization:
  DeviceNum = 0    //use device 0
  SS_Pin = 4   //use pin A4 as Slave Select
  if usbm_DllSpecs()=="" then Print "The USBmicro DLL is not installed" \ End
  if !usbm_FindDevices() then print "There are no Devices" \ End
  if !usbm_DeviceValid(DeviceNum) then print "Device is invalidated" \ End
  n = usbm_InitPorts(DeviceNum)
  n=usbm_DirectionA(DeviceNum,2^SS_Pin,2^SS_Pin)  //set SS_Pin to output
  n = usbm_InitSPI(DeviceNum,0%00011011) // 01=master,10=SPI mode3,11=62500 bits/sec
  n = usbm_SetBit(DeviceNum,SS_Pin)  //disable the slave SS=high initially
  setcolor white,black
  xyText 100,70," LTC1298 ","",15,fs_Bold
  xyText 50,100,"Channel[0]:","",15,fs_Bold
  xyText 50,120,"Channel[1]:","",15,fs_Bold
  setcolor black,white
  onAbort AbortHandler
Return
//================================================
AbortHandler:
  n = usbm_InitSPI(DeviceNum,0x00)  //trun SPI off
Terminate
//================================================
Read_ADC:
   V1 = 0 \ V2 = 0
   if !usbm_DeviceValid(DeviceNum) then return
   //-----read channel 0
   n = usbm_ResetBit(DeviceNum,SS_Pin)
   m = usbm_SpiMaster(DeviceNum,toByte(1)+toByte(0x80)) //codes for channel 0 and MSB first
   n = usbm_SetBit(DeviceNum,SS_Pin)
   v = ((getstrbyte(m,2)&0x0F)<<8)+getstrbyte(m,3)
   V1 = 5.0*v/0xFFF 
   //-----read channel 1
   n = usbm_ResetBit(DeviceNum,SS_Pin)  
   m = usbm_SpiMaster(DeviceNum,toByte(1)+toByte(0xC0)) //codes for channel 1 and MSB first
   n = usbm_SetBit(DeviceNum,SS_Pin)
   v = ((getstrbyte(m,2)&0x0F) << 8)+getstrbyte(m,3)
   V2 = 5.0*v/0xFFF 
Return
//================================================
