ManinProgram:
  GoSub Initialization
  if AllOk
     while true
       vn=usbm_ReadA(DeviceNum)
       xytext 90,60,bin(vn&0x0F,4),"",20,fs_Bold
       xytext 420,60,bin(vn >> 4,4),"",20,fs_Bold
     wend
  endif
End
//==============================================================
Initialization:
   DeviceNum = 0 \ AllOk = false
   if usbm_DllSpecs() == "" then print "The USBm.Dll is not installed" \return
   if !usbm_FindDevices() then print "There are no U4x1 devices" \return
   Dim S[3]
   S[1] = toByte(1)+toByte(0)+toByte(0)+toByte(0)+toByte(3)+toByte(255)+toByte(0)
   S[2] = BuffWrite(S[1],0,2)
   if usbm_DeviceValid(DeviceNum)
      n = usbm_DirectionA(DeviceNum,255,255)  //SetPort A to output
      AllOk = true
      for i=1 to 2
         n    = usbm_Stepper(DeviceNum,S[i])           //Initialize motor
         S[i] = BuffWriteB(S[i],1,1)                   //
         n    = usbm_Stepper(DeviceNum,S[i])           //turn it on but no steps
         AddCheckbox "ON"+i,50+330*(i-1),105,"",1
         Addbutton   "Initialize"+i,100+330*(i-1),100,70
         Addbutton   "Step"+i,225+330*(i-1),320,70
         AddRBGroup  "Direction"+i,50+330*(i-1),140,150,40,2,"Right"+crlf()+"Left"
         AddRBGroup  "Type"+i,50+330*(i-1),190,240,40,3,"Half Step"+crlf()+"Full Step"+crlf()+"Wave"
         SetRBGroup  "Direction"+i,1 \ SetRBGroup "Type"+i,1
         AddSlider   "Speed"+i,50+330*(i-1),240,240,0,255
         AddEdit     "Speed"+i,295+330*(i-1),245,60,0,0 \ ReadOnlyEdit "Speed"+i
         AddCheckBox "Continuous"+i,55+330*(i-1),295,"",0
         AddEdit     "Steps"+i,230+330*(i-1),290,60,0,"1" \ IntegerEdit "Steps"+i 
         xyText      150+330*(i-1),295,"Steps (0-255):","Times new roman",10,fs_Bold
      next
      AddTimer "t1" \ SetTimer "t1",off \ AddTimer "t2" \ SetTimer "t2",off
      onCheckBox cbHandler \ onSlider slHandler
      OnEdit edHandler \ onRBGroup rbgHandler
      onButton bHandler \ onTimer tHandler
   endif   
Return
//==============================================================
Stepper:
  n = usbm_Stepper(DeviceNum,S)  //do the steps
Return
//==============================================================
tHandler:
   lt = LastTimer()
   ltn = Right(lt,1)
   RenameButton "Stop"+ltn,"Step"+ltn
   SetTimer lt,off
   onTimer tHandler
Return
//==============================================================
bHandler:
   lb = LastButton()
   lbn = tonumber(Right(lb,1))
   if left(lb,10) == "Initialize"
      S[lbn] = BuffWriteB(S[lbn],1,0) \ S[lbn] = BuffWriteB(S[lbn],6,0)
      n = usbm_Stepper(DeviceNum,S[lbn])           //Initialize motor
      S[lbn] = BuffWriteB(S[lbn],1,1)              //
      n = usbm_Stepper(DeviceNum,S[lbn])           //turn it on but no steps
   elseif left(lb,4) == "Step"
      Steps = ToNumber(GetEdit("Steps"+lbn),0)
      Rate  = 255-GetSliderPos("Speed"+lbn)
      S[lbn] = BuffWriteB(S[lbn],6,Steps)
      S = S[lbn] \ GoSub Stepper
      RenameButton "Step"+lbn,"Stop"+lbn
      SetTimerPeriod "t"+lbn,128*Rate*Steps/1000
      SetTimer "t"+lbn,on
   elseif left(lb,4) == "Stop"
      SS = S[lbn]
      S[lbn] = BuffWriteB(S[lbn],1,0) \ S = S[lbn] \ GoSub Stepper
      S[lbn] = SS \  SetTimer "t"+lbn,off
      RenameButton "Stop"+lbn,"Step"+lbn
   endif   
   onButton bHandler
Return
//==============================================================
rbgHandler:
   lrbg = LastRBGroup()
   lrbn = tonumber(Right(lrbg,1))
   if left(lrbg,9) == "Direction"
      Direction = GetRBGroup(lrbg)-1
      S[lrbn] = BuffWriteB(S[lrbn],2,Direction)
      S = S[lrbn] \ GoSub Stepper
   elseif left(lrbg,4) == "Type"
      movetype = GetRBGroup(lrbg)-1
      if movetype = 0 then Type = 0 \ Initial = 3
      if movetype = 1 then Type = 1 \ Initial = 3
      if movetype = 2 then Type = 1 \ Initial = 1
      SetCheckBox "Continuous"+lrbn,0  //if continuous turn it off
      S[lrbn] = BuffWriteB(S[lrbn],1,0) \ S[lrbn] = BuffWriteB(S[lrbn],3,Type) 
      S[lrbn] = BuffWriteB(S[lrbn],4,Initial) \ S[lrbn] = BuffWriteB(S[lrbn],6,0)
      n = usbm_Stepper(DeviceNum,S[lrbn])           //turn motor off and Initialize it
      S[lrbn] = BuffWriteB(S[lrbn],1,1)                  //
      n = usbm_Stepper(DeviceNum,S[lrbn])           //turn back on
   endif
   onRBGroup rbgHandler
Return
//==============================================================
edHandler:
   led = LastEdit()
   if left(led,5) == "Steps"
      Steps = Limit(ToNumber(GetEdit(led),0),0,254)
      SetEdit led,Steps \ edn =EditChanged(led)
   endif
   onEdit edHandler
Return
//==============================================================
cbHandler:
   lcb = LastCheckBox()
   lcbn = tonumber(right(lcb,1))
   if left(lcb,10) == "Continuous"
      cbn = GetCheckBox(lcb)
      EnableEdit "Steps"+lcbn,!cbn \ EnableButton "Step"+lcbn,!cbn
      S[lcbn] = BuffWriteB(S[lcbn],6,255 * cbn)      
      S = S[lcbn] \ GoSub Stepper
   elseif left(lcb,2) == "ON"
      S[lcbn] = BuffWriteB(S[lcbn],1,GetCheckBox(lcb))      
      S = S[lcbn] \ GoSub Stepper
   endif
   onCheckBox cbHandler
Return
//==============================================================
slHandler:
   lsl = LastSlider()
   Rate = 255-GetSliderPos(lsl)
   SetEdit lsl,GetSliderPos(lsl)
   lsn = tonumber(Right(lsl,1))
   S[lsn] = BuffWriteB(S[lsn],5,Rate)
   if GetCheckBox("Continuous"+lsn) then S = S[lsn] \ GoSub Stepper
   onSlider slHandler
Return
//==============================================================
