MainProgram:
  GoSub Initialization
  if AllOk
     while true
       GoSub Read_ThermoData
       xyText 200,130,Format(Tc,"##0.00C = ")+Format(Tf,"0.00F")+spaces(10),"",15,fs_Bold
       n=usbm_ReadA(DeviceNum)
       xytext 205,155,bin(n&0x0F,4),"",20,fs_Bold
       x = ""+(255-Rate)
       if Direction == 0 && Rate < 255 then x = x+" Right"
       if Direction == 1 && Rate < 255 then x = x+" Left"
       SetEDit "Status",udp_Status("u1")
       xytext 205,190,JustifyL(x," ",12),"",15,fs_Bold
       if GetCheckBox("Allow Sending")
          US = 0 \ BuffPrintB US,Tc,n
          x = udp_Send("u1",US,GetEDit("rmtIP"),ToNumber(GetEdit("rmtPort"),0))
       endif   
     wend   
  endif  
end
//================================================
Initialization:
  AllOk = false
  DeviceNum = 0    //use device 0
  Thermo_Pin = 15   //use pin B7 for input from the DS1820 
  Direction = 0 \ Rate = 255 \ Steps = 255
  lclPort = 46000 
  if usbm_DllSpecs() == "" then print "The USBmicro DLL is not installed" \return
  if !usbm_FindDevices() then print "There are no Devices" \ return
  S = toByte(1)+toByte(0)+toByte(Direction)+toByte(0)+toByte(3)+toByte(Rate)+toByte(0)
  if !usbm_DeviceValid(DeviceNum) then Return
  n = usbm_DirectionA(DeviceNum,0xF,0xF)  //SetPort A0-A3 as output
  n = usbm_Stepper(DeviceNum,S)           //Initialize motor
  S = BuffWriteB(S,1,1)                   //
  n = usbm_Stepper(DeviceNum,S)           //turn it on but no stepping
  AllOk = true
  x = udp_start("u1",lclPort)
  xyText 50,50,"Local IP    = "+TCP_LocalIP(),"Times new roman",14,fs_Bold
  xyText 50,70,"Local Port = "+lclPort,"Times new roman",14,fs_Bold
  xyText 500,50,"Remote IP    = ","Times new roman",14,fs_Bold
  xyText 500,80,"Remote Port = ","Times new roman",14,fs_Bold
  xyText 550,150,"Socket Status","Times new roman",14,fs_Bold
  AddEdit "rmtIP",630,50,100,0,tcp_LocalIP()
  AddEdit "rmtPort",630,80,60,0,47000 \ IntegerEdit "rmtPort"
  AddEdit "Status",500,180,250
  AddCheckBox "Allow Sending",530,110
  xyText 200,5,"Reader Program","Times new roman",20,fs_Bold|fs_Underlined
  xyText 10,130,"Temperature    =","",15,fs_Bold
  xyText 10,160,"Stepping State =","",15,fs_Bold
  xyText 10,190,"Stepping Rate  =","",15,fs_Bold
  onUDP udpHandler
Return
//================================================
Read_ThermoData:
  if !usbm_DeviceValid(DeviceNum) then Tc = -40 \ Tf = -40 \return
  n = usbm_reset1wire(DeviceNum,Thermo_Pin)
  n =usbm_write1wire(DeviceNum,0xCC) \ n =usbm_write1wire(DeviceNum,0x44)
  n =usbm_reset1wire(DeviceNum,Thermo_Pin)
  n =usbm_write1wire(DeviceNum,0xCC) \ n =usbm_write1wire(DeviceNum,0xBE)
  n =usbm_read1wire(DeviceNum) \ m = usbm_read1wire(DeviceNum)
  x = 0 \ if(m & 0x80) then x = 0xFFFFF000
  Tc = (x |(((m & 0x0F)<< 8)+n))*0.0625
  Tf = Tc*1.8+32
Return
//=========================================================
Stepper:
  S = BuffWriteB(S,5,Rate) \ S = BuffWriteB(S,2,Direction) 
  S = BuffWrite(S,6,Steps)
  n = usbm_Stepper(DeviceNum,S)  //do the steps
Return
//==============================================================
udpHandler:
   if udp_BuffCount("u1") >= 4
      m = BuffReadI(udp_Read("u1"),0)
      Steps = 255 \ Direction = 0
      if m < 0 then Direction = 1
      if !m then Steps = 0
      Rate = 255-abs(m)
      GoSub Stepper
   endif
   onUDP udpHandler
Return
//==============================================================
